#if !defined(AFX_ACQUISITION_H__92C16BF4_379E_4CCB_9F2B_98FBC3FBA581__INCLUDED_)
#define AFX_ACQUISITION_H__92C16BF4_379E_4CCB_9F2B_98FBC3FBA581__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "fli.h"
#include "image.h"
#include "resource.h"

#import "apogee.dll" no_namespace

// Acquisition.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CAquisitionParams window

class CAcquisitionParams : public CObject
{
// Construction
public:
	CAcquisitionParams();
	DECLARE_DYNCREATE(CAcquisitionParams);
public:
	CAcquisitionParams &operator=( CAcquisitionParams & );  // Right side is the argument.
// Attributes
public:
	int		CellExposure;
	BOOL	CellImageLaserOff;
	long	CellBinning;
	long	CycleTime;
	long	Height;
	long	LaserBinning;
	long	LaserExposure;
	BOOL	SeparateLaserImage;
	long	Width;
	long	XOrigin;
	long	YOrigin;
	unsigned int StoreCycle;
	BOOL	CellImage8Bit;
	BOOL	LaserImage8Bit;
	int		CellPixelShift;
	int		LaserPixelShift;
	BOOL	m_LightDefault;
	CPoint Calibration;  //in nm per Pixel	
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAcquisitionParams)
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:	
	long ShutterDelay;
	long CellContrastLevel;
	long LaserContrastLevel;
	BOOL CellAutoContrast;
	BOOL LaserAutoContrast;

	virtual ~CAcquisitionParams();

};

/////////////////////////////////////////////////////////////////////////////
// CAcquisitionDlg dialog

class CAcquisitionDlg : public CDialog
{
// Construction
public:
	CAcquisitionDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CAcquisitionDlg)
	enum { IDD = IDD_ACQUISITIONDLG };
	int		m_nCellExposure;
	BOOL	m_nCellImageLaserOff;
	long	m_nCellBinning;
	long	m_nCycleTime;
	long	m_nHeight;
	long	m_nLaserBinning;
	long	m_nLaserExposure;
	BOOL	m_nSeparateLaserImage;
	long	m_nWidth;
	long	m_nXOrigin;
	long	m_nYOrigin;
	long	m_CalibrationX;
	long	m_CalibrationY;
	UINT	m_StoreCycle;
	BOOL	m_CellImage8Bit;
	BOOL	m_LaserImage8Bit;
	int		m_CellPixelShift;
	int		m_LaserPixelShift;
	BOOL	m_CellAutoContrast;
	BOOL	m_LaserAutoContrast;
	long	m_CellContrastLevel;
	long	m_LaserContrastLevel;
	long	m_ShutterDelay;
	BOOL	m_LightDefault;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAcquisitionDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CAcquisitionDlg)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CAcquisition window

class CNeuronApp;
class CDataPointDoc;
class CMicroscope;

class CAcquisition : public CObject
{
// Construction
public:
	CAcquisition(CNeuronApp *aparent, CMicroscope *aMicroscope);

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAcquisition)
	//}}AFX_VIRTUAL

// Implementation
public:
	void InitialUpdate(bool aHardwareAccess);
	bool ForceTestPicture;
	bool HardwareAccess;
	ICameraPtr cam;
	CTime OldAcquisitionTime;
	CString TestPictureName;
	CString IniFileName;
	CMicroscope* Microscope;
	void SerializeParams(CArchive &ar);
	void OnIdle();
	void Play();
	bool IsPlaying();
	void ConfigDlg();
	virtual ~CAcquisition();
	void SetTestPictureName(CString aTestPictureName);
	CString GetTestPictureName() {return TestPictureName;};
	void SetIniFileName(CString aIniFileName);
	CString GetIniFileName() {return IniFileName;};
	CString FakeRunDir;

	// Generated message map functions
protected:
	int FakeRunNr;
	//{{AFX_MSG(CAcquisition)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
private:
	CAcquisitionParams Param;
	CTime NextAcquisitionTime;
	bool Playing;
	bool ParametersChanged;
	CAcquisitionDlg* AcquisitionDlg;
	CNeuronApp* parent;
	void CloseCamera();
	void InitCamera(CString IniFileName);	
	CDataPointDoc* DataPoint;
	int CameraExists;
	flidev_t device;
	long ul_x, ul_y, lr_x, lr_y;
	
};

/////////////////////////////////////////////////////////////////////////////


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ACQUISITION_H__92C16BF4_379E_4CCB_9F2B_98FBC3FBA581__INCLUDED_)
