// BeamGuidingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Neuron.h"
#include "BeamGuidingDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBeamGuidingDlg dialog


CBeamGuidingDlg::CBeamGuidingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBeamGuidingDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBeamGuidingDlg)
	m_HopTime = 0;
	m_LaserCellOverlap = 0;
	m_OffVoltageDAC0 = 0.0f;
	m_OffVoltageDAC2 = 0.0f;
	m_SamplingFrequency = 0;
	m_SinusSweep = FALSE;
	m_WobbleXFrequency = 0;
	m_WobbleYFrequency = 0;
	m_ScanSpeed = 0;
	m_AntiHysteresis = FALSE;
	m_DAC0Amplitude = 0;
	m_DAC1Amplitude = 0;
	m_DAC2Amplitude = 0;
	m_DAC3Amplitude = 0;
	m_DAC0Frequency = 0;
	m_DAC1Frequency = 0;
	m_DAC2Frequency = 0;
	m_DAC3Frequency = 0;
	m_AntiHysteresisAfterHop = FALSE;
	m_DAC0AmplitudeAfterHop = 0;
	m_DAC1AmplitudeAfterHop = 0;
	m_DAC2AmplitudeAfterHop = 0;
	m_DAC3AmplitudeAfterHop = 0;
	m_DAC0FrequencyAfterHop = 0;
	m_DAC1FrequencyAfterHop = 0;
	m_DAC2FrequencyAfterHop = 0;
	m_DAC3FrequencyAfterHop = 0;
	m_AntiHysteresisDecayTime = 0;
	m_AntiHysteresisHopToCenter = FALSE;
	m_AntiHysteresisHopAlsoForOneStop = FALSE;
	m_AntiHysteresisHopRestingTime = 0;
	m_FixPointVoltageDAC0 = 0.0f;
	m_FixPointVoltageDAC1 = 0.0f;
	m_FixPointVoltageDAC2 = 0.0f;
	m_FixPointVoltageDAC3 = 0.0f;
	//}}AFX_DATA_INIT
}


void CBeamGuidingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBeamGuidingDlg)
	DDX_Text(pDX, IDC_HOPTIME, m_HopTime);
	DDV_MinMaxLong(pDX, m_HopTime, 0, 10000);
	DDX_Text(pDX, IDC_LASERCELLOVERLAP, m_LaserCellOverlap);
	DDV_MinMaxLong(pDX, m_LaserCellOverlap, 0, 100000);
	DDX_Text(pDX, IDC_OFFVOLTAGEDAC0, m_OffVoltageDAC0);
	DDV_MinMaxFloat(pDX, m_OffVoltageDAC0, -10.f, 10.f);
	DDX_Text(pDX, IDC_OFFVOLTAGEDAC2, m_OffVoltageDAC2);
	DDV_MinMaxFloat(pDX, m_OffVoltageDAC2, -10.f, 10.f);
	DDX_Text(pDX, IDC_SAMPLINGFREQUENCY, m_SamplingFrequency);
	DDV_MinMaxLong(pDX, m_SamplingFrequency, 1000, 1000000);
	DDX_Check(pDX, IDC_SINUSSWEEP, m_SinusSweep);
	DDX_Text(pDX, IDC_WOBBLEXFREQUENCY, m_WobbleXFrequency);
	DDV_MinMaxLong(pDX, m_WobbleXFrequency, 1, 1000);
	DDX_Text(pDX, IDC_WOBBLEYFREQUENCY, m_WobbleYFrequency);
	DDV_MinMaxLong(pDX, m_WobbleYFrequency, 1, 1000);
	DDX_Text(pDX, IDC_SCANSPEED, m_ScanSpeed);
	DDV_MinMaxLong(pDX, m_ScanSpeed, 0, 1000000);
	DDX_Check(pDX, IDC_ANTIHYSTERESIS, m_AntiHysteresis);
	DDX_Text(pDX, IDC_DAC0AMPLITUDE, m_DAC0Amplitude);
	DDV_MinMaxInt(pDX, m_DAC0Amplitude, 0, 100);
	DDX_Text(pDX, IDC_DAC1AMPLITUDE, m_DAC1Amplitude);
	DDV_MinMaxInt(pDX, m_DAC1Amplitude, 0, 100);
	DDX_Text(pDX, IDC_DAC2AMPLITUDE, m_DAC2Amplitude);
	DDV_MinMaxInt(pDX, m_DAC2Amplitude, 0, 100);
	DDX_Text(pDX, IDC_DAC3AMPLITUDE, m_DAC3Amplitude);
	DDV_MinMaxInt(pDX, m_DAC3Amplitude, 0, 100);
	DDX_Text(pDX, IDC_DAC0FREQUENCY, m_DAC0Frequency);
	DDV_MinMaxInt(pDX, m_DAC0Frequency, 0, 10000);
	DDX_Text(pDX, IDC_DAC1FREQUENCY, m_DAC1Frequency);
	DDV_MinMaxInt(pDX, m_DAC1Frequency, 0, 10000);
	DDX_Text(pDX, IDC_DAC2FREQUENCY, m_DAC2Frequency);
	DDV_MinMaxInt(pDX, m_DAC2Frequency, 0, 10000);
	DDX_Text(pDX, IDC_DAC3FREQUENCY, m_DAC3Frequency);
	DDV_MinMaxInt(pDX, m_DAC3Frequency, 0, 10000);
	DDX_Check(pDX, IDC_ANTIHYSTERESISAFTERHOP, m_AntiHysteresisAfterHop);
	DDX_Text(pDX, IDC_DAC0AMPLITUDE2, m_DAC0AmplitudeAfterHop);
	DDV_MinMaxInt(pDX, m_DAC0AmplitudeAfterHop, 0, 1000);
	DDX_Text(pDX, IDC_DAC1AMPLITUDE2, m_DAC1AmplitudeAfterHop);
	DDV_MinMaxInt(pDX, m_DAC1AmplitudeAfterHop, 0, 100);
	DDX_Text(pDX, IDC_DAC2AMPLITUDE2, m_DAC2AmplitudeAfterHop);
	DDV_MinMaxInt(pDX, m_DAC2AmplitudeAfterHop, 0, 100);
	DDX_Text(pDX, IDC_DAC3AMPLITUDE2, m_DAC3AmplitudeAfterHop);
	DDV_MinMaxInt(pDX, m_DAC3AmplitudeAfterHop, 0, 100);
	DDX_Text(pDX, IDC_DAC0FREQUENCY2, m_DAC0FrequencyAfterHop);
	DDV_MinMaxInt(pDX, m_DAC0FrequencyAfterHop, 0, 10000);
	DDX_Text(pDX, IDC_DAC1FREQUENCY2, m_DAC1FrequencyAfterHop);
	DDV_MinMaxInt(pDX, m_DAC1FrequencyAfterHop, 0, 10000);
	DDX_Text(pDX, IDC_DAC2FREQUENCY2, m_DAC2FrequencyAfterHop);
	DDV_MinMaxInt(pDX, m_DAC2FrequencyAfterHop, 0, 10000);
	DDX_Text(pDX, IDC_DAC3FREQUENCY2, m_DAC3FrequencyAfterHop);
	DDV_MinMaxInt(pDX, m_DAC3FrequencyAfterHop, 0, 10000);
	DDX_Text(pDX, IDC_DECAYTIME, m_AntiHysteresisDecayTime);
	DDV_MinMaxInt(pDX, m_AntiHysteresisDecayTime, 0, 1000);
	DDX_Check(pDX, IDC_ANTIHYSTERESISHOPTOCENTER, m_AntiHysteresisHopToCenter);
	DDX_Check(pDX, IDC_ANTIHYSTERESISHOPTOCENTERADIABATIC, m_AntiHysteresisHopAlsoForOneStop);
	DDX_Text(pDX, IDC_RESTINGTIME, m_AntiHysteresisHopRestingTime);
	DDV_MinMaxInt(pDX, m_AntiHysteresisHopRestingTime, 0, 1000);
	DDX_Text(pDX, IDC_FIXPOINTDAC0VOLTAGE, m_FixPointVoltageDAC0);
	DDV_MinMaxFloat(pDX, m_FixPointVoltageDAC0, -10.f, 10.f);
	DDX_Text(pDX, IDC_FIXPOINTDAC1VOLTAGE, m_FixPointVoltageDAC1);
	DDV_MinMaxFloat(pDX, m_FixPointVoltageDAC1, -10.f, 10.f);
	DDX_Text(pDX, IDC_FIXPOINTDAC2VOLTAGE, m_FixPointVoltageDAC2);
	DDV_MinMaxFloat(pDX, m_FixPointVoltageDAC2, -10.f, 10.f);
	DDX_Text(pDX, IDC_FIXPOINTDAC3VOLTAGE, m_FixPointVoltageDAC3);
	DDV_MinMaxFloat(pDX, m_FixPointVoltageDAC3, -10.f, 10.f);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBeamGuidingDlg, CDialog)
	//{{AFX_MSG_MAP(CBeamGuidingDlg)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBeamGuidingDlg message handlers
