// DataPointDoc.h : interface of the CDataPointDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DATAPOINTDOC_H__3C063052_FA9E_42E2_9E93_DD5387FB3585__INCLUDED_)
#define AFX_DATAPOINTDOC_H__3C063052_FA9E_42E2_9E93_DD5387FB3585__INCLUDED_

#include "Image.h"	// Added by ClassView
#include "Acquisition.h"	// Added by ClassView
#include "Beam.h"	
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CUnifiedBitmap;
class CRunDoc;

class CDataPointDoc : public CDocument
{
public:
	void SaveDetectionImage();
	CDataPointDoc(CAcquisitionParams &aParam);
 // create from serialization only
	CDataPointDoc();
	InitParams();
	DECLARE_SERIAL(CDataPointDoc)


// Attributes

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDataPointDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	void GetDocSize(long &width, long &height);
	CAcquisitionParams Param;
	CImage* LaserImage;
	CImage* CellImage;
	CTime ImageLookupTime;
	bool CellImageStored,LaserImageStored,ConeDetectionImageStored;
	virtual ~CDataPointDoc();
	virtual void OnChangedViewList( ) {};
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
public:
	//{{AFX_MSG(CDataPointDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:	
	CRect m_DetectionRegion;
	void CalcDetectionImage();
	CRect m_ContrastRegion;
	void OptimizeContrast();
	CString GetDirectory();
	void CompressImages();
	unsigned short CellImageFormat,LaserImageFormat,ConeDetectionImageFormat;
	void AddMessage(CString aMessage);
	CString Message;
	void ChangeComment();
	int PreviewBinning;
	void AddSpline(CPoint point);
	void CalcPreview(int aPreviewBinning);
	CImage* Preview;
	CString UpdateTitle();
	CString GetTimeStamp();
	CTimeSpan RelativeTime;
	CString Comment;
	CTime time;
	void DeleteImages();
	bool ImagesSaved;
	void SaveImages(CString Directory);
	CImage* LookupWithLoadCellImage(bool DoNotConvert=false);
	CImage* LookupWithLoadLaserImage();
	CImage* LookupWithLoadConeDetectionImage();	
	void Save(CString aDirectory,bool SaveImages);
	bool Load(CString aDirectory, WORD aMyNumber);
	WORD ReferenceImageNumber;
	CImage* ConeDetectionImage;	
	WORD MyNumber;
	CRunDoc* RunDocParent;
	void AddNewLaserFocus(CPoint Start, CPoint Direction);
	void DeleteLaserFocus(CBeamStop* BeamStop);
	bool Active;
	void ConvertCoordRealToPixel(CPoint &point);
	void ConvertCoordPixelToReal(CPoint &point);
	void ConvertCoordRealToPixel(double& point);
	void ConvertCoordPixelToReal(double &point);
	void CalcUnifiedBitmap(CDC* pDC,CUnifiedBitmap *&UnifiedBitmap,
								 bool aCellImage, COLORREF CellColor,
								 bool aLaserImage, COLORREF LaserColor,
								 bool aCompareImage, COLORREF CompareColor,
								 bool aConeDetectionImage, bool InverseConeDetectionImage, COLORREF ConeColor,unsigned char CellPixelShift,
								 bool ForceRecalculateUnifiedBitmap=false);	
	CImage* CalcUnifiedBitmap(	 CRect region,
								 bool aCellImage, COLORREF CellColor,
								 bool aLaserImage, COLORREF LaserColor,
								 bool aCompareImage, COLORREF CompareColor,
								 bool aConeDetectionImage, 
								 bool InverseConeDetectionImage, COLORREF ConeColor,
								 unsigned char CellPixelShift);	
	void CalcPreviewWinBitmap(CBitmap* WinBMP,unsigned short CellImagePixelShift,unsigned short Zoom);
	CBeamStop* FindNearestBeamStop(CPoint point,int &subPoint);
	void Move(CPoint MoveStartPoint,CPoint point,CBeamStop*& MovedStop, int &MovedSubPoint);
	void SaveAsBMPParam(CRect Selection,bool m_CellImage,bool m_LaserImage,bool m_DetectionImage);
	CBeamPath* BeamPath;
	unsigned short CellContrastMin,CellContrastMax,LaserContrastMin,LaserContrastMax;
private:	
	CString Directory;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DATAPOINTDOC_H__3C063052_FA9E_42E2_9E93_DD5387FB3585__INCLUDED_)
