// DataPointView.cpp : implementation of the CDataPointView class
//

#include "stdafx.h"
#include "Neuron.h"
#include "ChildFrm.h"
#include "DataPointDoc.h"
#include "DataPointView.h"
#include "UnifiedBitmap.h"
#include "hint.h"
#include "MainFrm.h"
#include "DataPointViewDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDataPointView

IMPLEMENT_DYNCREATE(CDataPointView, CScrollView)

BEGIN_MESSAGE_MAP(CDataPointView, CScrollView)
	//{{AFX_MSG_MAP(CDataPointView)
	ON_COMMAND(ID_AUTOCONTRAST_REGION, OnContrastRegion)
		ON_COMMAND(ID_DATAPOINT_WINDOW_NEW, OnDatapointWindowNew)
		ON_COMMAND(ID_ADDSPLINE, OnAddSpline)
		ON_COMMAND(ID_ZOOM_IN, OnZoomIn)
		ON_COMMAND(ID_ZOOM_OUT, OnZoomOut)
		ON_COMMAND(ID_NEW_LASER_FOCUS, OnNewLaserFocus)
		ON_COMMAND(ID_ADD_COMMENT, OnAddComment)
		ON_COMMAND(ID_DELETE_LASER_FOCUS, OnDeleteLaserFocus)
		ON_COMMAND(ID_LASER_ON, OnLaserOn)		
		ON_COMMAND(ID_MOVE_LASER_FOCUS, OnMoveLaserFocus)
		ON_COMMAND(ID_LASER_PROPERTIES, OnLaserProperties)
		ON_COMMAND(ID_LASER_PATH_VISIBLE, OnLaserPathVisible)
		ON_COMMAND(ID_LASER_IMAGE_VISIBLE, OnLaserImageVisible)
		ON_COMMAND(ID_CELL_IMAGE_VISIBLE, OnCellImageVisible)
		ON_COMMAND(ID__REALIZEDPATH, OnRealizedPathVisible)
		ON_COMMAND(ID_DELETESPLINE, OnDeleteSpline)
		ON_COMMAND(ID_SELECT_REGION, OnSelectRegion)
		ON_COMMAND(ID_COMPARE_IMAGE_VISIBLE, OnCompareImageVisible)
		ON_COMMAND(ID_CONEDETECTION_IMAGE_VISIBLE, OnConeDetectionImageVisible)
		ON_COMMAND(ID_MARK_VIEW_POSITION, OnMarkViewPosition)
		ON_UPDATE_COMMAND_UI(ID_LASER_PATH_VISIBLE, OnUpdateLaserPathVisible)
		ON_UPDATE_COMMAND_UI(ID_LASER_IMAGE_VISIBLE, OnUpdateLaserImageVisible)
		ON_UPDATE_COMMAND_UI(ID_CELL_IMAGE_VISIBLE, OnUpdateCellImageVisible)
		ON_UPDATE_COMMAND_UI(ID__REALIZEDPATH, OnUpdateRealizedPathVisible)
		ON_UPDATE_COMMAND_UI(ID_COMPARE_IMAGE_VISIBLE, OnUpdateCompareImageVisible)
		ON_UPDATE_COMMAND_UI(ID_CONEDETECTION_IMAGE_VISIBLE, OnUpdateConeDetectionImageVisible)
		ON_UPDATE_COMMAND_UI(ID_MARK_VIEW_POSITION, OnUpdateMarkViewPosition)
		ON_UPDATE_COMMAND_UI(ID_NEW_LASER_FOCUS, OnUpdateLaserFocus)
		ON_UPDATE_COMMAND_UI(ID_LASER_ON, OnUpdateLaserOn)
		ON_UPDATE_COMMAND_UI(ID_LASER_PROPERTIES, OnUpdateLaserProperties)
		ON_UPDATE_COMMAND_UI(ID_ZOOM_OUT, OnUpdateZoomOut)
		ON_UPDATE_COMMAND_UI(ID_ZOOM_IN, OnUpdateZoomIn) 
		ON_WM_LBUTTONDOWN()
		ON_WM_LBUTTONUP()
		ON_WM_MOUSEMOVE()
		ON_WM_CONTEXTMENU()
		ON_WM_CANCELMODE()
		ON_WM_LBUTTONDBLCLK()
		ON_WM_ERASEBKGND()
		ON_WM_HSCROLL()
		ON_WM_VSCROLL()
		ON_WM_MOVE()
		ON_UPDATE_COMMAND_UI(ID_ADDSPLINE, OnUpdateAddSpline) 
		ON_UPDATE_COMMAND_UI(ID_DELETESPLINE, OnUpdateDeleteSpline) 
	ON_COMMAND(ID_SAVE_AS_BMP, OnSaveAsBmp)
	ON_UPDATE_COMMAND_UI(ID_SAVE_AS_BMP, OnUpdateSaveAsBmp)
	ON_COMMAND(ID_RULER, OnUseRuler)
	ON_WM_CREATE()
	ON_COMMAND(ID_CONTRAST, OnOptimizeContrast)
	ON_COMMAND(ID_CALC_DETECTION_IMAGE, OnCalcDetectionImage)
		ON_COMMAND(ID_DATAVIEW_DLG, OnDataPointViewDlg)
		ON_UPDATE_COMMAND_UI(ID_MOVE_LASER_FOCUS, OnUpdateLaserFocus)
		ON_UPDATE_COMMAND_UI(ID_DELETE_LASER_FOCUS, OnUpdateLaserFocus)		
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDataPointView construction/destruction

CDataPointView::CDataPointView()
{
	RealizedPathVisible=false;
	ZoomLevel=0;//2;	
	LButtonDownMode=-1;
	LButtonUpMode=-1;
	LaserPathVisible=true;
	LaserImageVisible=true;
	CellImageVisible=true;
	CompareImageVisible=false;
	ConeDetectionImageVisible=true;
	MarkViewPosition=true;
	UnifiedBitmap=NULL;
	NewLaserFocusCursor1=AfxGetApp()->LoadCursor(IDC_NEWLASERFOCUSCURSOR1);
	MovedStop=NULL;
	MovedSubPoint=-1;
	IsPreview=false;
	CellPixelShift=0;
	TopMost=false;
	ForceRecalculateUnifiedBitmap=false;
}

CDataPointView::~CDataPointView()
{
	if (UnifiedBitmap) {
		if (UnifiedBitmap->Bitmap) {
			delete UnifiedBitmap->Bitmap;
			UnifiedBitmap->Bitmap=NULL;
		}
		delete UnifiedBitmap;
	}
	UnifiedBitmap=NULL;	
}

BOOL CDataPointView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDataPointView drawing

void CDataPointView::OnDraw(CDC* pDC)
{
	CDataPointDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CRect rectClip;	
	
	CRect selection;
	if (pDoc->RunDocParent)
		selection = pDoc->RunDocParent->Selection;
	//if (!IsPreview && !selection.IsRectEmpty())
	//	rectClip = selection;
	//else
	{
		pDC->GetClipBox(&rectClip);
		rectClip.InflateRect(2,2);
	}
	double Zoom=GetZoomFactor();	
	if (IsPreview) {	
		if ((pDoc->CellImageStored) || (pDoc->Preview)) {							
			if (pDoc->Preview==NULL) {
				if (pDoc->CellImage==NULL) pDoc->LookupWithLoadCellImage();
				pDoc->CalcPreview(((CNeuronApp*)AfxGetApp( ))->PreviewBinning);
			}
			if (pDoc->Preview!=NULL) {
				CDC dcMem;		
				dcMem.CreateCompatibleDC(pDC);
				CBitmap* PreviewWinBitmap= new CBitmap();				
				if (Zoom<1) Zoom=1;
				unsigned short hZoom=Zoom;
				PreviewWinBitmap->CreateCompatibleBitmap(pDC, pDoc->Preview->Width*hZoom,pDoc->Preview->Height*hZoom);
				ASSERT(PreviewWinBitmap->m_hObject != NULL);
				CBitmap* pbmOld = dcMem.SelectObject(PreviewWinBitmap);						
				pDoc->CalcPreviewWinBitmap(PreviewWinBitmap,CellPixelShift,hZoom);
				pDC->StretchBlt(rectClip.left, rectClip.top, rectClip.Width(),rectClip.Height(), &dcMem, rectClip.left, rectClip.top, rectClip.Width(),rectClip.Height(),SRCCOPY);				
				dcMem.SelectObject(pbmOld);
				dcMem.DeleteDC();
				delete PreviewWinBitmap;
			}
		
		} else {
			CBrush br( RGB(255,255,255));
			pDC->FillRect( rectClip, &br );
		}	
	} else {		
		int NrVisible=0;
		bool CellVis=(((pDoc->CellImageStored) || (pDoc->CellImage))&& (CellImageVisible));
		bool LaserVis=(((pDoc->LaserImageStored) || (pDoc->LaserImage))&& (LaserImageVisible));
		bool DetectVis=(((pDoc->ConeDetectionImageStored) || (pDoc->ConeDetectionImage))&& ConeDetectionImageVisible);		
		if (CellVis) NrVisible++;
		if (LaserVis) NrVisible++;
		if (DetectVis) NrVisible++;
		if (CompareImageVisible) NrVisible++;
		COLORREF CellCol,LaserCol,DetectCol,CompCol;
		bool InverseConeDetectionImage=false;
		if (NrVisible==1) {
			CellCol=RGB(255,255,255);
			LaserCol=RGB(255,255,255);
			CompCol=RGB(255,255,255);
			DetectCol=RGB(255,255,255);
		} else {
			CellCol=RGB(128+64,128+64,128+64);
			LaserCol=RGB(128,0,0);
			CompCol=RGB(0,128,0);
//			DetectCol=RGB(128+64,128+64,255);
			DetectCol=RGB(128+32,128+32,255);
		}
/*		if ((NrVisible==2) && (CellVis) && (DetectVis)) {
			CellCol=RGB(255,255,255);
			LaserCol=RGB(128,0,0);
			CompCol=RGB(0,128,0);
			DetectCol=RGB(128+64,128+64,255);
		}*/
		if (CompareImageVisible) {
			InverseConeDetectionImage=true;
			LaserVis=false;
			CellCol=RGB(128+32,128+32,128+32);
			LaserCol=RGB(0,0,0);
			CompCol=RGB(0,63+32,0);
			DetectCol=RGB(128+32,128+127,128+32);							
		}		
		if (CellVis || LaserVis || CompareImageVisible || DetectVis) {		
			pDoc->CalcUnifiedBitmap(pDC,UnifiedBitmap,CellImageVisible,CellCol,
											LaserImageVisible,LaserCol,
											CompareImageVisible,CompCol,
											ConeDetectionImageVisible,
											InverseConeDetectionImage,
											DetectCol,
											CellPixelShift,ForceRecalculateUnifiedBitmap);
			ForceRecalculateUnifiedBitmap=false;
			if (UnifiedBitmap) {				
				CDC dcMem;				
				dcMem.CreateCompatibleDC(pDC);
				CBitmap* pbmOld = dcMem.SelectObject(UnifiedBitmap->Bitmap);
				/*
				CRect selection = pDoc->RunDocParent->Selection;
				if (!selection.IsRectEmpty())
				{
					pDC->StretchBlt(rectClip.left, rectClip.top, rectClip.Width(),rectClip.Height(), &dcMem, 
						selection.left/Zoom, selection.top/Zoom, selection.Width()/Zoom,selection.Height()/Zoom,SRCCOPY);								
				}
				else
				*/
				{
					pDC->StretchBlt(rectClip.left, rectClip.top, rectClip.Width(),rectClip.Height(), &dcMem, 
						rectClip.left/Zoom, rectClip.top/Zoom, rectClip.Width()/Zoom,rectClip.Height()/Zoom,SRCCOPY);				
				}
				dcMem.SelectObject(pbmOld);
				dcMem.DeleteDC();
			} else {
				CBrush br( RGB(128,128,128));
				pDC->FillRect( rectClip, &br );
			}
		} else {
			CBrush br( RGB(255,255,255));
			pDC->FillRect( rectClip, &br );
		}
	}
	if ((RealizedPathVisible) && (pDoc->RunDocParent!=NULL)) {
		CDataPointMap *map=pDoc->RunDocParent->DataPointMap;
		if (map) {
			POSITION pos=map->CMapWordToOb::GetStartPosition();
			WORD key;				
			CDataPointDoc *doc=NULL;
			while (pos!=NULL) {
				map->GetNextAssoc(pos,key,doc);		
				if (doc && doc->BeamPath && doc->BeamPath->BeamOn && doc!=pDoc) {
					doc->BeamPath->Draw(pDC,pDoc,this,1);
				}
			}

		}		
	}
	if ((pDoc->BeamPath) && (LaserPathVisible)) pDoc->BeamPath->Draw(pDC,pDoc,this,0);	

	if (pDoc->CellImage) {	
		CPen penStroke;
		penStroke.CreatePen(PS_SOLID, 1, RGB(128,128,128));		
		CPen* pOldPen = pDC->SelectObject(&penStroke);
		pDC->MoveTo(pDoc->CellImage->Width*Zoom+1,0);
		pDC->LineTo(pDoc->CellImage->Width*Zoom+1,pDoc->CellImage->Height*Zoom+1);
		pDC->LineTo(0,pDoc->CellImage->Height*Zoom+1);	
		pDC->SelectObject(pOldPen);
	}
	
	if (MarkViewPosition) {
		CPen penStroke;
		penStroke.CreatePen(PS_SOLID, 1, RGB(0,255,0));		
		CPen* pOldPen = pDC->SelectObject(&penStroke);
		POSITION pos = pDoc->GetFirstViewPosition();
		while (pos != NULL)
		{
			CDataPointView* pView = (CDataPointView*)pDoc->GetNextView(pos);
			if ((pView!=this) && (!pView->IsPreview)) {
				CClientDC dc(pView);
				OnPrepareDC(&dc);				
				CRect rectClip;	
				dc.SelectClipRgn(NULL);
				dc.GetClipBox(&rectClip);
				CPoint ul=pView->GetScrollPosition(); 				
				CPoint lr(rectClip.right+ul.x, rectClip.bottom+ul.y);
				pView->ConvertCoordsViewToDoc(ul);
				ConvertCoordsDocToView(ul);
				pView->ConvertCoordsViewToDoc(lr);
				ConvertCoordsDocToView(lr);
				rectClip.left=ul.x;
				rectClip.top=ul.y;
				rectClip.right=lr.x;
				rectClip.bottom=lr.y;
				pDC->MoveTo(rectClip.left, rectClip.top);
				pDC->LineTo(rectClip.left, rectClip.bottom);
				pDC->LineTo(rectClip.right, rectClip.bottom);
				pDC->LineTo(rectClip.right, rectClip.top);
				pDC->LineTo(rectClip.left, rectClip.top);						
			}
		}   		
		pDC->SelectObject(pOldPen);
	}
/*
//	if ((pDoc->RunDocParent) && (!TempSelection.m_rect.IsRectEmpty())) { 
	if (!TempSelection.IsRectNull()) { 
		
		CPen penStroke;
		COLORREF color;
		if (LButtonUpMode == 3 || LButtonUpMode == 2) //select region/autocontrast 
			color = RGB(0,0,255);
		else if (LButtonUpMode == 4)
			color = RGB(0,255,255);
		penStroke.CreatePen(PS_SOLID, 1, color);		
		CPen* pOldPen = pDC->SelectObject(&penStroke);
		//CPoint ul(pDoc->RunDocParent->Selection.left,pDoc->RunDocParent->Selection.top);
		//CPoint lr(pDoc->RunDocParent->Selection.right,pDoc->RunDocParent->Selection.bottom);
		//ConvertCoordsDocToView(ul);
		//ConvertCoordsDocToView(lr);
		//CRect rectClip(ul.x,ul.y,lr.x,lr.y);
		CRect rectClip = TempSelection;
		rectClip.NormalizeRect();
		pDC->MoveTo(rectClip.left, rectClip.top);
		pDC->LineTo(rectClip.left, rectClip.bottom);
		pDC->LineTo(rectClip.right, rectClip.bottom);
		pDC->LineTo(rectClip.right, rectClip.top);
		pDC->LineTo(rectClip.left, rectClip.top);						
		pDC->SelectObject(pOldPen);
		
		//TempSelection.Draw(pDC);
	}
*/
	CRect rect = TempSelection;
	rect.NormalizeRect();
	pDC->FrameRect(rect,&CBrush(RGB(0,0,255)));

	CPoint ul(pDoc->m_DetectionRegion.TopLeft());
	CPoint lr(pDoc->m_DetectionRegion.BottomRight());
	ConvertCoordsDocToView(ul);
	ConvertCoordsDocToView(lr);
	pDC->FrameRect(CRect(ul,lr), &CBrush(RGB(255,0,0)));

	if (Ruler_start != Ruler_end)
	{
		CPen thickpen;
		thickpen.CreatePen(PS_SOLID, 3, RGB(0,255,255) );
		CPen* pOldPen = pDC->SelectObject(&thickpen);
		pDC->MoveTo(Ruler_start);
		pDC->LineTo(Ruler_end);
		pDC->SelectObject(pOldPen);
	}
}

void CDataPointView::OnUpdate(CView* /* pSender */, LPARAM /* lHint */,
	CObject* pHint)
{
	CDataPointDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	//SetTopMost();
	pDoc->RunDocParent->UpdateAllViews(NULL);
	double Zoom=GetZoomFactor();
	if (IsPreview && pDoc->Preview) {		
			if (Zoom<1) Zoom=1;
			unsigned short hZoom=Zoom;			
			SetScrollSizes( MM_TEXT, CSize(pDoc->Preview->Width*hZoom,pDoc->Preview->Height*hZoom) );			
	} else {			
		long width,height;
		CSize size;
		//CRect selection = pDoc->RunDocParent->Selection;
		//if (!selection.IsRectEmpty())
		//	size = CSize(selection.Width(), selection.Height());
		//else
		pDoc->GetDocSize(width,height);
		size=CSize::CSize(Zoom*width,Zoom*height);
		SetScrollSizes(MM_TEXT, size);		
	}
	ResizeParentToFit(true);  	
	// The document has informed this view that some data has changed.
	if (pHint)
	{
		if (pHint->IsKindOf(RUNTIME_CLASS(CHint))) {
			CHint* Hint = (CHint*)pHint;
			switch (Hint->Hint) {
				case 2: { 
					if (!MarkViewPosition) return;
					break;
				}		
				case 3: {
					if (!IsPreview) return;
					break;
				}
				case 4: {
					ForceRecalculateUnifiedBitmap=true;
					break;
				}
			}
		}
		/*if (pHint->IsKindOf(RUNTIME_CLASS(CDataPointObject)))
		{			
			CDataPointObject* pBeamStop = (CDataPointObject*)pHint;
			CClientDC dc(this);
			OnPrepareDC(&dc);
			CRect rectInvalid = pBeamStop->GetBoundingRect();
			CPoint br=rectInvalid.BottomRight();
			CPoint tl=rectInvalid.TopLeft();
			pDoc->ConvertCoordRealToPixel(br);
			ConvertCoordsDocToView(br);
			pDoc->ConvertCoordRealToPixel(tl);
			ConvertCoordsDocToView(tl);
			rectInvalid.SetRect(tl.x,tl.y,br.x,br.y);
			//dc.LPtoDP(&rectInvalid);
			InvalidateRect(&rectInvalid);
			return;
		}*/
	}
	// We can't interpret the hint, so assume that anything might
	// have been updated.
	Invalidate(TRUE);
	return;
}

BOOL CDataPointView::OnEraseBkgnd( CDC* pDC )
{
    CBrush br( RGB(0,0,0));   //GetSysColor( COLOR_WINDOW ) ); 
    FillOutsideRect( pDC, &br );
    return TRUE;                   // Erased
}

void CDataPointView::ConvertCoordsDeviceToLogical(CPoint &point)
{
	CClientDC dc(this);
	// CScrollView changes the viewport origin and mapping mode.
	// It's necessary to convert the point from device coordinates
	// to logical coordinates, such as are stored in the document.
	OnPrepareDC(&dc);  // set up mapping mode and viewport origin
	dc.DPtoLP(&point);
}

void CDataPointView::ConvertCoordsLogicalToDevice(CPoint &point)
{
	CClientDC dc(this);
	// CScrollView changes the viewport origin and mapping mode.
	// It's necessary to convert the point from device coordinates
	// to logical coordinates, such as are stored in the document.
	OnPrepareDC(&dc);  // set up mapping mode and viewport origin
	dc.LPtoDP(&point);
}


void CDataPointView::ConvertCoordsDocToView(CPoint &point)
{
	double Zoom=GetZoomFactor();	
	point.x=Zoom*point.x;
	point.y=Zoom*point.y;
}

void CDataPointView::ConvertCoordsViewToDoc(CPoint &point)
{
	double Zoom=1/GetZoomFactor();	
	point.x=Zoom*point.x;
	point.y=Zoom*point.y;
}

/////////////////////////////////////////////////////////////////////////////
// CDataPointView printing

BOOL CDataPointView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDataPointView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDataPointView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDataPointView diagnostics

#ifdef _DEBUG
void CDataPointView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CDataPointView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CDataPointDoc* CDataPointView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDataPointDoc)));
	return (CDataPointDoc*)m_pDocument;
}
#endif //_DEBUG

void CDataPointView::OnInitialUpdate()
{	
	if (IsPreview) {		
		CSize sizeTotal;		
		sizeTotal.cx = sizeTotal.cy = 100;
		SetScrollSizes(MM_TEXT, sizeTotal);
		ResizeParentToFit(false);
	} 
	else {
		long width,height;
		GetDocument()->GetDocSize(width,height);
		double Zoom=GetZoomFactor();	
		CSize size=CSize::CSize(Zoom*width,Zoom*height);
		SetScrollSizes(MM_TEXT, size);
		CScrollView::OnInitialUpdate();
		ResizeParentToFit();
	}
	CDataPointDoc* pDoc = GetDocument();	
	ASSERT_VALID(pDoc);
	pDoc->UpdateTitle();
}


/////////////////////////////////////////////////////////////////////////////
// CDataPointView message handlers

void CDataPointView::UpdateMarks()
{
	CDataPointDoc* pDoc = GetDocument();	
	ASSERT_VALID(pDoc);
	CHint *hint=new CHint(2,CRect());
	pDoc->UpdateAllViews(this, 0L, hint);
	delete hint;	
}


void CDataPointView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	UpdateMarks();
	CScrollView::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CDataPointView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	UpdateMarks();
	CScrollView::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CDataPointView::OnMove(int x, int y ) 
{
//	UpdateMarks();
}

void CDataPointView::OnDatapointWindowNew() 
{
	CMultiDocTemplate* DataPointDocTemplate = new CMultiDocTemplate(
		IDR_DATAPOINT_TYPE,
		RUNTIME_CLASS(CDataPointDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CDataPointView));
	CDataPointDoc* Doc=GetDocument();
	CFrameWnd* NewFrame=DataPointDocTemplate->CreateNewFrame(Doc,NULL);	
	DataPointDocTemplate->InitialUpdateFrame( NewFrame, Doc);	
}

void CDataPointView::OnAddSpline() 
{
	CDataPointDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
//	if (pDoc->Active) {
		LButtonDownMode=6;
		//SetCursor(NewLaserFocusCursor1);
//	} else AfxMessageBox("Datapoint is no longer the last recorded");
}

void CDataPointView::OnZoomIn() 
{
	if (ZoomLevel > -7) {
		ZoomLevel--;
		OnInitialUpdate();
		UpdateMarks();
		UpdateView();
	}
}

void CDataPointView::OnZoomOut() 
{
	if (ZoomLevel<7) {
		ZoomLevel++;
		OnInitialUpdate();		
		UpdateMarks();
		UpdateView();	
	}
}

void CDataPointView::OnNewLaserFocus() 
{
	CDataPointDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	LButtonDownMode=1;		
	SetCursor(NewLaserFocusCursor1);
}

void CDataPointView::OnAddComment() 
{
	CDataPointDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->ChangeComment();
}

void CDataPointView::OnUpdateLaserFocus(CCmdUI* pCmdUI) 
{
	CDataPointDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);	
	pCmdUI->Enable(true);// pDoc->Active);	
}

void CDataPointView::OnUpdateAddSpline(CCmdUI* pCmdUI) 
{
	CDataPointDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);	
	pCmdUI->Enable(true);// pDoc->Active);	
}

void CDataPointView::OnUpdateDeleteSpline(CCmdUI* pCmdUI) 
{
	CDataPointDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);	
	pCmdUI->Enable(true);// pDoc->Active);	
}

void CDataPointView::OnLaserPathVisible() 
{
	LaserPathVisible=!LaserPathVisible;
	Invalidate(TRUE);
}

void CDataPointView::OnLaserImageVisible() 
{
	LaserImageVisible=!LaserImageVisible;
	Invalidate(TRUE);
}

void CDataPointView::OnCellImageVisible() 
{
	CellImageVisible=!CellImageVisible;
	Invalidate(TRUE);
}

void CDataPointView::OnRealizedPathVisible() 
{
	RealizedPathVisible=!RealizedPathVisible;
	Invalidate(TRUE);
}

void CDataPointView::OnCompareImageVisible() 
{
	CompareImageVisible=!CompareImageVisible;
	Invalidate(TRUE);
}

void CDataPointView::OnConeDetectionImageVisible() 
{
	ConeDetectionImageVisible=!ConeDetectionImageVisible;
	Invalidate(TRUE);
}

void CDataPointView::OnMarkViewPosition() 
{
	MarkViewPosition=!MarkViewPosition;
	Invalidate(TRUE);
}

void CDataPointView::OnUpdateLaserPathVisible(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(LaserPathVisible);
	pCmdUI->Enable(true);		
}

void CDataPointView::OnUpdateLaserImageVisible(CCmdUI* pCmdUI) 
{	
	pCmdUI->Enable(true);	
	pCmdUI->SetCheck(LaserImageVisible);
}

void CDataPointView::OnUpdateCellImageVisible(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(CellImageVisible);
	pCmdUI->Enable(true);	
}

void CDataPointView::OnUpdateRealizedPathVisible(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(RealizedPathVisible);
	pCmdUI->Enable(true);	
}

void CDataPointView::OnUpdateCompareImageVisible(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(CompareImageVisible);
	pCmdUI->Enable(true);	
}

void CDataPointView::OnUpdateConeDetectionImageVisible(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(ConeDetectionImageVisible);
	pCmdUI->Enable(true);	
}

void CDataPointView::OnUpdateMarkViewPosition(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(MarkViewPosition);
	pCmdUI->Enable(true);	
}

void CDataPointView::OnUpdateLaserProperties(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( true);	
}

void CDataPointView::OnLaserOn() {
	CDataPointDoc* pDoc = GetDocument();	
	ASSERT_VALID(pDoc);
	if (pDoc->RunDocParent->GetNeuronApp()) pDoc->RunDocParent->GetNeuronApp()->BeamGuiding->ToggleLaserOnOff();
}

void CDataPointView::OnUpdateLaserOn(CCmdUI* pCmdUI) 
{
	CDataPointDoc* pDoc = GetDocument();	
	ASSERT_VALID(pDoc);
	if (pDoc->RunDocParent->GetNeuronApp()) {		
		pCmdUI->SetCheck( pDoc->RunDocParent->GetNeuronApp()->BeamGuiding->IsLaserOn() );
		pCmdUI->Enable( true );	
	} else pCmdUI->Enable( false );	
}

void CDataPointView::OnLaserProperties() {
	LButtonDownMode=3;
}

void CDataPointView::OnDeleteLaserFocus() {
	LButtonDownMode=4;
}

void CDataPointView::OnDeleteSpline() {
	LButtonDownMode=7;
}

void CDataPointView::OnSelectRegion() {
	LButtonDownMode=8;
}

void CDataPointView::OnMoveLaserFocus() {
	LButtonDownMode=5;
}

void CDataPointView::OnUpdateZoomOut(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( true );	
}

void CDataPointView::OnUpdateZoomIn(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( true );
}

void CDataPointView::UpdateView()
{
	CClientDC dc(this);
	OnPrepareDC(&dc);
	OnDraw(&dc);
}

void CDataPointView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CDataPointDoc* pDoc = GetDocument();	
	ASSERT_VALID(pDoc);
	switch (LButtonUpMode) 
	{
	case 1: 
	//moving something?
		{
			ReleaseCapture();		
			ConvertCoordsDeviceToLogical(point);
			ConvertCoordsViewToDoc(point);
			ConvertCoordsDeviceToLogical(MoveStartPoint);
			ConvertCoordsViewToDoc(MoveStartPoint);
			pDoc->Move(MoveStartPoint,point,MovedStop,MovedSubPoint);							
			break;
		}
	case 2:
	//selection box
		{
			CPoint ul(TempSelection.left,TempSelection.top);
			CPoint lr(TempSelection.right,TempSelection.bottom);
			ConvertCoordsViewToDoc(ul);
			ConvertCoordsViewToDoc(lr);
			CRect rectClip(ul.x,ul.y,lr.x,lr.y);
			rectClip.NormalizeRect();
			pDoc->RunDocParent->Selection = rectClip;
			TempSelection = rectClip;

			break;		
		}/*
	case 3:
	//optimize contrast
		{			
			CPoint ul(TempSelection.left,TempSelection.top);
			CPoint lr(TempSelection.right,TempSelection.bottom);
			ConvertCoordsViewToDoc(ul);
			ConvertCoordsViewToDoc(lr);
			CRect rectClip(ul.x,ul.y,lr.x,lr.y);
			rectClip.NormalizeRect();
			pDoc->RunDocParent->m_ContrastRegion = rectClip;
			pDoc->OptimizeContrast();
			
			CHint *hint=new CHint(4,CRect());
			pDoc->UpdateAllViews(NULL, 0L, hint);
			LButtonUpMode=-1;	
			LButtonDragMode=-1;	
			TempSelection.SetRectEmpty();
		}
	case 4:
	//detection region
		{
			CPoint ul(TempSelection.left,TempSelection.top);
			CPoint lr(TempSelection.right,TempSelection.bottom);
			ConvertCoordsViewToDoc(ul);
			ConvertCoordsViewToDoc(lr);
			CRect rectClip(ul.x,ul.y,lr.x,lr.y);
			rectClip.NormalizeRect();
			//do something with rectClip
			
			CHint *hint=new CHint(4,CRect());
			pDoc->UpdateAllViews(NULL, 0L, hint);
			LButtonUpMode=-1;	
			LButtonDragMode=-1;	
			TempSelection.SetRectEmpty();
			
		}*/
	}
	LButtonUpMode=-1;
	LButtonDragMode=-1;	

	CScrollView::OnLButtonUp(nFlags, point);
}

void CDataPointView::OnMouseMove(UINT nFlags, CPoint point) 
{	
	DisplayCursorInStatusBar(point);
	CDataPointDoc* pDoc = GetDocument();	
	ASSERT_VALID(pDoc);
	switch (LButtonUpMode) {
	case 1: {				
			CPoint help=point;
			ConvertCoordsDeviceToLogical(point);
			ConvertCoordsViewToDoc(point);
			ConvertCoordsDeviceToLogical(MoveStartPoint);
			ConvertCoordsViewToDoc(MoveStartPoint);
			pDoc->Move(MoveStartPoint,point,MovedStop,MovedSubPoint);	
			MoveStartPoint=help;						
			break;
		}	
	}	
	switch (LButtonDragMode) {
	//select region
	case 1: 
			
			if (pDoc->RunDocParent) {
				CPoint help=point;
				ConvertCoordsDeviceToLogical(help);
				//ConvertCoordsViewToDoc(help);
				TempSelection.right = help.x;
				TempSelection.bottom = help.y;
				//pDoc->RunDocParent->Selection = TempSelection;
				//pDoc->RunDocParent->Selection.NormalizeRect();
				DisplaySelectionInStatusBar();
			}	
			//pDoc->UpdateAllViews(NULL);
			Invalidate();
			
			break;
	//ruler
	case 2:
			if (pDoc->RunDocParent) {
				CPoint help=point;
				ConvertCoordsDeviceToLogical(help);
				ConvertCoordsViewToDoc(help);
				Ruler_end = help;
				DisplayRulerInStatusBar();
			}	
			Invalidate();
			//pDoc->UpdateAllViews(NULL);		
	}

	CScrollView::OnMouseMove(nFlags, point);
}

void CDataPointView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CDataPointDoc* pDoc = GetDocument();	
	ASSERT_VALID(pDoc);
	switch (LButtonDownMode) {
	case 1: {
			if (pDoc->Active) {
				LButtonDownMode=2;
				SetCursor(AfxGetApp()->LoadCursor(IDC_NEWLASERFOCUSCURSOR2));
				FirstLButtonDown=point;
			} else {
				AfxMessageBox("Datapoint is no longer the last recorded");
				LButtonDownMode=-1;
				SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
			}
			break;
		}
	case 2: {
			LButtonDownMode=-1;
			if (pDoc->Active) {							
				ConvertCoordsDeviceToLogical(point);
				ConvertCoordsViewToDoc(point);
				pDoc->ConvertCoordPixelToReal(point);
				ConvertCoordsDeviceToLogical(FirstLButtonDown);
				ConvertCoordsViewToDoc(FirstLButtonDown);
				pDoc->ConvertCoordPixelToReal(FirstLButtonDown);
				pDoc->AddNewLaserFocus(FirstLButtonDown,point-FirstLButtonDown);				
			} else AfxMessageBox("Datapoint is no longer the last recorded");
			break;
		}
	case 3: {
			CPoint help=point;
			ConvertCoordsDeviceToLogical(help);
			ConvertCoordsViewToDoc(help);
			PropertyDlg(help);
			LButtonDownMode=-1;
			break;
			}
	case 4: {
			if (pDoc->Active) {
				int subPoint;
				CPoint help=point;
				ConvertCoordsDeviceToLogical(help);
				ConvertCoordsViewToDoc(help);
				CBeamStop* BeamStop=pDoc->FindNearestBeamStop(help,subPoint);
				if (BeamStop) {
					pDoc->DeleteLaserFocus(BeamStop);
				}
			}
			LButtonDownMode=-1;
			break;
			}
	
	case 6: {
			LButtonDownMode=-1;
			if (pDoc->Active) {							
				ConvertCoordsDeviceToLogical(point);
				ConvertCoordsViewToDoc(point);				
				pDoc->AddSpline(point);				
			} else AfxMessageBox("Datapoint is no longer the last recorded");
			
			break;
			}
	case 7: {
			if (pDoc->Active) {
				int subPoint;
				CPoint help=point;
				ConvertCoordsDeviceToLogical(help);
				ConvertCoordsViewToDoc(help);
				CBeamStop* BeamStop=pDoc->FindNearestBeamStop(help,subPoint);
				if (BeamStop) BeamStop->DeleteSplinePoint(subPoint);
				pDoc->UpdateAllViews(NULL, 0L, BeamStop);
			}
			LButtonDownMode=-1;
			break;
			}
	//this is start select region
	case 8: {
			if (pDoc->RunDocParent) {
				CPoint help=point;
				ConvertCoordsDeviceToLogical(help);
				//ConvertCoordsViewToDoc(help);

				TempSelection.SetRectEmpty();
				TempSelection.left=help.x;	
				TempSelection.top=help.y;
			}
			//LButtonDownMode=9;
			LButtonDragMode=1;
			LButtonDownMode=-1;
			LButtonUpMode = 2;
			break;
			}
	//this isn't used anymore, it was to finish select region
	/*
	case 9: {
			if (pDoc->RunDocParent) {
				CPoint help=point;
				ConvertCoordsDeviceToLogical(help);
				ConvertCoordsViewToDoc(help);
				pDoc->RunDocParent->Selection.right=help.x;	
				pDoc->RunDocParent->Selection.bottom=help.y;
				DisplaySelectionInStatusBar();
			}
			LButtonDownMode=-1;
			pDoc->UpdateAllViews(NULL);
			break;
			}
	*/
	//start ruler tool
	case 9: 
			if (pDoc->RunDocParent) 
			{
				CPoint help=point;
				ConvertCoordsDeviceToLogical(help);
				ConvertCoordsViewToDoc(help);
				Ruler_start = help;
				Ruler_end = help;
			}
			LButtonDragMode=2;
			LButtonDownMode=-1;
			break;
	//contrast region
	case 10:
			if (pDoc->RunDocParent) {
				CPoint help=point;
				ConvertCoordsDeviceToLogical(help);
				//ConvertCoordsViewToDoc(help);

				TempSelection.SetRectEmpty();
				TempSelection.left=help.x;	
				TempSelection.top=help.y;
			}
			//LButtonDownMode=9;
			LButtonDragMode=1;
			LButtonDownMode=-1;
			LButtonUpMode = 3;
			break;
	//detection region
	case 11:
			if (pDoc->RunDocParent) {
				CPoint help=point;
				ConvertCoordsDeviceToLogical(help);
				//ConvertCoordsViewToDoc(help);

				TempSelection.SetRectEmpty();
				TempSelection.left=help.x;	
				TempSelection.top=help.y;
			}
			//LButtonDownMode=9;
			LButtonDragMode=1;
			LButtonDownMode=-1;
			LButtonUpMode = 4;
			break;

	case 5: 		
	default: {
			int subPoint;
			CPoint help=point;
			ConvertCoordsDeviceToLogical(help);
			ConvertCoordsViewToDoc(help);
			CBeamStop* BeamStop=pDoc->FindNearestBeamStop(help,subPoint);
			if (BeamStop) {
				SetCapture();
				LButtonUpMode=1;
				MoveStartPoint=point;
				MovedStop=BeamStop;
				MovedSubPoint=subPoint;
			}
			TempSelection.SetRectEmpty();
			Ruler_end = Ruler_start;
			if (pDoc->RunDocParent)
				pDoc->RunDocParent->Selection.SetRectEmpty();
			pDoc->UpdateAllViews(NULL);
		}
		LButtonDownMode=-1;
		break;
	}	
	CScrollView::OnLButtonDown(nFlags, point);
}


void CDataPointView::OnContextMenu(CWnd* /*pWnd*/, CPoint point) 
{
   // make sure window is active
   GetParentFrame()->ActivateFrame();

   CPoint local = point;
   ScreenToClient(&local);
//   ClientToDoc(local);

   /*CDrawObj* pObj;
   pObj = GetDocument()->ObjectAt(local);
   if (pObj != NULL)
   {
      if (!IsSelected(pObj))
         Select(pObj, FALSE);
      UpdateWindow();*/

      CMenu menu;
      if (menu.LoadMenu(IDR_DATAPOINTPOPUPMENU))
      {
         CMenu* pPopup = menu.GetSubMenu(0);
         ASSERT(pPopup != NULL);

         pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
            point.x, point.y,
            AfxGetMainWnd()); // use main window for cmds
      }
   //}
}

void CDataPointView::OnCancelMode() 
{
	CScrollView::OnCancelMode();
	
	// TODO: Add your message handler code here
	
}

void CDataPointView::OnLButtonDblClk(UINT nFlags, CPoint point) {
	if (IsPreview) {
		CDataPointDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);
		if (pDoc->RunDocParent) pDoc->RunDocParent->LoadDatapoint(pDoc->MyNumber);				
	} else {
		CPoint help=point;
		ConvertCoordsDeviceToLogical(help);
		ConvertCoordsViewToDoc(help);
		PropertyDlg(help); 
	}
	CScrollView::OnLButtonDblClk(nFlags, point);
}

void CDataPointView::PropertyDlg(CPoint point) //point in pixel coord
{
	CDataPointDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	int subPoint;
	CBeamStop* BeamStop=pDoc->FindNearestBeamStop(point,subPoint);
	if (BeamStop) {
		int help=BeamStop->PropertyDlg(pDoc->Active);
		if (help>=0) {			
			if (help>0) {			
				POSITION pos=pDoc->BeamPath->GetHeadPosition();
				while (pos!=NULL) {
					CBeamStop* Obj=((CBeamStop*)pDoc->BeamPath->GetNext(pos));		
					if ((help & 1)>0) {
						Obj->Size=BeamStop->Size;
						Obj->Range=BeamStop->Range;
						Obj->PolynomDegree=BeamStop->PolynomDegree;
					}
					if ((help & 2)>0) Obj->DwellTime=BeamStop->DwellTime;				
				}
			}								
			pDoc->UpdateAllViews(NULL, 0L, BeamStop);
			pDoc->RunDocParent->GetNeuronApp()->BeamGuiding->SetNewPath(pDoc->BeamPath);
		}
	}
}

double CDataPointView::GetZoomFactor()
{
/*	if (IsPreview) {
		CDataPointDoc* pDoc = (CDataPointDoc*)GetDocument();
		ASSERT_VALID(pDoc);
		double help=pDoc->PreviewBinning;
		return 1/help;
	} else */
	return  (ZoomLevel>0) ? (double)(256 >> ZoomLevel)/256.0 : (double)(256 << abs(ZoomLevel))/256.0;
}

void CDataPointView::OnSaveAsBmp() 
{
	CDataPointDoc* pDoc = (CDataPointDoc*)GetDocument();
	ASSERT_VALID(pDoc);
	if (pDoc->RunDocParent) {
		pDoc->RunDocParent->SaveAsBMP(pDoc->MyNumber);
	}
}

void CDataPointView::OnUpdateSaveAsBmp(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(true);
}

void CDataPointView::OnDataPointViewDlg() {
	CDataPointViewDlg dlg;
	dlg.m_CellVisible=CellImageVisible;
	dlg.m_CompareVisible=CompareImageVisible;
	dlg.m_DetectionVisible=ConeDetectionImageVisible;
	dlg.m_LaserVisible=LaserImageVisible;
	dlg.m_PathVisible=LaserPathVisible;
	dlg.m_RealizedPathVisible=RealizedPathVisible;
	dlg.m_ViewmarksVisible=MarkViewPosition;
	dlg.m_CellPixelShift=CellPixelShift;
	dlg.m_TopMost=TopMost;
	if (dlg.DoModal()==IDOK) {
		CellImageVisible=dlg.m_CellVisible;
		CompareImageVisible=dlg.m_CompareVisible;
		ConeDetectionImageVisible=dlg.m_DetectionVisible;
		LaserImageVisible=dlg.m_LaserVisible;
		LaserPathVisible=dlg.m_PathVisible;
		RealizedPathVisible=dlg.m_RealizedPathVisible;
		MarkViewPosition=dlg.m_ViewmarksVisible;
		CellPixelShift=dlg.m_CellPixelShift;
		TopMost=dlg.m_TopMost;
		if (IsPreview) {
			CellImageVisible=true;
			CompareImageVisible=false;
			ConeDetectionImageVisible=false;
			LaserImageVisible=false;			
		}
		SetTopMost();
		Invalidate(TRUE);
	}
}

void CDataPointView::DisplaySelectionInStatusBar()
{
	CDataPointDoc* pDoc = GetDocument();	
	ASSERT_VALID(pDoc);	
	if (pDoc->RunDocParent) {
		CPoint ul,lr;
		/*
		ul.x=pDoc->RunDocParent->Selection.left;
		ul.y=pDoc->RunDocParent->Selection.top;
		lr.x=pDoc->RunDocParent->Selection.right;
		lr.y=pDoc->RunDocParent->Selection.bottom;
		*/
		ul.x = TempSelection.left;
		ul.y = TempSelection.top;
		lr.x = TempSelection.right;
		lr.y = TempSelection.bottom;

		pDoc->ConvertCoordPixelToReal(ul);
		pDoc->ConvertCoordPixelToReal(lr);	
		double x1,y1,x2,y2;
		x1=ul.x;
		y1=ul.y;
		x2=lr.x;
		y2=lr.y;
		x1/=1000.0;
		y1/=1000.0;
		x2/=1000.0;
		y2/=1000.0;
		double w=fabs(x1-x2);
		double h=fabs(y1-y2);
		double d=w*w+h*h;
		if (d>0.000001) d=sqrt(d);
		CString strCurPos;
		strCurPos.Format(ID_INDICATOR_SELECTION, x1, y1,w,h,d,w*h);
		((CMainFrame*)AfxGetApp()->m_pMainWnd)->GetStatusBar()->SetPaneText(((CMainFrame*)AfxGetApp()->m_pMainWnd)->GetStatusBar()->CommandToIndex(ID_INDICATOR_SELECTION),strCurPos);
	}
}

void CDataPointView::DisplayCursorInStatusBar(CPoint point)
{
	CDataPointDoc* pDoc = GetDocument();	
	ASSERT_VALID(pDoc);
	CPoint p=point;
	ConvertCoordsDeviceToLogical(p);
	ConvertCoordsViewToDoc(p);
	pDoc->ConvertCoordPixelToReal(p);
	double x=p.x;
	double y=p.y;
	x/=1000.0;
	y/=1000.0;
	CString strCurPos;
	strCurPos.Format(ID_INDICATOR_CURPOS, x, y);
	((CMainFrame*)AfxGetApp()->m_pMainWnd)->GetStatusBar()->SetPaneText(((CMainFrame*)AfxGetApp()->m_pMainWnd)->GetStatusBar()->CommandToIndex(ID_INDICATOR_CURPOS),strCurPos);
}

void CDataPointView::SetAsPreview()
{
	IsPreview=true;
	ZoomLevel=-1;
	CellImageVisible=true;
	CompareImageVisible=false;
	ConeDetectionImageVisible=false;
	LaserImageVisible=false;	
	LaserPathVisible=true;
	RealizedPathVisible=true;	
	MarkViewPosition=true;
	TopMost=true;
	SetTopMost();
}

void CDataPointView::SetTopMost()
{
	if (TopMost) {
		//SetWindowPos(&wndTopMost,0,0,0,0, SWP_NOMOVE | SWP_NOSIZE  |SWP_DRAWFRAME  | SWP_SHOWWINDOW);
		SetWindowPos(&wndTopMost,0,0,0,0, SWP_NOMOVE | SWP_NOSIZE);
	} else {
		//tWindowPos(&wndNoTopMost,0,0,0,0, SWP_NOMOVE | SWP_NOSIZE | SWP_DRAWFRAME | SWP_SHOWWINDOW);
		SetWindowPos(&wndBottom,0,0,0,0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
	}
//	DWORD help=GetExStyle( ) & WS_EX_TOPMOST;
}

void CDataPointView::OnUseRuler()
{
	LButtonDownMode = 9;
}

void CDataPointView::DisplayRulerInStatusBar()
{
	CDataPointDoc* pDoc = GetDocument();	
	ASSERT_VALID(pDoc);	
	if (pDoc->RunDocParent) {
		CPoint start = Ruler_start;
		CPoint end = Ruler_end;
		pDoc->ConvertCoordPixelToReal(start);
		pDoc->ConvertCoordPixelToReal(end);	
		double x1,y1,x2,y2;
		x1=start.x;
		y1=start.y;
		x2=end.x;
		y2=end.y;
		x1/=1000.0;
		y1/=1000.0;
		x2/=1000.0;
		y2/=1000.0;
		double w=fabs(x1-x2);
		double h=fabs(y1-y2);
		double d=w*w+h*h;
		if (d>0.000001) d=sqrt(d);
		CString strCurPos;
		strCurPos.Format(ID_INDICATOR_SELECTION, x1, y1,w,h,d,w*h);
		((CMainFrame*)AfxGetApp()->m_pMainWnd)->GetStatusBar()->SetPaneText(((CMainFrame*)AfxGetApp()->m_pMainWnd)->GetStatusBar()->CommandToIndex(ID_INDICATOR_SELECTION),strCurPos);
	}
}

//DEL void CDataPointView::OpenSelectRegion()
//DEL {
//DEL 	CMultiDocTemplate* DataPointDocTemplate = new CMultiDocTemplate(
//DEL 		IDR_DATAPOINT_TYPE,
//DEL 		RUNTIME_CLASS(CDataPointDoc),
//DEL 		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
//DEL 		RUNTIME_CLASS(CDataPointView));
//DEL 	CDataPointDoc* Doc=GetDocument();
//DEL 	CFrameWnd* NewFrame=DataPointDocTemplate->CreateNewFrame(Doc,NULL);	
//DEL 	DataPointDocTemplate->InitialUpdateFrame( NewFrame, Doc);
//DEL 
//DEL }

int CDataPointView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	//m_dialogbar.Create( GetParentFrame(), IDD_RUN_FORM, CBRS_TOP, IDD_RUN_FORM);
	if (CScrollView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	
	return 0;
}

void CDataPointView::OnContrastRegion() 
{
	LButtonDownMode = 10;
}


//DEL void CDataPointView::ContrastRegion()
//DEL {
//DEL 	CDataPointDoc* pDoc = GetDocument();	
//DEL 	ASSERT_VALID(pDoc);
//DEL 	if (!IsPreview && pDoc->CellImage && !m_ContrastRegion.IsRectNull() )
//DEL 	{
//DEL 	}
//DEL }

void CDataPointView::OnOptimizeContrast() 
{
	CDataPointDoc* pDoc = GetDocument();	
	ASSERT_VALID(pDoc);
	if (!TempSelection.IsRectNull())
	{
		pDoc->m_ContrastRegion = TempSelection;
		pDoc->RunDocParent->m_ContrastRegion = TempSelection;
		TempSelection.SetRectEmpty();
	}
	else if (!pDoc->m_ContrastRegion.IsRectNull())
	{
		pDoc->m_ContrastRegion.SetRectEmpty();
		pDoc->RunDocParent->m_ContrastRegion.SetRectEmpty();
	}
	pDoc->OptimizeContrast();
	CHint *hint=new CHint(4,CRect());
	pDoc->UpdateAllViews(NULL, 0L, hint);

}

void CDataPointView::OnCalcDetectionImage() 
{
	CDataPointDoc* pDoc = GetDocument();	
	ASSERT_VALID(pDoc);
	if (!TempSelection.IsRectNull())
	{
		pDoc->m_DetectionRegion = TempSelection;
		pDoc->RunDocParent->m_DetectionRegion = TempSelection;
		TempSelection.SetRectEmpty();
	}
	else if (!pDoc->m_ContrastRegion.IsRectNull())
	{
		pDoc->m_DetectionRegion.SetRectEmpty();
		pDoc->RunDocParent->m_DetectionRegion.SetRectEmpty();
	}
	pDoc->CalcDetectionImage();	
}

BOOL WriteDIB(LPTSTR szFile, HANDLE hDIB)
{
	BITMAPFILEHEADER	hdr;
	LPBITMAPINFOHEADER	lpbi;

	if (!hDIB)
		return FALSE;

	CFile file;
	if( !file.Open( szFile, CFile::modeWrite|CFile::modeCreate) )
		return FALSE;

	lpbi = (LPBITMAPINFOHEADER)hDIB;

	int nColors = 1 << lpbi->biBitCount;

	// Fill in the fields of the file header 
	hdr.bfType		= ((WORD) ('M' << 8) | 'B');	// is always "BM"
	hdr.bfSize		= GlobalSize (hDIB) + sizeof( hdr );
	hdr.bfReserved1 	= 0;
	hdr.bfReserved2 	= 0;
	hdr.bfOffBits		= (DWORD) (sizeof( hdr ) + lpbi->biSize +
						nColors * sizeof(RGBQUAD));

	// Write the file header 
	file.Write( &hdr, sizeof(hdr) );

	// Write the DIB header and the bits 
	file.Write( lpbi, GlobalSize(hDIB) );

	return TRUE;
}

HANDLE DDBToDIB( CBitmap& bitmap, DWORD dwCompression, CPalette* pPal ) 
{
	BITMAP			bm;
	BITMAPINFOHEADER	bi;
	LPBITMAPINFOHEADER 	lpbi;
	DWORD			dwLen;
	HANDLE			hDIB;
	HANDLE			handle;
	HDC 			hDC;
	HPALETTE		hPal;


	ASSERT( bitmap.GetSafeHandle() );

	// The function has no arg for bitfields
	if( dwCompression == BI_BITFIELDS )
		return NULL;

	// If a palette has not been supplied use defaul palette
	hPal = (HPALETTE) pPal->GetSafeHandle();
	if (hPal==NULL)
		hPal = (HPALETTE) GetStockObject(DEFAULT_PALETTE);

	// Get bitmap information
	bitmap.GetObject(sizeof(bm),(LPSTR)&bm);

	// Initialize the bitmapinfoheader
	bi.biSize		= sizeof(BITMAPINFOHEADER);
	bi.biWidth		= bm.bmWidth;
	bi.biHeight 		= bm.bmHeight;
	bi.biPlanes 		= 1;
	bi.biBitCount		= bm.bmPlanes * bm.bmBitsPixel;
	bi.biCompression	= dwCompression;
	bi.biSizeImage		= 0;
	bi.biXPelsPerMeter	= 0;
	bi.biYPelsPerMeter	= 0;
	bi.biClrUsed		= 0;
	bi.biClrImportant	= 0;

	// Compute the size of the  infoheader and the color table
	int nColors = (1 << bi.biBitCount);
	if( nColors > 256 ) 
		nColors = 0;
	dwLen  = bi.biSize + nColors * sizeof(RGBQUAD);

	// We need a device context to get the DIB from
	hDC = GetDC(NULL);
	hPal = SelectPalette(hDC,hPal,FALSE);
	RealizePalette(hDC);

	// Allocate enough memory to hold bitmapinfoheader and color table
	hDIB = GlobalAlloc(GMEM_FIXED,dwLen);

	if (!hDIB){
		SelectPalette(hDC,hPal,FALSE);
		ReleaseDC(NULL,hDC);
		return NULL;
	}

	lpbi = (LPBITMAPINFOHEADER)hDIB;

	*lpbi = bi;

	// Call GetDIBits with a NULL lpBits param, so the device driver 
	// will calculate the biSizeImage field 
	GetDIBits(hDC, (HBITMAP)bitmap.GetSafeHandle(), 0L, (DWORD)bi.biHeight,
			(LPBYTE)NULL, (LPBITMAPINFO)lpbi, (DWORD)DIB_RGB_COLORS);

	bi = *lpbi;

	// If the driver did not fill in the biSizeImage field, then compute it
	// Each scan line of the image is aligned on a DWORD (32bit) boundary
	if (bi.biSizeImage == 0){
		bi.biSizeImage = ((((bi.biWidth * bi.biBitCount) + 31) & ~31) / 8) 
						* bi.biHeight;

		// If a compression scheme is used the result may infact be larger
		// Increase the size to account for this.
		if (dwCompression != BI_RGB)
			bi.biSizeImage = (bi.biSizeImage * 3) / 2;
	}

	// Realloc the buffer so that it can hold all the bits
	dwLen += bi.biSizeImage;
	if (handle = GlobalReAlloc(hDIB, dwLen, GMEM_MOVEABLE))
		hDIB = handle;
	else{
		GlobalFree(hDIB);

		// Reselect the original palette
		SelectPalette(hDC,hPal,FALSE);
		ReleaseDC(NULL,hDC);
		return NULL;
	}

	// Get the bitmap bits
	lpbi = (LPBITMAPINFOHEADER)hDIB;

	// FINALLY get the DIB
	BOOL bGotBits = GetDIBits( hDC, (HBITMAP)bitmap.GetSafeHandle(),
				0L,				// Start scan line
				(DWORD)bi.biHeight,		// # of scan lines
				(LPBYTE)lpbi 			// address for bitmap bits
				+ (bi.biSize + nColors * sizeof(RGBQUAD)),
				(LPBITMAPINFO)lpbi,		// address of bitmapinfo
				(DWORD)DIB_RGB_COLORS);		// Use RGB for color table

	if( !bGotBits )
	{
		GlobalFree(hDIB);
		
		SelectPalette(hDC,hPal,FALSE);
		ReleaseDC(NULL,hDC);
		return NULL;
	}

	SelectPalette(hDC,hPal,FALSE);
	ReleaseDC(NULL,hDC);
	return hDIB;
}

BOOL WriteWindowToDIB( LPTSTR szFile, CWnd *pWnd )
{
	CBitmap 	bitmap;
	CWindowDC	dc(pWnd);
	CDC 		memDC;
	CRect		rect;

	memDC.CreateCompatibleDC(&dc); 

	pWnd->GetWindowRect(rect);

	bitmap.CreateCompatibleBitmap(&dc, rect.Width(),rect.Height() );
	
	CBitmap* pOldBitmap = memDC.SelectObject(&bitmap);
	memDC.BitBlt(0, 0, rect.Width(),rect.Height(), &dc, 0, 0, SRCCOPY); 

	// Create logical palette if device support a palette
	CPalette pal;
	if( dc.GetDeviceCaps(RASTERCAPS) & RC_PALETTE )
	{
		UINT nSize = sizeof(LOGPALETTE) + (sizeof(PALETTEENTRY) * 256);
		LOGPALETTE *pLP = (LOGPALETTE *) new BYTE[nSize];
		pLP->palVersion = 0x300;

		pLP->palNumEntries = 
			GetSystemPaletteEntries( dc, 0, 255, pLP->palPalEntry );

		// Create the palette
		pal.CreatePalette( pLP );

		delete[] pLP;
	}

	memDC.SelectObject(pOldBitmap);

	// Convert the bitmap to a DIB
	HANDLE hDIB = DDBToDIB( bitmap, BI_RGB, &pal );

	if( hDIB == NULL )
		return FALSE;

	// Write it to file
	WriteDIB( szFile, hDIB );

	// Free the memory allocated by DDBToDIB for the DIB
	GlobalFree( hDIB );
	return TRUE;
}
