// DataPointView.h : interface of the CDataPointView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DATAPOINTVIEW_H__584239C3_05EA_4A9A_83CF_D4D60B43DD67__INCLUDED_)
#define AFX_DATAPOINTVIEW_H__584239C3_05EA_4A9A_83CF_D4D60B43DD67__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CDataPointView : public CScrollView
{
protected: // create from serialization only
	CDataPointView();
	DECLARE_DYNCREATE(CDataPointView)	
// Attributes
public:
	CDataPointDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDataPointView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	void SetTopMost();
	bool TopMost;
	unsigned char CellPixelShift;
	void SetAsPreview();
	bool IsPreview;
	void DisplayCursorInStatusBar();
	void DisplaySelectionInStatusBar();
	int MovedSubPoint;
	CBeamStop* MovedStop;
	HCURSOR NewLaserFocusCursor1;
	bool MarkViewPosition;
	bool ConeDetectionImageVisible;
	bool CompareImageVisible;
	double GetZoomFactor();
	CPoint MoveStartPoint;
	bool CellImageVisible;
	bool RealizedPathVisible;
	bool LaserImageVisible;
	bool LaserPathVisible;
	CUnifiedBitmap* UnifiedBitmap;
	void ConvertCoordsDocToView(CPoint &point);
	void ConvertCoordsViewToDoc(CPoint &point);
	void ConvertCoordsDeviceToLogical(CPoint &point);
	void ConvertCoordsLogicalToDevice(CPoint &point);
	void UpdateView();
	void UpdateMarks();
	virtual ~CDataPointView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	void DisplayRulerInStatusBar();
	CPoint Ruler_end;
	CPoint Ruler_start;
//	CRectTracker TempSelection;
	CRect TempSelection;
	int LButtonDragMode;
	//{{AFX_MSG(CDataPointView)
		afx_msg void OnContrastRegion();
		afx_msg void OnDatapointWindowNew();
		afx_msg void OnAddSpline();
		afx_msg void OnZoomIn();
		afx_msg void OnZoomOut();
		afx_msg void OnNewLaserFocus();
		afx_msg void OnAddComment();
		afx_msg void OnDeleteLaserFocus();
		afx_msg void OnLaserOn();		
		afx_msg void OnMoveLaserFocus();
		afx_msg void OnLaserProperties();
		afx_msg void OnLaserPathVisible();
		afx_msg void OnLaserImageVisible();
		afx_msg void OnCellImageVisible();
		afx_msg void OnRealizedPathVisible();
		afx_msg void OnDeleteSpline();
		afx_msg void OnSelectRegion();
		afx_msg void OnCompareImageVisible();
		afx_msg void OnConeDetectionImageVisible();
		afx_msg void OnMarkViewPosition();
		afx_msg void OnUpdateLaserPathVisible(CCmdUI* pCmdUI);
		afx_msg void OnUpdateLaserImageVisible(CCmdUI* pCmdUI);
		afx_msg void OnUpdateCellImageVisible(CCmdUI* pCmdUI);
		afx_msg void OnUpdateRealizedPathVisible(CCmdUI* pCmdUI);
		afx_msg void OnUpdateCompareImageVisible(CCmdUI* pCmdUI);
		afx_msg void OnUpdateConeDetectionImageVisible(CCmdUI* pCmdUI);
		afx_msg void OnUpdateMarkViewPosition(CCmdUI* pCmdUI);
		afx_msg void OnUpdateLaserFocus(CCmdUI* pCmdUI);
		afx_msg void OnUpdateLaserOn(CCmdUI* pCmdUI);
		afx_msg void OnUpdateLaserProperties(CCmdUI* pCmdUI);
		afx_msg void OnUpdateZoomOut(CCmdUI* pCmdUI);	
		afx_msg void OnUpdateZoomIn(CCmdUI* pCmdUI); 
		afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
		afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
		afx_msg void OnMouseMove(UINT nFlags, CPoint point);
		afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
		afx_msg void OnCancelMode();
		afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
		afx_msg BOOL OnEraseBkgnd( CDC* pDC );
		afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
		afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
		afx_msg void OnMove(int x, int y);
		afx_msg void OnUpdateAddSpline(CCmdUI* pCmdUI);
		afx_msg void OnUpdateDeleteSpline(CCmdUI* pCmdUI); 
	afx_msg void OnSaveAsBmp();
	afx_msg void OnUpdateSaveAsBmp(CCmdUI* pCmdUI);
	afx_msg void OnUseRuler();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnOptimizeContrast();
	afx_msg void OnCalcDetectionImage();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	int LButtonUpMode;
	CPoint FirstLButtonDown;
	int LButtonDownMode;
	int ZoomLevel;
	void PropertyDlg(CPoint point) ;
	void OnDataPointViewDlg();
	void DisplayCursorInStatusBar(CPoint point);
	bool ForceRecalculateUnifiedBitmap;
};

BOOL WriteDIB(LPTSTR szFile, HANDLE hDIB);
HANDLE DDBToDIB( CBitmap& bitmap, DWORD dwCompression, CPalette* pPal );
BOOL WriteWindowToDIB( LPTSTR szFile, CWnd *pWnd );


#ifndef _DEBUG  // debug version in DataPointView.cpp
inline CDataPointDoc* CDataPointView::GetDocument()
   { return (CDataPointDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DATAPOINTVIEW_H__584239C3_05EA_4A9A_83CF_D4D60B43DD67__INCLUDED_)
