#if !defined(AFX_GUIDING_H__A159C0EA_1B5E_45F0_B155_663BBE02F577__INCLUDED_)
#define AFX_GUIDING_H__A159C0EA_1B5E_45F0_B155_663BBE02F577__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Guiding.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CGuiding window

class CGuiding : public CObject
{
// Construction
public:
	CGuiding();

// Attributes
private:
	double SplineLength;
	double InitT;
	CArray<POINT, POINT> CurvePoints;
	bool Spline;
	double xp,yp,xd,yd;
	int height,width;
	bool GetPos(CBeamStop *BeamStop,double t,CPoint &pos);
	void PrepareAdvanceBeamStop(CDataPointDoc *aDataPoint, CBeamStop *BeamStop, bool SubstractBeamAdvance);
	void AdvanceBeamStop(CDataPointDoc* aDataPoint,CBeamStop* BeamStop,long Timelaps);
// Operations
public:

// Implementation
public:			
	bool ExtractAxonArea;
	bool ExtractCellArea;
	long	m_FloodFillOutsideSize;
	int		m_MedianSize;
	int		m_BeamAdvance;
	long	m_MaxStepsize;
	long	m_CropBorders;
	int		m_EdgeFilterEnd;
	int		m_EdgeFilterStart;
	long	m_EraseSmaller1;
	long	m_EraseSmaller2;
	long	m_FillGapStart1;
	long	m_FillGapStart2;
	int		m_FillGapStop1;
	int		m_FillGapStop2;
	int		m_MedianLevel;
	long	m_StopAfterStep;
	long	m_ExaminedSurrounding;
	void CalcDetectionImage(CDataPointDoc* aDataPoint, CRect region, CBeamGuiding *aBeamGuiding=NULL);
	void CalcDetectionImage(CDataPointDoc* aDataPoint, CBeamGuiding *aBeamGuiding=NULL);
	int GuidingMode;
	void StartStop(bool start);
	bool IsGuiding;
	CTime LastGuidingTime;
	void CalcNewBeamPath(CDataPointDoc* aDataPoint, CBeamGuiding* aBeamGuiding,long Timelaps);
	virtual ~CGuiding();
	void OnGuidingDialog();
	void SerializeParams(CArchive &ar);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GUIDING_H__A159C0EA_1B5E_45F0_B155_663BBE02F577__INCLUDED_)
