// Image.cpp : implementation file
//

#include "stdafx.h"
#include "Neuron.h"
#include "Image.h"
#include "TGA.h"
#include "BMP.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CImage


CImage::CImage()
{	
	Width=0;
	Height=0;	
    bitmap =NULL;	
	bitmap32bit=NULL;
	WinBitmap=NULL;
	bitperpixel=16;
	Width1Bit=0;
	bitmap8bit=NULL;
	EffectiveBitPerPixel=16;
}

void CImage::Copy(CImage *Org)
{
	if (bitmap8bit) delete bitmap8bit;
	bitmap8bit=NULL;
	if (WinBitmap) delete WinBitmap;
	WinBitmap=NULL;
	if (bitmap) delete bitmap;
	bitmap=NULL;
	if (bitmap32bit) delete bitmap32bit;
	bitmap32bit=NULL;
	EffectiveBitPerPixel=Org->EffectiveBitPerPixel;
	bitperpixel=Org->bitperpixel;
	Width1Bit=Org->Width1Bit;
	WinBitmap=NULL;
	Width=Org->Width;
	Height=Org->Height;			
	if (bitperpixel==1) {		
		bitmap32bit = new unsigned long[Width1Bit*Height];
		unsigned long *bm=bitmap32bit;
		unsigned long *o=Org->bitmap32bit;
		for (long i=0;i<Width1Bit*Height;i++) {
			*bm=*o;
			o++;
			bm++;
		}
	} else if (bitperpixel==8) {
		bitmap8bit = new unsigned char[Width*Height];
		unsigned char *bm=bitmap8bit;
		unsigned char *o=Org->bitmap8bit;
		for (long i=0;i<Width*Height;i++) {
			*bm=*o;
			o++;
			bm++;
		}
	} else{		
		bitmap = new unsigned short[Width*Height];
		unsigned short *bm=bitmap;
		unsigned short *o=Org->bitmap;
		for (long i=0;i<Width*Height;i++) {
			*bm=*o;
			o++;
			bm++;
		}
	}
}

CImage::CImage(CImage* Org)
{	
	bitmap =NULL;	
	bitmap8bit=NULL;
	bitmap32bit=NULL;
	WinBitmap=NULL;
	Copy(Org);
}

CImage::CImage(unsigned long aWidth,unsigned long aHeight,bool init,unsigned char abitperpixel )
{
	bitperpixel=abitperpixel;
	Width1Bit=0;
	WinBitmap=NULL;
	bitmap=NULL;
	bitmap8bit=NULL;
	bitmap32bit=NULL;
	EffectiveBitPerPixel=abitperpixel;
	NewBitmap(aWidth,aHeight,init);
}

void CImage::NewBitmap(unsigned long aWidth, unsigned long aHeight,bool init)
{
	if (WinBitmap) {
		delete WinBitmap;
		WinBitmap=NULL;
	}
	if (bitmap8bit) delete bitmap8bit;
	bitmap8bit=NULL;
	if (bitmap) delete bitmap;	
	bitmap=NULL;
	if (bitmap32bit) delete bitmap32bit;	
	bitmap32bit=NULL;
	Width=aWidth;
	Height=aHeight;
	if (bitperpixel==1) {
		Width1Bit=Width>>5;
		if ((Width & 0x1F)>0) Width1Bit++;		
		bitmap32bit = new unsigned long[Width1Bit*Height];
		if (init) {
			unsigned long *bm=bitmap32bit;		
			for (long i=0;i<Width1Bit*Height;i++) {
				*bm=0;				
				bm++;
			}
		}		
	} if (bitperpixel==8) {
		bitmap8bit = new unsigned char[Width*Height];
		if (init) {
			unsigned char *h=bitmap8bit;
			for (long j = 0; j < Width*Height; j++) {*h=0;h++;}
		}
	} else {	
		bitmap = new unsigned short[Width*Height];
		if (init) {
			unsigned short *h=bitmap;
			for (long j = 0; j < Width*Height; j++) {*h=0;h++;}
		}
	}
}

CImage::~CImage()
{
	if (bitmap) delete bitmap;
	bitmap=NULL;
	if (bitmap8bit) delete bitmap8bit;
	bitmap8bit=NULL;
	if (bitmap32bit) delete bitmap32bit;
	bitmap32bit=NULL;
	if (WinBitmap) delete WinBitmap;
	WinBitmap=NULL;
}

/////////////////////////////////////////////////////////////////////////////
// CImage message handlers

void CImage::GetWinBitmap(CBitmap*& aBitmap,unsigned long red,unsigned long green,unsigned long blue) {
	if (!WinBitmap) {		
		if (red>255) red=255;				
		if (green>255) green=255;
		if (blue>255) blue=255;
		unsigned long coloring=blue+green*256+red*65536;
		unsigned long  *hbitmap= new unsigned long[Height*Width];
		unsigned short *sb=bitmap;
		unsigned long  *lb=hbitmap;
		for (long i=0;i<Height*Width;i++) {
			unsigned long color=*sb/256;
			if (color>255) color=255;
			*lb=coloring*color/255;
			lb++;
			sb++;
		}
		WinBitmap=new CBitmap();
		WinBitmap->CreateBitmap(Width,Height,1,32,hbitmap);			
		delete hbitmap;
	}
	aBitmap=WinBitmap;
}

void CImage::SaveAsTGA(const char *name)
{
	TGAFile hTGAFile;
	hTGAFile.WriteTGAFile(name,Width,Height,bitmap); 
}

bool CImage::LoadFromTGA(const char *name)
{
	TGAFile hTGAFile;
	return !hTGAFile.ReadTGAFile(name,Width,Height,bitmap); 
}

#include <stdio.h>
#include <io.h>
#include <assert.h>
#include <stdlib.h>
//#include <alloc.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>
#include <dos.h>
//#include <dir.h>

#include "TGA.h"

TGAFile::TGAFile() {
}

TGAFile::WriteTGAFile(const char* name,unsigned long width,unsigned long height,unsigned short *bitmap) {
  int maxpos;
  unsigned char *zeile;
  FILE *stream;
  int open;  
//  struct diskfree_t free;
  //long avail;
  maxpos=width;
  zeile=NULL;
/*  if (_dos_getdiskfree(0, &free)!=0) avail=0; else
  avail=(long) free.avail_clusters
		  * (long) free.bytes_per_sector
		  * (long) free.sectors_per_cluster; */
  long int filesize;
  filesize=width*height*2+18;
  //if (avail<filesize) open=0; else {
	 open=1;
	 stream=fopen(name,"wb");
    putc(0,stream);
    putc(0,stream);
	putc(3,stream);                         /* uncompressed BW */
    putc(0,stream); putc(0,stream);
    putc(0,stream); putc(0,stream);   putc(0,stream);
    putc(0,stream); putc(0,stream);           /* X origin */
    putc(0,stream); putc(0,stream);           /* y origin */
    putc((width & 0x00FF),stream);
    putc((width & 0xFF00) / 256,stream);
    putc((height & 0x00FF),stream);
    putc((height & 0xFF00) / 256,stream);
    putc(16,stream);                        /* 16 bit bitmap */
    putc(0,stream);
	zeile=new unsigned char[2*width];	
	unsigned short* bm=bitmap;
	for (int i=0;i<height;i++) {
		for (int j=0;j<width;j++) {
			zeile[j*2]=(*bm & 0x00FF);
			zeile[j*2+1]=(*bm & 0xFF00) / 256 ;  			
			bm++;
		}
		fwrite(zeile,1,maxpos*2,stream);		
	}
	delete zeile;
	zeile=NULL;
	fclose(stream);
//  }
}

TGAFile::~TGAFile()
{
	//if (zeile) delete zeile;
	//zeile=NULL;
}

bool TGAFile::ReadTGAFile(const char* name,unsigned long &width,unsigned long &height,unsigned short *&bitmap) {
	int hoehe,breite;
	int position;
	unsigned char *zeile;  	
	zeile=NULL;
	position=0;
	FILE* bild;  
	bild=fopen(name,"rb");
	bool error=true;
	if (bild) {    
		error=false;
		error=error || getc(bild)!=0;
		error=error || getc(bild)!=0;
		error=error || getc(bild)!=3;
		for (int i=0;i<9;i++) error=error || getc(bild)!=0;
		unsigned char help1=getc(bild);//inforce read order
		unsigned char help2=getc(bild);		
		breite=help1+help2*256;
		help1=getc(bild);
		help2=getc(bild);				
		hoehe=help1+help2*256;		
		error=error || getc(bild)!=16;
		error=error || getc(bild)!=0;    
		if (error) fclose(bild);		
		else  {
			zeile=new unsigned char[2*breite];		
			width=breite;
			height=hoehe;
			if (bitmap) delete bitmap;
			bitmap = new unsigned short[width*height];		
			unsigned short* bm=bitmap;
			for (int i=0;i<height;i++) {			
				fread(zeile,1,2*width,bild);
				for (int j=0;j<width;j++) {				
					*bm=zeile[j*2]+zeile[j*2+1]*256;  				
					bm++;
				}						
			} 
			fclose(bild);  
			delete zeile;  
			zeile=NULL;
		}	 	
	}
	return error;
};

void CImage::SaveAsBMP(const char *name,CRect Selection)
{
	CRect Sel=Selection;
	if (Sel.IsRectEmpty()) {
		Sel.left=0;
		Sel.right=Width-1;
		Sel.top=0;
		Sel.bottom=Height-1;
	}
	if (Sel.right>Width) Sel.right=Width-1;
	if (Sel.bottom>Height) Sel.bottom=Height-1;
	if ((Sel.left<0) || (Sel.left>Sel.right)) Sel.left=0;
	if ((Sel.top<0) || (Sel.top>Sel.bottom)) Sel.top=0;	
	int BMPWidth=Sel.right-Sel.left+1;
	int BMPHeight=Sel.bottom-Sel.top+1;
	if (bitperpixel==1) { 
		COLORREF ColorTab[2];
		ColorTab[0]=RGB(0,0,0);		
		ColorTab[1]=RGB(255,255,255);		
		WriteBMPFile BMP=WriteBMPFile::WriteBMPFile(name,BMPWidth,BMPHeight,2,ColorTab,true);	
		unsigned char byte=0;
		unsigned char PixelNr=0;
		for (int y=Sel.top;y<=Sel.bottom;y++) {
			for (int x=Sel.left;x<=Sel.right;x++) {
				if (GetPixel1Bit(x,Sel.bottom-(y-Sel.top))) byte|=0x80 >> PixelNr;
				PixelNr++;
				if (PixelNr==8) {
					BMP.Pixel(byte);			
					PixelNr=0;
					byte=0;
				}
			}
			if (PixelNr!=0) BMP.Pixel(byte);			
			PixelNr=0;
			byte=0;			
			BMP.WriteLine();
			BMP.NewLine();
		}
	} else {
		COLORREF ColorTab[256];
		for (int i=0;i<256;i++) 
			ColorTab[i]=RGB(i,i,i);		
		WriteBMPFile BMP=WriteBMPFile::WriteBMPFile(name,BMPWidth,BMPHeight,256,ColorTab);	
		if (bitperpixel==16) {
			for (int y=Sel.top;y<=Sel.bottom;y++) {
				for (int x=Sel.left;x<=Sel.right;x++) {
					BMP.Pixel(bitmap[x+(Sel.bottom-(y-Sel.top))*Width]/256);			
				}
				BMP.WriteLine();
				BMP.NewLine();
			}
		} else {
			for (int y=Sel.top;y<=Sel.bottom;y++) {
				for (int x=Sel.left;x<=Sel.right;x++) {
					BMP.Pixel(bitmap8bit[x+(Sel.bottom-(y-Sel.top))*Width]);			
				}
				BMP.WriteLine();
				BMP.NewLine();
			}
		}
	}
}

bool CImage::LoadFromBMP(const char *name,int LoadingMode,bool blackwhite)
{
	COLORREF ColorTab[256];
	ReadBMPFile BMP=ReadBMPFile::ReadBMPFile(name,ColorTab,blackwhite);
	if (!BMP.Ok()) return false;
	if (WinBitmap) delete WinBitmap;
	WinBitmap=NULL;
				
	if (bitperpixel==1) { 
		if ((((Width<BMP.getBreite()) || (Height<BMP.getHoehe())) && (LoadingMode==0)) || (bitmap32bit==NULL)) {
			if (bitmap32bit) delete bitmap32bit;
			bitmap32bit=NULL;
			NewBitmap(BMP.getBreite(),BMP.getHoehe(),false);
		}
		unsigned char byte=0;
		unsigned char PixelNr=0;		
		int hoehe=BMP.getHoehe()-1;
		for (int y=0;y<BMP.getHoehe();y++) {
			for (int x=0;x<BMP.getBreite();x++) {		
				if (PixelNr==0) byte=BMP.getPixel(x/8);							
				SetPixel1Bit(x,hoehe-y,(byte & (0x80 >> PixelNr))>0);
				PixelNr++;
				if (PixelNr==8) PixelNr=0;					
			}			
			PixelNr=0;						
			if (y<BMP.getHoehe()-1) BMP.HoleZeile();		
		}
	} else if (bitperpixel==8) {
		if ((((Width<BMP.getBreite()) || (Height<BMP.getHoehe())) && (LoadingMode==0)) || (bitmap8bit==NULL)) {
			if (bitmap8bit) delete bitmap8bit;
			bitmap8bit=NULL;
			NewBitmap(BMP.getBreite(),BMP.getHoehe(),false);
		}
		int minwidth=(Width<BMP.getBreite()) ? Width : BMP.getBreite();		
		int hoehe=BMP.getHoehe()-1;
		for (int y=0;y<BMP.getHoehe();y++) {
			for (int x=0;x<minwidth;x++) {
				if (((hoehe-y)<Height) && (x<Width)) {				
					bitmap8bit[x+(hoehe-y)*Width]=BMP.getPixel(x);			
				}
			}
			if (y<BMP.getHoehe()-1) BMP.HoleZeile();		
		}
	} else {
		if ((((Width<BMP.getBreite()) || (Height<BMP.getHoehe())) && (LoadingMode==0)) || (bitmap==NULL)) {
			if (bitmap) delete bitmap;
			bitmap=NULL;
			NewBitmap(BMP.getBreite(),BMP.getHoehe(),false);
		}
		int minwidth=(Width<BMP.getBreite()) ? Width : BMP.getBreite();		
		int hoehe=BMP.getHoehe()-1;
		for (int y=0;y<BMP.getHoehe();y++) {
			for (int x=0;x<minwidth;x++) {
				if (((hoehe-y)<Height) && (x<Width)) {				
					bitmap[x+(hoehe-y)*Width]=BMP.getPixel(x)*256;			
				}
			}
			if (y<BMP.getHoehe()-1) BMP.HoleZeile();		
		}
	}
	if (LoadingMode==2) {
		if (BMP.getBreite()<Width) {
			unsigned short Source;
			unsigned short Dest;
			unsigned short maxy=(Height<BMP.getHoehe()) ? Height : BMP.getHoehe();
			for (unsigned short y=0;y<maxy;y++) {
				Source=0;
				Dest=BMP.getBreite();
				while (Dest<Width) {
					SetPixel16Bit(Dest,y,GetPixel16Bit(Source,y));
					Dest++;
					Source++;
				}				
			}
		}
		if (BMP.getHoehe()<Height) {
			unsigned short Source;
			unsigned short Dest;
			for (unsigned short x=0;x<Width;x++) {
				Source=0;
				Dest=BMP.getHoehe();
				while (Dest<Height) {
					SetPixel16Bit(x,Dest,GetPixel16Bit(x,Source));
					Dest++;
					Source++;
				}				
			}
		}
	}
	return true;
}














#include <stdio.h>
#include <io.h>
#include <stdlib.h>
//#include <alloc.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>
#include <dos.h>
//#include <dir.h>

#include "bmp.h"

WriteBMPFile::WriteBMPFile(const char* name,long int width, long int height,long int colors,COLORREF *palette, bool blackwhite) {
//  struct diskfree_t free;
  zeile=NULL;
//  if (_dos_getdiskfree(0, &free)!=0) avail=0;
//  else avail=(long) free.avail_clusters
//		  * (long) free.bytes_per_sector
//		  * (long) free.sectors_per_cluster;
  long int filesize,datasize;
  long int dataoffset,infoheaderlen,longbuffer;
  short int nullint=0;
  long int pixelwidth=width;
  if (blackwhite) {
		width/=8;
		if (width*8!=pixelwidth) width++;
  }
  modwidth = ( 4 - width % 4 )%4;
  datasize=(width+modwidth)*height;
  dataoffset=14+40+colors*4;
  filesize=datasize+dataoffset;
//  if (avail<filesize) open=0; else {
	 open=1;
	 stream=fopen(name,"wb");
	 if (!stream) return;
	 fprintf(stream,"BM");
	 fwrite(&filesize,sizeof(long int),1, stream);
	 fwrite(&nullint,sizeof(short int),1, stream);
	 fwrite(&nullint,sizeof(short int),1, stream);
	 fwrite(&dataoffset,sizeof(long int),1, stream);
	 infoheaderlen=40;
	 fwrite(&infoheaderlen,sizeof(long int),1, stream);
	 fwrite(&pixelwidth,sizeof(long int),1, stream);
	 fwrite(&height,sizeof(long int),1, stream);
	 nullint=1;
	 fwrite(&nullint,sizeof(short int),1, stream);
	 if (blackwhite) nullint=1;
	 else nullint=8;
	 fwrite(&nullint,sizeof(short int),1, stream);
	 nullint=0;
	 longbuffer=0;
	 fwrite(&longbuffer,sizeof(long int),1, stream);
	 fwrite(&datasize,sizeof(long int),1, stream);
	 longbuffer=0;
	 fwrite(&longbuffer,sizeof(long int),1, stream);
	 fwrite(&longbuffer,sizeof(long int),1, stream);
	 fwrite(&colors,sizeof(long int),1, stream);
	 fwrite(&colors,sizeof(long int),1, stream);
	 for (int i=0;i<colors;i++) {
		unsigned char red=GetRValue(palette[i]);
		unsigned char green=GetGValue(palette[i]);
		unsigned char blue=GetBValue(palette[i]);
		unsigned char nullchar=0;
		fwrite(&blue,1,1,stream);
		fwrite(&green,1,1,stream);
		fwrite(&red,1,1,stream);
		fwrite(&nullchar,1,1,stream);
	 }
	 zeile=(unsigned char *)malloc(width);
	 pos=0;
	 maxpos=width;
//  }
}

WriteBMPFile::~WriteBMPFile() {
  if (zeile!=NULL) free(zeile);
  if (open) fclose(stream);
}

void WriteBMPFile::Pixel(unsigned char col) {
  if (pos<maxpos) {
	 zeile[pos]=col;
	 pos++;
  }
}

void WriteBMPFile::WriteLine() {
  if (open) fwrite(zeile,1,maxpos,stream);
  ZeileAuffuellen();
}

void WriteBMPFile::NewLine() {
  pos=0;
}

void WriteBMPFile::ZeileAuffuellen() {
  unsigned char nullbyte=0;
  int x;
  if (open) for (x=0;x<modwidth;x++)  fwrite(&nullbyte,sizeof(char),1,stream);
}


//*** BMPZeile ***//
ReadBMPFile::ReadBMPFile(const char *filename,COLORREF *palette,bool blackwhite) {
  unsigned char *headerbuffer;
  char string[256];
  long int longbuffer[1];
  long int *lwidth, *lheight, *pcolors;

  position=0;
  offen=0;
  bild=fopen(filename,"rb");
  ok=0;
  zeile = NULL;
  puffer = NULL;
  if (bild) {
	 offen=1;
    ok=1;
	 fread(string,1,10,bild);
	 if (strncmp(string,"BM",2)==0) {
		fread(longbuffer,sizeof(long int),1,bild);
		headerbuffer=(unsigned char*)malloc(*longbuffer);
		fread(headerbuffer,1,(size_t)40/*(*longbuffer)-14-1024*/,bild);
		pcolors=(long int *)(headerbuffer+32);
		colors=*pcolors;

		if (blackwhite) colors=2; else colors=256; //why enforcement?
		
		for (int i=0;i<colors;i++) {
		  unsigned char red;
		  unsigned char green;
		  unsigned char blue;
		  unsigned char nullchar;
		  fread(&blue,1,1,bild);
		  fread(&green,1,1,bild);
		  fread(&red,1,1,bild);
		  fread(&nullchar,1,1,bild);
		  if (i<256) palette[i]=RGB(red,green,blue);
		}
		lwidth=(long int *)(headerbuffer+4);
		lheight=(long int *)(headerbuffer+8);
		breite = (int)(*lwidth);
		hoehe = (int)(*lheight);
		pixelwidth=breite;
		if (blackwhite) {
			breite/=8;
			if (breite*8!=pixelwidth) breite++;
		}
		modweite = ( 4 - breite % 4 )%4;		
		free(headerbuffer);
		zeile=(unsigned char *)malloc(breite+modweite);
		if ((double(breite)+double(modweite))*double(hoehe)<65000.0) {
		  puffer=(unsigned char *)malloc((breite+modweite)*hoehe);
		  fread(puffer,1,(breite+modweite)*hoehe,bild);
		  fclose(bild);
		  offen=0;
		} else puffer=NULL;
		HoleZeile();
	 } else {
		fclose(bild);
		offen=0;
	 }
  }
};

ReadBMPFile::~ReadBMPFile(void) {
  if (offen) fclose(bild);
  offen=0;
  if (zeile) free(zeile);
  if (puffer) free(puffer);
}

void ReadBMPFile::HoleZeile(void) {
  if (offen) fread(zeile,1,breite+modweite,bild);
  else for (int i=0;i<breite;i++) zeile[i]=puffer[position*(breite+modweite)+i];
  position++;
}

int ReadBMPFile::eof() {
  return (position>hoehe);
}

void CImage::GetHistogram(CHistogram *Histogram)
{
	unsigned short *bm=bitmap;
	for (int i=0;i<256;i++) Histogram->statistic[i]=0;
	for (long x=0;x<Width*Height;x++) {
		unsigned char help=*bm/256;
		Histogram->statistic[help]++;
		bm++;
	}
	Histogram->Total=Width*Height;
}

void CImage::CountBlackAndWhitePixel(unsigned long x1, unsigned long y1, unsigned long x2, unsigned long y2,unsigned long &NrBlack, unsigned long &NrWhite)
{
	NrBlack=0;
	NrWhite=0;
	if (x1>Width) x1=Width;
	if (x2>Width) x2=Width;
	if (y1>Height) y1=Height;
	if (y2>Height) y2=Height;
	for (int x=x1;x<x2;x++) for (int y=y1;y<y2;y++) {
		if (bitmap[x+y*Width]>32000) NrWhite++; else NrBlack++;
	}
}

void CImage::FillRegion(unsigned long x1, unsigned long y1, unsigned long x2, unsigned long y2,unsigned short color) {
	if (x1>Width) x1=Width;
	if (x2>Width) x2=Width;
	if (y1>Height) y1=Height;
	if (y2>Height) y2=Height;
	for (int x=x1;x<x2;x++) for (int y=y1;y<y2;y++) bitmap[x+y*Width]=color;	
}



/*******************************************************************
 * Function : floodFill
 * --------------------
 * A recursive algorithm for filling a region with a specified
 * fill color. The floodFill routine is initially passed a seed point
 * with an oldColor specified (the color to be replaced). At each
 * iteration, check to make sure the oldColor is at the present
 * (x, y) location. Also check that the (x, y) coordinate lies within
 * the frame buffer drawing region using the macros VALID_X() and
 * VALID_Y(). The third necessary condition to check is that the
 * current fillColor and the color to be replaced aren't the same.
 *
 * The recursion comes into play by visiting the 4-connected
 * neighbors of every (x, y) coordinate passed in.
 *******************************************************************/
const unsigned long StackSize=7000000;
unsigned short* StackX=NULL;	
unsigned short* StackY=NULL;	
unsigned char* StackDir=NULL;
unsigned short* MetaStackX=NULL;	
unsigned short* MetaStackY=NULL;	
unsigned char* MetaStackDir=NULL;

void CreateFloodFillStack(int bitperpixel)
{
	if (StackX==NULL) {
		StackX = new unsigned short[StackSize];	
		StackY = new unsigned short[StackSize];	
		StackDir = new unsigned char[StackSize];
	}
	if (bitperpixel==1) {
		if (MetaStackX==NULL) {
			MetaStackX = new unsigned short[StackSize];	
			MetaStackY = new unsigned short[StackSize];	
			MetaStackDir = new unsigned char[StackSize];
		}
	}
}

void DeleteFloodFillStack(int bitperpixel)
{
	if (StackX!=NULL) {
		delete StackX;
		StackX=NULL;
		delete StackY;
		StackY=NULL;
		delete StackDir;
		StackDir=NULL;
	}
	if (bitperpixel==1) {
		if (MetaStackX!=NULL) {
			delete MetaStackX;
			MetaStackX=NULL;
			delete MetaStackY;
			MetaStackY=NULL;
			delete MetaStackDir;
			MetaStackDir=NULL;
		}
	}
}

void CImage::FloodFillWithBlack1Bit(unsigned short x0, unsigned short y0, unsigned long &count)
//fills a white area black until finding a black boundary
//used to fill small dirt spots
{
	if ((x0>Width) || (y0>Height)) return;
	count=0;		
//	unsigned short* StackX = new unsigned short[StackSize];	
//	unsigned short* StackY = new unsigned short[StackSize];	
//	unsigned char* StackDir = new unsigned char[StackSize];	
	unsigned long StackPos=1;
	unsigned long MetaStackPos=0;
	StackX[StackPos]=x0;
	StackY[StackPos]=y0;
	StackDir[StackPos]=0;
	unsigned short x,y;
	unsigned char dir;
	unsigned long pos,x1bit;
	unsigned long subx;
	while (((MetaStackPos>0) && (MetaStackPos<(StackSize-10))) || ((StackPos>0) && (StackPos<(StackSize-10)))) {		
		if (MetaStackPos==0) {
			x=StackX[StackPos];
			y=StackX[StackPos];
			dir=StackDir[StackPos];
			StackPos--;
			count++;		
			x1bit=(x>>5);
			pos=x1bit+y*Width1Bit;		
			subx=(1 << (x & 0x1f));
			bitmap32bit[pos]^=subx;
			count++;	
			if ((dir!=4) && (y>0) && GetPixel1Bit(x,y-1)) {  //for up, down no metapixel test, at least for the instance
				StackPos++;
				StackX[StackPos]=x;
				StackY[StackPos]=y-1;
				StackDir[StackPos]=3;										
			}
			if ((dir!=3) && (y<(Height-1)) && GetPixel1Bit(x,y+1)) {			
				StackPos++;
				StackX[StackPos]=x;
				StackY[StackPos]=y+1;
				StackDir[StackPos]=4;							
			}
			if (subx==0) {				      
				//metapixel test to the right
				if (((x1bit+1)<Width1Bit) && (bitmap32bit[pos+1]==0xFFFFFFFF)) {
					//metapixelfloodfill
					MetaStackPos++;
					MetaStackX[StackPos]=x1bit+1;
					MetaStackY[StackPos]=y;
					MetaStackDir[StackPos]=2+4;								
				} else {
					if ((dir!=1) && (x<(Width-1)) && GetPixel1Bit(x+1,y)) {			
						StackPos++;
						StackX[StackPos]=x+1;
						StackY[StackPos]=y;
						StackDir[StackPos]=2;									
					}
				}
			} else {
				if ((dir!=1) && (x<(Width-1)) && GetPixel1Bit(x+1,y)) {			
					StackPos++;
					StackX[StackPos]=x+1;
					StackY[StackPos]=y;
					StackDir[StackPos]=2;								
				}
			}
			if (subx==0x80000000) {
				//metapixel test to the right
				if ((x1bit>0) && (bitmap32bit[pos-1]==0xFFFFFFFF)) {
					//metapixelfloodfill
					MetaStackPos++;				
					MetaStackX[StackPos]=x1bit-1;
					MetaStackY[StackPos]=y;
					MetaStackDir[StackPos]=1+4;								
				} else {
					if ((dir!=2) && (x>0) && GetPixel1Bit(x-1,y)) {
						StackPos++;
						StackX[StackPos]=x-1;
						StackY[StackPos]=y;
						StackDir[StackPos]=1;									
					}
				}
			} else {		
				if ((dir!=2) && (x>0) && GetPixel1Bit(x-1,y)) {
					StackPos++;
					StackX[StackPos]=x-1;
					StackY[StackPos]=y;
					StackDir[StackPos]=1;								
				}
			}			
		} else {
			//metafloodfill		
			x=MetaStackX[StackPos];
			y=MetaStackX[StackPos];
			dir=MetaStackDir[StackPos];
			StackPos--;
			pos=x+y*Width1Bit;
			bitmap32bit[pos]=0;
			count+=32;		//that's it: a gain in speed of a factor 32!
			if ((dir!=4+1) && (x+1<Width1Bit)) { //came not from right -> metapixel test to the right
				if (bitmap32bit[pos+1]==0xFFFFFFFF) {
					//metapixelfloodfill
					MetaStackPos++;				
					MetaStackX[StackPos]=x+1;
					MetaStackY[StackPos]=y;
					MetaStackDir[StackPos]=2+4;								
				} else {
					x=(x+1)*32;  //convert to pixelcoord
					if (x<Width) {
						if (dir==4+2) {  //came from left -> Check leftmost pixel						
							if (GetPixel1Bit(x,y)) {
								StackPos++;
								StackX[StackPos]=x;
								StackY[StackPos]=y;
								StackDir[StackPos]=2;														
							}
						} else {  //came from below or above-> have to check all pixels
							dir-=4;
							for (int i=x;i<x+32;i++) {
								if (GetPixel1Bit(i,y)) {
									StackPos++;
									StackX[StackPos]=i;
									StackY[StackPos]=y;
									StackDir[StackPos]=dir;															
								}
							}
						}
					} 
				}
			}			
			if ((dir!=4+2) && (x>0)) { //came not from left -> metapixel test to the left
				if (bitmap32bit[pos-1]==0xFFFFFFFF) {
					//metapixelfloodfill
					MetaStackPos++;				
					MetaStackX[StackPos]=x-1;
					MetaStackY[StackPos]=y;
					MetaStackDir[StackPos]=1+4;								
				} else {
					x=(x-1)*32;  //convert to pixelcoord
					if (dir==4+1) {  //came from right -> Check rightmost pixel						
						x+=31;
						if (GetPixel1Bit(x,y)) {
							StackPos++;
							StackX[StackPos]=x;
							StackY[StackPos]=y;
							StackDir[StackPos]=1;													
						}
					} else {  //came from below or above-> have to check all pixels
						dir-=4;
						for (int i=x;i<x+32;i++) {
							if (GetPixel1Bit(i,y)) {
								StackPos++;
								StackX[StackPos]=i;
								StackY[StackPos]=y;
								StackDir[StackPos]=dir;														
							}
						}
					} 
				}
			}

			if ((dir!=4+4) && (y>0)) { //came not from above -> metapixel test above
				if (bitmap32bit[pos-Width1Bit]==0xFFFFFFFF) {
					//metapixelfloodfill
					StackPos++;
					StackX[StackPos]=x;
					StackY[StackPos]=y-1;
					StackDir[StackPos]=3+4;												
				} else {
					x=x*32;  
					y--;
					 //have to check all pixels					
					for (int i=x;i<x+32;i++) {
						if (GetPixel1Bit(i,y)) {
							StackPos++;
							StackX[StackPos]=i;
							StackY[StackPos]=y;
							StackDir[StackPos]=3;							
						}
					} 
				}
			}

			if ((dir!=4+3) && (y<Height)) { //came not from below -> metapixel test below
				if (bitmap32bit[pos+Width1Bit]==0xFFFFFFFF) {
					//metapixelfloodfill
					StackPos++;
					StackX[StackPos]=x;
					StackY[StackPos]=y+1;
					StackDir[StackPos]=4+4;												
				} else {
					x=x*32;  //convert to pixelcoord
					y++;
					 //have to check all pixels					
					for (int i=x;i<x+32;i++) {
						if (GetPixel1Bit(i,y)) {
							StackPos++;
							StackX[StackPos]=i;
							StackY[StackPos]=y;
							StackDir[StackPos]=4;													
						}
					} 
				}
			}			
		}		
	}
	if (MetaStackPos>=(StackSize-10)) {
		while (MetaStackPos>0) {
			x=StackX[MetaStackPos];
			y=StackY[MetaStackPos];			
			bitmap32bit[x+y*Width1Bit]=0;
			MetaStackPos--;
			count+=32;		
		}
	}
	if (StackPos>=(StackSize-10)) {
		while (StackPos>0) {
			x=StackX[StackPos];
			y=StackY[StackPos];						
			SetPixel1BitBlack(x,y);			
			StackPos--;
			count++;		
		}
	}	
}

void CImage::FloodFill(unsigned long x, unsigned long y, unsigned short color, unsigned long &count)
{	
	if (bitperpixel==16) FloodFill16Bit(x,y,color,count);
	else if (bitperpixel==8) FloodFill8Bit(x,y,color/256,count);
}

void CImage::FloodFill16Bit(unsigned long x, unsigned long y, unsigned short color, unsigned long &count) {
	if ((x>Width) || (y>Height) || (bitperpixel!=16)) return;
	bool StackCreated=false;
	if (StackX==NULL) {
		CreateFloodFillStack(bitperpixel); 
		StackCreated=true; 
	}
	unsigned long ff_StackPos;
	unsigned long ff_count;
	unsigned short ff_color;

	ff_count=0;
	ff_color=color;
	unsigned int hx=x;
	unsigned int hy=y;
	ff_StackPos=1;
	StackX[1]=hx;
	StackY[1]=hy;
	StackDir[1]=0;
	unsigned char dir;
	while ((ff_StackPos>0) && (ff_StackPos<(StackSize-10))) {
		hx=StackX[ff_StackPos];
		hy=StackY[ff_StackPos];
		dir=StackDir[ff_StackPos];
		SetPixel16Bit(hx,hy,ff_color);
		ff_count++;					
		if ((dir!=1) && (hx>0) && ((GetPixel16Bit(hx-1,hy)!=ff_color))) {
			StackX[ff_StackPos]=hx-1;
			StackY[ff_StackPos]=hy;
			StackDir[ff_StackPos]=2;
			ff_StackPos++;
		}
		if ((dir!=2) && (hx<Width-1) && ((GetPixel16Bit(hx+1,hy)!=ff_color))) {
			StackX[ff_StackPos]=hx+1;
			StackY[ff_StackPos]=hy;
			StackDir[ff_StackPos]=1;
			ff_StackPos++;
		}
		if ((dir!=3) && (hy>0) && ((GetPixel16Bit(hx,hy-1)!=ff_color))) {
			StackX[ff_StackPos]=hx;
			StackY[ff_StackPos]=hy-1;
			StackDir[ff_StackPos]=4;
			ff_StackPos++;
		}
		if ((dir!=4) && (hy<Height-1) && ((GetPixel16Bit(hx,hy+1)!=ff_color))) {
			StackX[ff_StackPos]=hx;
			StackY[ff_StackPos]=hy+1;
			StackDir[ff_StackPos]=3;
			ff_StackPos++;
		}							
		ff_StackPos--;
	}
	if (ff_StackPos>=(StackSize-10)) {
		while (ff_StackPos>0) {
			hx=StackX[ff_StackPos];
			hy=StackY[ff_StackPos];
			SetPixel16Bit(hx,hy,ff_color);
			ff_StackPos--;
		}
	}
	count=ff_count;			
	if (StackCreated) DeleteFloodFillStack(bitperpixel);
}

void CImage::FloodFill8Bit(unsigned long x, unsigned long y, unsigned short color, unsigned long &count) {
	if ((x>Width) || (y>Height) || (bitperpixel!=8)) return;
	bool StackCreated=false;
	if (StackX==NULL) {
		CreateFloodFillStack(bitperpixel); 
		StackCreated=true; 
	}
	unsigned long ff_StackPos;
	unsigned long ff_count;
	unsigned short ff_color;

	ff_count=0;
	ff_color=color;
	unsigned int hx=x;
	unsigned int hy=y;
	ff_StackPos=1;
	StackX[1]=hx;
	StackY[1]=hy;
	StackDir[1]=0;
	unsigned char dir;
	while ((ff_StackPos>0) && (ff_StackPos<(StackSize-10))) {
		hx=StackX[ff_StackPos];
		hy=StackY[ff_StackPos];
		dir=StackDir[ff_StackPos];
		SetPixel8Bit(hx,hy,ff_color);
		ff_count++;					
		if ((dir!=1) && (hx>0) && ((GetPixel8Bit(hx-1,hy)!=ff_color))) {
			StackX[ff_StackPos]=hx-1;
			StackY[ff_StackPos]=hy;
			StackDir[ff_StackPos]=2;
			ff_StackPos++;
		}
		if ((dir!=2) && (hx<Width-1) && ((GetPixel8Bit(hx+1,hy)!=ff_color))) {
			StackX[ff_StackPos]=hx+1;
			StackY[ff_StackPos]=hy;
			StackDir[ff_StackPos]=1;
			ff_StackPos++;
		}
		if ((dir!=3) && (hy>0) && ((GetPixel8Bit(hx,hy-1)!=ff_color))) {
			StackX[ff_StackPos]=hx;
			StackY[ff_StackPos]=hy-1;
			StackDir[ff_StackPos]=4;
			ff_StackPos++;
		}
		if ((dir!=4) && (hy<Height-1) && ((GetPixel8Bit(hx,hy+1)!=ff_color))) {
			StackX[ff_StackPos]=hx;
			StackY[ff_StackPos]=hy+1;
			StackDir[ff_StackPos]=3;
			ff_StackPos++;
		}							
		ff_StackPos--;
	}
	if (ff_StackPos>=(StackSize-10)) {
		while (ff_StackPos>0) {
			hx=StackX[ff_StackPos];
			hy=StackY[ff_StackPos];
			SetPixel8Bit(hx,hy,ff_color);
			ff_StackPos--;
		}
	}
	count=ff_count;			
	if (StackCreated) DeleteFloodFillStack(bitperpixel);
}

void CImage::InvertFloodFill(unsigned long x, unsigned long y, unsigned short fillcolor, unsigned short surfacecolor,unsigned long &count) {
	if (bitperpixel==16) InvertFloodFill16Bit(x,y,fillcolor,surfacecolor,count);
	else if (bitperpixel==8) InvertFloodFill8Bit(x,y,fillcolor/256,surfacecolor/256,count);
}

void CImage::InvertFloodFill16Bit(unsigned long x, unsigned long y, unsigned short fillcolor, unsigned short surfacecolor,unsigned long &count)
{
	if ((x>Width) || (y>Height) || (bitperpixel!=16)) return;
	bool StackCreated=false;
	if (StackX==NULL) {
		CreateFloodFillStack(bitperpixel); 
		StackCreated=true; 
	}
	unsigned long ff_StackPos;
	unsigned long ff_count;
	unsigned short ff_color;

	ff_count=0;
	ff_color=surfacecolor;
	unsigned int hx=x;
	unsigned int hy=y;
	ff_StackPos=1;
	StackX[1]=hx;
	StackY[1]=hy;
	StackDir[1]=0;
	unsigned char dir;
	while ((ff_StackPos>0) && (ff_StackPos<(StackSize-10))) {
		hx=StackX[ff_StackPos];
		hy=StackY[ff_StackPos];
		dir=StackDir[ff_StackPos];
		SetPixel16Bit(hx,hy,fillcolor);
		ff_count++;			
		if (ff_count>StackSize) {
			double a=1110;
		}
		if ((dir!=1) && (hx>0) && ((GetPixel16Bit(hx-1,hy)==ff_color))) {
			StackX[ff_StackPos]=hx-1;
			StackY[ff_StackPos]=hy;
			StackDir[ff_StackPos]=2;
			ff_StackPos++;
		}
		if ((dir!=2) && (hx<Width-1) && ((GetPixel16Bit(hx+1,hy)==ff_color))) {
			StackX[ff_StackPos]=hx+1;
			StackY[ff_StackPos]=hy;
			StackDir[ff_StackPos]=1;
			ff_StackPos++;
		}
		if ((dir!=3) && (hy>0) && ((GetPixel16Bit(hx,hy-1)==ff_color))) {
			StackX[ff_StackPos]=hx;
			StackY[ff_StackPos]=hy-1;
			StackDir[ff_StackPos]=4;
			ff_StackPos++;
		}
		if ((dir!=4) && (hy<Height-1) && ((GetPixel16Bit(hx,hy+1)==ff_color))) {
			StackX[ff_StackPos]=hx;
			StackY[ff_StackPos]=hy+1;
			StackDir[ff_StackPos]=3;
			ff_StackPos++;
		}							
		ff_StackPos--;
	}
	if (ff_StackPos>=(StackSize-10)) {
		while (ff_StackPos>0) {
			hx=StackX[ff_StackPos];
			hy=StackY[ff_StackPos];
			SetPixel16Bit(hx,hy,fillcolor);
			ff_StackPos--;
		}
	}
	count=ff_count;		
	if (StackCreated) DeleteFloodFillStack(bitperpixel);	
}

void CImage::InvertFloodFill8Bit(unsigned long x, unsigned long y, unsigned short fillcolor, unsigned short surfacecolor,unsigned long &count)
{
	if ((x>Width) || (y>Height) || (bitperpixel!=8)) return;
	bool StackCreated=false;
	if (StackX==NULL) {
		CreateFloodFillStack(bitperpixel); 
		StackCreated=true; 
	}
	unsigned long ff_StackPos;
	unsigned long ff_count;
	unsigned short ff_color;

	ff_count=0;
	ff_color=surfacecolor;
	unsigned int hx=x;
	unsigned int hy=y;
	ff_StackPos=1;
	StackX[1]=hx;
	StackY[1]=hy;
	StackDir[1]=0;
	unsigned char dir;
	while ((ff_StackPos>0) && (ff_StackPos<(StackSize-10))) {
		hx=StackX[ff_StackPos];
		hy=StackY[ff_StackPos];
		dir=StackDir[ff_StackPos];
		SetPixel8Bit(hx,hy,fillcolor);
		ff_count++;			
		if (ff_count>StackSize) {
			double a=1110;
		}
		if ((dir!=1) && (hx>0) && ((GetPixel8Bit(hx-1,hy)==ff_color))) {
			StackX[ff_StackPos]=hx-1;
			StackY[ff_StackPos]=hy;
			StackDir[ff_StackPos]=2;
			ff_StackPos++;
		}
		if ((dir!=2) && (hx<Width-1) && ((GetPixel8Bit(hx+1,hy)==ff_color))) {
			StackX[ff_StackPos]=hx+1;
			StackY[ff_StackPos]=hy;
			StackDir[ff_StackPos]=1;
			ff_StackPos++;
		}
		if ((dir!=3) && (hy>0) && ((GetPixel8Bit(hx,hy-1)==ff_color))) {
			StackX[ff_StackPos]=hx;
			StackY[ff_StackPos]=hy-1;
			StackDir[ff_StackPos]=4;
			ff_StackPos++;
		}
		if ((dir!=4) && (hy<Height-1) && ((GetPixel8Bit(hx,hy+1)==ff_color))) {
			StackX[ff_StackPos]=hx;
			StackY[ff_StackPos]=hy+1;
			StackDir[ff_StackPos]=3;
			ff_StackPos++;
		}							
		ff_StackPos--;
	}
	if (ff_StackPos>=(StackSize-10)) {
		while (ff_StackPos>0) {
			hx=StackX[ff_StackPos];
			hy=StackY[ff_StackPos];
			SetPixel8Bit(hx,hy,fillcolor);
			ff_StackPos--;
		}
	}
	count=ff_count;		
	if (StackCreated) DeleteFloodFillStack(bitperpixel);	
}

bool CImage::IsFrontierPoint8Bit(unsigned short hx,unsigned short hy) {
	bool found=false;
	if (GetPixel8Bit(hx,hy)==0) { //ok side of frontier and untested point		
		if (hx>0) {  //left side			
			found=true;
			if (GetPixel8Bit(hx-1,hy)==255) {				
			} else if ((hy<Height-1) && (GetPixel8Bit(hx-1,hy+1)==255)) {				
			} else if ((hy>0) && (GetPixel8Bit(hx-1,hy-1)==255)) {				
			} else found=false;
		} 
		if (!found) { //middle
			found=true;
			if ((hy<Height-1) && (GetPixel8Bit(hx,hy+1)==255)) {								
			} else if ((hy>0) && (GetPixel8Bit(hx,hy-1)==255)) {								
			} else found=false;
		}
		if ((!found) && (hx<Width-1)) {//right
			found=true;
			if (GetPixel8Bit(hx+1,hy)==255) {				
			} else if ((hy<Height-1) && (GetPixel8Bit(hx+1,hy+1)==255)) {				
			} else if ((hy>0) && (GetPixel8Bit(hx+1,hy-1)==255)) {				
			} else found=false;
		}		
	}
	return found;
}

bool CImage::IsFrontierPoint16Bit(unsigned short hx,unsigned short hy) {
	bool found=false;
	if (GetPixel16Bit(hx,hy)==0) { //ok side of frontier and untested point		
		if (hx>0) {  //left side			
			found=true;
			if (GetPixel16Bit(hx-1,hy)==65535) {				
			} else if ((hy<Height-1) && (GetPixel16Bit(hx-1,hy+1)==65535)) {				
			} else if ((hy>0) && (GetPixel16Bit(hx-1,hy-1)==65535)) {				
			} else found=false;
		} 
		if (!found) { //middle
			found=true;
			if ((hy<Height-1) && (GetPixel16Bit(hx,hy+1)==65535)) {								
			} else if ((hy>0) && (GetPixel16Bit(hx,hy-1)==65535)) {								
			} else found=false;
		}
		if ((!found) && (hx<Width-1)) {//right
			found=true;
			if (GetPixel16Bit(hx+1,hy)==65535) {				
			} else if ((hy<Height-1) && (GetPixel16Bit(hx+1,hy+1)==65535)) {				
			} else if ((hy>0) && (GetPixel16Bit(hx+1,hy-1)==65535)) {				
			} else found=false;
		}		
	}
	return found;
}

void CImage::GetFrontier(CPoint StartPos,CPoint &Left,CPoint &Right,unsigned short Range,CArray<POINT,POINT> *Frontier,unsigned long &count) {
	if (bitperpixel==16) GetFrontier16Bit(StartPos,Left,Right,Range,Frontier,count);
	else if (bitperpixel==8) GetFrontier8Bit(StartPos,Left,Right,Range,Frontier,count);
} 

void CImage::GetFrontier16Bit(CPoint StartPos,CPoint &Left,CPoint &Right,unsigned short Range,CArray<POINT,POINT> *Frontier,unsigned long &count) {
	Left=Right=CPoint(0,0);
	count=0;
	if ((StartPos.y<0) || (StartPos.x<0) || (StartPos.x>Width) || (StartPos.y>Height) || (bitperpixel!=16)) return;	
	unsigned long ff_StackPos;
	unsigned long ff_count;
	ff_count=0;
	unsigned int hx=StartPos.x;
	unsigned int hy=StartPos.y;
	unsigned int fx=hx;
	unsigned int fy=hy;
	unsigned int dist=1;
	bool found=false;
	unsigned short value;
	if (!GetPixel(hx,hy,value)) return;
	if (value==0) { //correct side of frontier, test distance
		dist=1;
		found=false;
		while ((!found) && (dist<10)) {
			     if (GetPixel(fx=hx+dist,fy=hy+dist,value) && (value==65535)) found=true;
			else if (GetPixel(fx=hx+dist,fy=hy,value) && (value==65535)) found=true;
			else if (GetPixel(fx=hx+dist,fy=hy-dist,value) && (value==65535)) found=true;
			else if (GetPixel(fx=hx,fy=hy+dist,value) && (value==65535)) found=true;			
			else if (GetPixel(fx=hx,fy=hy-dist,value) && (value==65535)) found=true;
			else if (GetPixel(fx=hx-dist,fy=hy+dist,value) && (value==65535)) found=true;
			else if (GetPixel(fx=hx-dist,fy=hy,value) && (value==65535)) found=true;
			else if (GetPixel(fx=hx-dist,fy=hy-dist,value) && (value==65535)) found=true;
			if (!found) dist++;
		}
		if (!found) return;
		if (dist>1) {  //initial point not directly at frontier
			hx=fx;  //this is frontierpoint, but wrong side
			hy=fy;
		}
	}
	if (!GetPixel(hx,hy,value)) return;
	if (value==65535) { //wrong side of frontier	
		dist=1;
		found=false;
		while ((!found) && (dist<10)) {
			     if (GetPixel(fx=hx+dist,fy=hy+dist,value) && (value==0)) found=true;
			else if (GetPixel(fx=hx+dist,fy=hy,value) && (value==0)) found=true;
			else if (GetPixel(fx=hx+dist,fy=hy-dist,value) && (value==0)) found=true;
			else if (GetPixel(fx=hx,fy=hy+dist,value) && (value==0)) found=true;			
			else if (GetPixel(fx=hx,fy=hy-dist,value) && (value==0)) found=true;
			else if (GetPixel(fx=hx-dist,fy=hy+dist,value) && (value==0)) found=true;
			else if (GetPixel(fx=hx-dist,fy=hy,value) && (value==0)) found=true;
			else if (GetPixel(fx=hx-dist,fy=hy-dist,value) && (value==0)) found=true;
			if (!found) dist++;
		}
		if (!found) return;
		hx=fx;
		hy=fy; //this must be frontier point since not found for dist-1
	} 
	if (!found) return;
	bool StackCreated=false;
	if (StackX==NULL) {
		CreateFloodFillStack(bitperpixel); 
		StackCreated=true; 
	}
	ff_StackPos=1;
	StackX[1]=hx;
	StackY[1]=hy;
	StackDir[1]=0;
	unsigned char dir;
	bool LeftAssigned=false;
	while ((ff_StackPos>0) && (ff_StackPos<(StackSize-10))) {
		hx=StackX[ff_StackPos];
		hy=StackY[ff_StackPos];
		dir=StackDir[ff_StackPos];
		SetPixel16Bit(hx,hy,32000);
		Frontier->Add(CPoint::CPoint(hx,hy));
		ff_count++;					
		bool EndPoint=false;
		if ((dir!=1) && (hx>0) && IsFrontierPoint16Bit(hx-1,hy)) {
			if (((hx-1)-StartPos.x)*((hx-1)-StartPos.x)+((hy)-StartPos.y)*((hy)-StartPos.y) < Range*Range) {
				StackX[ff_StackPos]=hx-1;
				StackY[ff_StackPos]=hy;
				StackDir[ff_StackPos]=2;
				ff_StackPos++;
			} else EndPoint=true;
		}
		if ((dir!=2) && (hx<Width-1) && IsFrontierPoint16Bit(hx+1,hy)) {
			if (((hx+1)-StartPos.x)*((hx+1)-StartPos.x)+((hy)-StartPos.y)*((hy)-StartPos.y) < Range*Range) {			
				StackX[ff_StackPos]=hx+1;
				StackY[ff_StackPos]=hy;
				StackDir[ff_StackPos]=1;
				ff_StackPos++;
			} else EndPoint=true;
		}
		if ((dir!=3) && (hy>0) && IsFrontierPoint16Bit(hx,hy-1)) {
			if (((hx)-StartPos.x)*((hx)-StartPos.x)+((hy-1)-StartPos.y)*((hy-1)-StartPos.y) < Range*Range) {						
				StackX[ff_StackPos]=hx;
				StackY[ff_StackPos]=hy-1;
				StackDir[ff_StackPos]=4;
				ff_StackPos++;
			} else EndPoint=true;
		}
		if ((dir!=4) && (hy<Height-1) && IsFrontierPoint16Bit(hx,hy+1)) {
			if (((hx)-StartPos.x)*((hx)-StartPos.x)+((hy+1)-StartPos.y)*((hy+1)-StartPos.y) < Range*Range) {			
				StackX[ff_StackPos]=hx;
				StackY[ff_StackPos]=hy+1;
				StackDir[ff_StackPos]=3;
				ff_StackPos++;
			} else EndPoint=true;
		}						
		if (EndPoint) {
			if (!LeftAssigned) {
				LeftAssigned=true;
				Left=CPoint(hx,hy);
			} else {				
				if (((Left.x-hx)*(Left.x-hx)+(Left.y-hy)*(Left.y-hy))>10) Right=CPoint(hx,hy);				
			}
		}
		ff_StackPos--;
	}
	if (ff_StackPos>=(StackSize-10)) {
		while (ff_StackPos>0) {
			hx=StackX[ff_StackPos];
			hy=StackY[ff_StackPos];
			SetPixel16Bit(hx,hy,32000);
			Frontier->Add(CPoint::CPoint(hx,hy));
			ff_StackPos--;
		}
	}
	count=ff_count;			
	if (StackCreated) DeleteFloodFillStack(bitperpixel);
}

void CImage::GetFrontier8Bit(CPoint StartPos,CPoint &Left,CPoint &Right,unsigned short Range,CArray<POINT,POINT> *Frontier,unsigned long &count) {
	Left=Right=CPoint(0,0);
	count=0;
	if ((StartPos.y<0) || (StartPos.x<0) || (StartPos.x>Width) || (StartPos.y>Height) || (bitperpixel!=8)) return;	
	unsigned long ff_StackPos;
	unsigned long ff_count;
	ff_count=0;
	unsigned int hx=StartPos.x;
	unsigned int hy=StartPos.y;
	unsigned int fx=hx;
	unsigned int fy=hy;
	unsigned int dist=1;
	bool found=false;
	unsigned short value;
	if (!GetPixel(hx,hy,value)) return;
	if (value==0) { //correct side of frontier, test distance
		dist=1;
		found=false;
		while ((!found) && (dist<10)) {
			     if (GetPixel(fx=hx+dist,fy=hy+dist,value) && (value>65000)) found=true;
			else if (GetPixel(fx=hx+dist,fy=hy,value) && (value>65000)) found=true;
			else if (GetPixel(fx=hx+dist,fy=hy-dist,value) && (value>65000)) found=true;
			else if (GetPixel(fx=hx,fy=hy+dist,value) && (value>65000)) found=true;			
			else if (GetPixel(fx=hx,fy=hy-dist,value) && (value>65000)) found=true;
			else if (GetPixel(fx=hx-dist,fy=hy+dist,value) && (value>65000)) found=true;
			else if (GetPixel(fx=hx-dist,fy=hy,value) && (value>65000)) found=true;
			else if (GetPixel(fx=hx-dist,fy=hy-dist,value) && (value>65000)) found=true;
			if (!found) dist++;
		}
		if (!found) return;
		if (dist>1) {  //initial point not directly at frontier
			hx=fx;  //this is frontierpoint, but wrong side
			hy=fy;
		}
	}
	if (!GetPixel(hx,hy,value)) return;
	if (value>65000) { //wrong side of frontier	
		dist=1;
		found=false;
		while ((!found) && (dist<10)) {
			     if (GetPixel(fx=hx+dist,fy=hy+dist,value) && (value==0)) found=true;
			else if (GetPixel(fx=hx+dist,fy=hy,value) && (value==0)) found=true;
			else if (GetPixel(fx=hx+dist,fy=hy-dist,value) && (value==0)) found=true;
			else if (GetPixel(fx=hx,fy=hy+dist,value) && (value==0)) found=true;			
			else if (GetPixel(fx=hx,fy=hy-dist,value) && (value==0)) found=true;
			else if (GetPixel(fx=hx-dist,fy=hy+dist,value) && (value==0)) found=true;
			else if (GetPixel(fx=hx-dist,fy=hy,value) && (value==0)) found=true;
			else if (GetPixel(fx=hx-dist,fy=hy-dist,value) && (value==0)) found=true;
			if (!found) dist++;
		}
		if (!found) return;
		hx=fx;
		hy=fy; //this must be frontier point since not found for dist-1
	} 
	if (!found) return;
	bool StackCreated=false;
	if (StackX==NULL) {
		CreateFloodFillStack(bitperpixel); 
		StackCreated=true; 
	}
	ff_StackPos=1;
	StackX[1]=hx;
	StackY[1]=hy;
	StackDir[1]=0;
	unsigned char dir;
	bool LeftAssigned=false;
	while ((ff_StackPos>0) && (ff_StackPos<(StackSize-10))) {
		hx=StackX[ff_StackPos];
		hy=StackY[ff_StackPos];
		dir=StackDir[ff_StackPos];
		SetPixel8Bit(hx,hy,127);
		Frontier->Add(CPoint::CPoint(hx,hy));
		ff_count++;					
		bool EndPoint=false;
		if ((dir!=1) && (hx>0) && IsFrontierPoint8Bit(hx-1,hy)) {
			if (((hx-1)-StartPos.x)*((hx-1)-StartPos.x)+((hy)-StartPos.y)*((hy)-StartPos.y) < Range*Range) {
				StackX[ff_StackPos]=hx-1;
				StackY[ff_StackPos]=hy;
				StackDir[ff_StackPos]=2;
				ff_StackPos++;
			} else EndPoint=true;
		}
		if ((dir!=2) && (hx<Width-1) && IsFrontierPoint8Bit(hx+1,hy)) {
			if (((hx+1)-StartPos.x)*((hx+1)-StartPos.x)+((hy)-StartPos.y)*((hy)-StartPos.y) < Range*Range) {			
				StackX[ff_StackPos]=hx+1;
				StackY[ff_StackPos]=hy;
				StackDir[ff_StackPos]=1;
				ff_StackPos++;
			} else EndPoint=true;
		}
		if ((dir!=3) && (hy>0) && IsFrontierPoint8Bit(hx,hy-1)) {
			if (((hx)-StartPos.x)*((hx)-StartPos.x)+((hy-1)-StartPos.y)*((hy-1)-StartPos.y) < Range*Range) {						
				StackX[ff_StackPos]=hx;
				StackY[ff_StackPos]=hy-1;
				StackDir[ff_StackPos]=4;
				ff_StackPos++;
			} else EndPoint=true;
		}
		if ((dir!=4) && (hy<Height-1) && IsFrontierPoint8Bit(hx,hy+1)) {
			if (((hx)-StartPos.x)*((hx)-StartPos.x)+((hy+1)-StartPos.y)*((hy+1)-StartPos.y) < Range*Range) {			
				StackX[ff_StackPos]=hx;
				StackY[ff_StackPos]=hy+1;
				StackDir[ff_StackPos]=3;
				ff_StackPos++;
			} else EndPoint=true;
		}						
		if (EndPoint) {
			if (!LeftAssigned) {
				LeftAssigned=true;
				Left=CPoint(hx,hy);
			} else {				
				if (((Left.x-hx)*(Left.x-hx)+(Left.y-hy)*(Left.y-hy))>10) Right=CPoint(hx,hy);				
			}
		}
		ff_StackPos--;
	}
	if (ff_StackPos>=(StackSize-10)) {
		while (ff_StackPos>0) {
			hx=StackX[ff_StackPos];
			hy=StackY[ff_StackPos];
			SetPixel8Bit(hx,hy,127);
			Frontier->Add(CPoint::CPoint(hx,hy));
			ff_StackPos--;
		}
	}
	count=ff_count;			
	if (StackCreated) DeleteFloodFillStack(bitperpixel);
}


void CImage::CopyFloodFill(unsigned long x, unsigned long y, unsigned short color,unsigned long &count,CImage* dest)
{
	if ((x>Width) || (y>Height)) return;
	unsigned short* ff_StackX,
	unsigned short* ff_StackY;
	unsigned long ff_StackPos;
	unsigned long ff_count;
	unsigned short ff_color;
	CImage* ff_dest;

	ff_dest=dest;
	ff_count=0;
	ff_color=color;
	unsigned int hx=x;
	unsigned int hy=y;
	ff_StackX = new unsigned short[StackSize];
	ff_StackY = new unsigned short[StackSize];
	ff_StackPos=1;
	ff_StackX[1]=hx;
	ff_StackY[1]=hy;
	while ((ff_StackPos>0) && (ff_StackPos<(StackSize-10))) {
		hx=ff_StackX[ff_StackPos];
		hy=ff_StackY[ff_StackPos];
		ff_dest->SetPixel16Bit(hx,hy,ff_color);
		ff_count++;			
		if ((hx>0) && ((GetPixel16Bit(hx-1,hy)==ff_color) && (ff_dest->GetPixel16Bit(hx-1,hy)!=ff_color))) {
			ff_StackX[ff_StackPos]=hx-1;
			ff_StackY[ff_StackPos]=hy;
			ff_StackPos++;
		}
		if ((hx<Width-1) && ((GetPixel16Bit(hx+1,hy)==ff_color) && (ff_dest->GetPixel16Bit(hx+1,hy)!=ff_color))) {
			ff_StackX[ff_StackPos]=hx+1;
			ff_StackY[ff_StackPos]=hy;
			ff_StackPos++;
		}
		if ((hy>0) && ((GetPixel16Bit(hx,hy-1)==ff_color) && (ff_dest->GetPixel16Bit(hx,hy-1)!=ff_color))) {
			ff_StackX[ff_StackPos]=hx;
			ff_StackY[ff_StackPos]=hy-1;
			ff_StackPos++;
		}
		if ((hx<Height-1) && ((GetPixel16Bit(hx,hy+1)==ff_color) && (ff_dest->GetPixel16Bit(hx,hy+1)!=ff_color))) {
			ff_StackX[ff_StackPos]=hx;
			ff_StackY[ff_StackPos]=hy+1;
			ff_StackPos++;
		}						
		ff_StackPos--;
	}
	if (ff_StackPos>=(StackSize-10)) {
		double a=1000;
	}
	count=ff_count;		
	delete ff_StackX;
	ff_StackX=NULL;
	delete ff_StackY;
	ff_StackY=NULL;
}

void CImage::Filter(unsigned short FilterSize, long Filter[],unsigned short Norm, CImage* dest) {	
	unsigned short offset=FilterSize/2;	
	for (unsigned long x=0;x<(Width-FilterSize);x++)
	for (unsigned long y=0;y<(Height-FilterSize);y++) {
		long sum=0;
		for (unsigned long x2=0;x2<FilterSize;x2++)
		for (unsigned long y2=0;y2<FilterSize;y2++) {			
			long help=GetPixel16Bit(x+x2,y+y2);
			sum+=Filter[x2+FilterSize*y2]*help;
		}
		long help=sum;
		help/=Norm;
		help=abs(help);		
		if (help>65535) help=65535;
		dest->SetPixel16Bit(x+offset,y+offset,help);
	}
}

void CImage::AddImage(CImage* Source) {
	unsigned short *bm=bitmap;
	unsigned short *org=Source->bitmap;
	for (unsigned long x=0;x<Width;x++)
	for (unsigned long y=0;y<Height;y++) {
		unsigned long help=*org;
		help+=*bm;
		if (help>65535) help=65535;
		*bm=help;
		org++;
		bm++;
	}
}

double CImage::CalcMedian()
{
	double out=0;
	unsigned short *bm=bitmap;
	for (unsigned long x=0;x<Width*Height;x++) {out+=*bm;bm++;}
	return out/(Width*Height);
}

void CImage::CopyMedian(unsigned short NeighborhoodSize, unsigned short Median, CImage *source)
{
	if (bitperpixel==1) {
		unsigned short area=(2*NeighborhoodSize+1)*(2*NeighborhoodSize+1);	
		for (unsigned long x=NeighborhoodSize;x<(Width-NeighborhoodSize);x++) {
			for (unsigned long y=NeighborhoodSize;y<(Height-NeighborhoodSize);y++) {		
				unsigned long sum=0;
				for (short x2=-NeighborhoodSize;x2<=NeighborhoodSize;x2++)
				for (short y2=-NeighborhoodSize;y2<=NeighborhoodSize;y2++) sum+=source->GetPixel16Bit(x+x2,y+y2);
				sum/=area;
				if (sum>Median) SetPixel1BitWhite(x,y);
				else SetPixel1BitBlack(x,y);
			}
		}
	} else if (bitperpixel==8) {
		unsigned short area=(2*NeighborhoodSize+1)*(2*NeighborhoodSize+1);	
		for (unsigned long x=NeighborhoodSize;x<(Width-NeighborhoodSize);x++) {
			for (unsigned long y=NeighborhoodSize;y<(Height-NeighborhoodSize);y++) {		
				unsigned long sum=0;
				for (short x2=-NeighborhoodSize;x2<=NeighborhoodSize;x2++)
				for (short y2=-NeighborhoodSize;y2<=NeighborhoodSize;y2++) sum+=source->GetPixel16Bit(x+x2,y+y2);
				sum/=area;
				SetPixel8Bit(x,y,(sum>Median) ? 255 : 0);				
			}
		}
	} else {
		unsigned short area=(2*NeighborhoodSize+1)*(2*NeighborhoodSize+1);	
		for (unsigned long x=NeighborhoodSize;x<(Width-NeighborhoodSize);x++) {
			for (unsigned long y=NeighborhoodSize;y<(Height-NeighborhoodSize);y++) {		
				unsigned long sum=0;
				for (short x2=-NeighborhoodSize;x2<=NeighborhoodSize;x2++)
				for (short y2=-NeighborhoodSize;y2<=NeighborhoodSize;y2++) sum+=source->GetPixel16Bit(x+x2,y+y2);
				sum/=area;
				if (sum>Median) SetPixel16Bit(x,y,(sum>Median) ? 65535 : 0);				
			}
		}
	}
}

void CImage::Fill(unsigned short Color)
{
	unsigned short *bm=bitmap;
	for (unsigned long x=0;x<Width*Height;x++) {*bm=Color;bm++;}	
}

void CImage::CropBorders(unsigned short Bordersize,unsigned short Color)
{
	if (bitperpixel==1) {
		unsigned long x,y;
		unsigned short RestBorder=Bordersize;
		x=0;		
		while (RestBorder>32) {
			for (y=0;y<Height;y++) bitmap32bit[x+y*Width1Bit]=0;
			RestBorder-=32;
			x++;
		}
		if (RestBorder>0) {
			unsigned long pattern=0xFFFFFFFF << RestBorder;
			for (y=0;y<Height;y++) bitmap32bit[x+y*Width1Bit]&=pattern;
		}		
		for (x=Width-Bordersize;x<Width;x++) {  //this could be still optimized
			for (y=0;y<Height;y++) SetPixel1BitBlack(x,y);
		}
		for (y=Height-Bordersize;y<Height;y++) {
			for (x=0;x<Width1Bit;x++) bitmap32bit[x+y*Width1Bit]=0;
		}
		for (y=0;y<Bordersize;y++) {
			for (x=0;x<Width1Bit;x++) bitmap32bit[x+y*Width1Bit]=0;				
		}
	} else if (bitperpixel==8) {
		unsigned long x,y;
		unsigned char hColor=Color/256;
		for (x=0;x<Bordersize;x++) {
			for (y=0;y<Height;y++) SetPixel8Bit(x,y,hColor);
		}
		for (x=Width-Bordersize;x<Width;x++) {
			for (y=0;y<Height;y++) SetPixel8Bit(x,y,hColor);
		}
		for (y=Height-Bordersize;y<Height;y++) {
			for (x=0;x<Width;x++) SetPixel8Bit(x,y,hColor);
		}
		for (y=0;y<Bordersize;y++) {
			for (x=0;x<Width;x++) SetPixel8Bit(x,y,hColor);
		}

	} else {
		unsigned long x,y;
		for (x=0;x<Bordersize;x++) {
			for (y=0;y<Height;y++) SetPixel16Bit(x,y,Color);
		}
		for (x=Width-Bordersize;x<Width;x++) {
			for (y=0;y<Height;y++) SetPixel16Bit(x,y,Color);
		}
		for (y=Height-Bordersize;y<Height;y++) {
			for (x=0;x<Width;x++) SetPixel16Bit(x,y,Color);
		}
		for (y=0;y<Bordersize;y++) {
			for (x=0;x<Width;x++) SetPixel16Bit(x,y,Color);
		}
	}
}

void CImage::FillGaps(unsigned short GapSize)
{	
	if (bitperpixel==1) {
		for (unsigned long x=GapSize;x<(Width-GapSize);x++)
		for (unsigned long y=GapSize;y<(Height-GapSize);y++) if (!GetPixel1Bit(x,y)) {
			bool GapFound=false;
			GapFound=GapFound || (GetPixel1Bit(x+GapSize,y+GapSize)) && (GetPixel1Bit(x-GapSize,y-GapSize));
			GapFound=GapFound || (GetPixel1Bit(x+GapSize,y-GapSize)) && (GetPixel1Bit(x-GapSize,y+GapSize));
			GapFound=GapFound || (GetPixel1Bit(x+GapSize,y)) && (GetPixel1Bit(x-GapSize,y));
			GapFound=GapFound || (GetPixel1Bit(x,y+GapSize)) && (GetPixel1Bit(x,y-GapSize));
			if (GapFound) SetPixel1BitWhite(x,y);
		}	
	} else if (bitperpixel==8) { 
		for (unsigned long x=GapSize;x<(Width-GapSize);x++)
		for (unsigned long y=GapSize;y<(Height-GapSize);y++) if (GetPixel8Bit(x,y)==0) {
			bool GapFound=false;
			GapFound=GapFound || (GetPixel8Bit(x+GapSize,y+GapSize)==255) && (GetPixel8Bit(x-GapSize,y-GapSize)==255);
			GapFound=GapFound || (GetPixel8Bit(x+GapSize,y-GapSize)==255) && (GetPixel8Bit(x-GapSize,y+GapSize)==255);
			GapFound=GapFound || (GetPixel8Bit(x+GapSize,y)==255) && (GetPixel8Bit(x-GapSize,y)==255);
			GapFound=GapFound || (GetPixel8Bit(x,y+GapSize)==255) && (GetPixel8Bit(x,y-GapSize)==255);
			if (GapFound) SetPixel8Bit(x,y,255);
		}
	} else {
		for (unsigned long x=GapSize;x<(Width-GapSize);x++)
		for (unsigned long y=GapSize;y<(Height-GapSize);y++) if (GetPixel16Bit(x,y)==0) {
			bool GapFound=false;
			GapFound=GapFound || (GetPixel16Bit(x+GapSize,y+GapSize)==65535) && (GetPixel16Bit(x-GapSize,y-GapSize)==65535);
			GapFound=GapFound || (GetPixel16Bit(x+GapSize,y-GapSize)==65535) && (GetPixel16Bit(x-GapSize,y+GapSize)==65535);
			GapFound=GapFound || (GetPixel16Bit(x+GapSize,y)==65535) && (GetPixel16Bit(x-GapSize,y)==65535);
			GapFound=GapFound || (GetPixel16Bit(x,y+GapSize)==65535) && (GetPixel16Bit(x,y-GapSize)==65535);
			if (GapFound) SetPixel16Bit(x,y,65535);
		}
	}
}

void CImage::Invert()
{
	unsigned short *bm=bitmap;
	for (unsigned long x=0;x<Width*Height;x++) {*bm=65535-(*bm);}	
}

void CImage::FloodFillOutside()
{
	unsigned long x,y;
	x=0;
	y=0;
	bool found=false;
	while ((!found) && (y<Height)) {
		x=0;
		while ((!found) && (x<Width)) {
			found=GetPixel16Bit(x,y)==0;
			x++;
		}
		y++;
	}
	unsigned long count;
	InvertFloodFill(x,y,1,0,count);
	for (x=0;x<Width;x++) for (y=0;y<Height;y++) {
		if (GetPixel16Bit(x,y)==1) SetPixel16Bit(x,y,65535);
		else SetPixel16Bit(x,y,0);
	}
}

void CImage::ExchangeColor(unsigned short testcolor,unsigned short truecolor, unsigned short falsecolor)
{
	for (unsigned int x=0;x<Width;x++) for (unsigned int y=0;y<Height;y++) {
		if (GetPixel16Bit(x,y)==testcolor) SetPixel16Bit(x,y,truecolor);
		else SetPixel16Bit(x,y,falsecolor);
	}	
}

void CImage::TestColor(unsigned short testcolor)
{
	if (bitperpixel==8) {
		unsigned char *bm=bitmap8bit;
		for (long x=0;x<Width*Height;x++) {
			if (*bm==testcolor) *bm=255; 
			else *bm=0;
			bm++;
		}	
	} else if (bitperpixel==16) {
		unsigned short *bm=bitmap;
		for (long x=0;x<Width*Height;x++) {
			if (*bm==testcolor) *bm=65535; 
			else *bm=0;
			bm++;
		}	
	}
}

void CImage::EraseSmallerThan(unsigned long MaxCount)
{
	CreateFloodFillStack(bitperpixel);
	//Erase all the small white spots with spotarea smaller than m_EraseSmaller1 pixels
	if (bitperpixel==1) {
		if (MaxCount>0) {
			CImage* help=new CImage(this);	
			for (unsigned short x=0;x<Width;x++) {
				for (unsigned short y=0;y<Height;y++) {
					if (help->GetPixel1Bit(x,y)) {
						unsigned long count=0;
						help->FloodFillWithBlack1Bit(x,y,count);
						if (count<MaxCount) FloodFillWithBlack1Bit(x,y,count);					
					}
				}
			}
			delete help;
			help=NULL;
		}
	} else if (bitperpixel==8) {
		if (MaxCount>0) {
			CImage* help=new CImage(this);	
			for (unsigned short x=0;x<Width;x++) {
				for (unsigned short y=0;y<Height;y++) {
					if (help->GetPixel8Bit(x,y)==255) {
						unsigned long count=0;
						help->FloodFill8Bit(x,y,0,count);
						if (count<MaxCount) {					
							FloodFill8Bit(x,y,0,count);
						}
					}
				}
			}
			delete help;
			help=NULL;
		}
	} else {		
		if (MaxCount>0) {
			CImage* help=new CImage(this);	
			for (unsigned short x=0;x<Width;x++) {
				for (unsigned short y=0;y<Height;y++) {
					if (help->GetPixel16Bit(x,y)==65535) {
						unsigned long count=0;
						help->FloodFill16Bit(x,y,0,count);
						if (count<MaxCount) {					
							FloodFill16Bit(x,y,0,count);
						}
					}
				}
			}
			delete help;
			help=NULL;
		}
	}
	DeleteFloodFillStack(bitperpixel);
}

void CImage::ConvertTo1BitPerPixel()
{	
	if (bitperpixel==1) return;	
	if (bitperpixel==8) {		
		Width1Bit=Width>>5;
		if ((Width & 0x1F)>0) Width1Bit++;
		if (bitmap32bit) delete bitmap32bit;
		bitmap32bit=new unsigned long[Width1Bit*Height];	
		for (unsigned short y=0;y<Height;y++) 
			for (unsigned short x=0;x<Width;x++){
				SetPixel1Bit(x,y,GetPixel8Bit(x,y)>0);
			}	
		delete bitmap8bit;
		bitmap8bit=NULL;
		bitperpixel=1;
	} else {
		Width1Bit=Width>>5;
		if ((Width & 0x1F)>0) Width1Bit++;
		if (bitmap32bit) delete bitmap32bit;
		bitmap32bit=new unsigned long[Width1Bit*Height];	
		for (unsigned short y=0;y<Height;y++) 
			for (unsigned short x=0;x<Width;x++){
				SetPixel1Bit(x,y,GetPixel16Bit(x,y)>0);
			}	
		delete bitmap;
		bitmap=NULL;
		bitperpixel=1;
	}
}

void CImage::ConvertTo8BitPerPixel()
{	
	if (bitperpixel==8) return;	
	if (bitperpixel==16) {
		if (bitmap8bit) delete bitmap8bit;
		bitmap8bit=new unsigned char[Width*Height];	
		for (unsigned short y=0;y<Height;y++) 
			for (unsigned short x=0;x<Width;x++){
				SetPixel8Bit(x,y,GetPixel16Bit(x,y)/256);
			}	
		delete bitmap;
		bitmap=NULL;
		bitperpixel=8;
	}
}

void CImage::ConvertTo16BitPerPixel()
{		
	if (bitperpixel==16) return;	
	if (bitperpixel==8) {
		if (bitmap) delete bitmap;
		bitmap=new unsigned short[Width*Height];	
		for (unsigned short y=0;y<Height;y++) 
			for (unsigned short x=0;x<Width;x++) {
				SetPixel16Bit(x,y,GetPixel8Bit(x,y)*256);
			}	
		delete bitmap8bit;
		bitmap8bit=NULL;
		bitperpixel=16;	
	} else if (bitperpixel==1) {
		if (bitmap) delete bitmap;
		bitmap=new unsigned short[Width*Height];	
		for (unsigned short y=0;y<Height;y++) 
			for (unsigned short x=0;x<Width;x++) {
				SetPixel16Bit(x,y,(GetPixel1Bit(x,y)) ? 65535 : 0);
			}	
		delete bitmap32bit;
		bitmap32bit=NULL;
		bitperpixel=16;	
	}
}


void CImage::CopyRegion(unsigned short x0, unsigned short y0, unsigned short x1, unsigned short y1, CImage *source)
{
	if (bitperpixel==1) {
		for (unsigned short y=y0;y<y1;y++) for (unsigned short x=x0;x<x1;x++) SetPixel1Bit(x-x0,y-y0,source->GetPixel1Bit(x,y));
	} else if (bitperpixel==8) {
		for (unsigned short y=y0;y<y1;y++) for (unsigned short x=x0;x<x1;x++) SetPixel8Bit(x-x0,y-y0,source->GetPixel8Bit(x,y));
	} else {
		for (unsigned short y=y0;y<y1;y++) for (unsigned short x=x0;x<x1;x++) SetPixel16Bit(x-x0,y-y0,source->GetPixel16Bit(x,y));
	}	
}

void CImage::CopyOrAt(unsigned short x0, unsigned short y0, CImage *source)
{
	if (bitperpixel==1) { //I did beforehand guarantee bitalignement!
		x0=x0>>5;
		for (unsigned short y=y0;y<y0+source->Height;y++) {
			unsigned short yOffs=y*Width1Bit;
			for (unsigned short x=x0;x<(x0+(source->Width>>5));x++)			
				bitmap32bit[x+yOffs]|=source->bitmap32bit[x-x0+yOffs];
		}
	} else if (bitperpixel==8) {
		for (unsigned short y=y0;y<y0+source->Height;y++)
			for (unsigned short x=x0;x<x0+source->Width;x++)			
				SetPixel8Bit(x,y,GetPixel8Bit(x,y) | source->GetPixel8Bit(x-x0,y-y0));
	} else {
		for (unsigned short y=y0;y<y0+source->Height;y++)
			for (unsigned short x=x0;x<x0+source->Width;x++)			
				SetPixel16Bit(x,y,GetPixel16Bit(x,y) | source->GetPixel16Bit(x-x0,y-y0));
	}
}

void CImage::FillBorder(unsigned short Bordersize)
{
	if (bitperpixel==1) {
		unsigned long x,y;
		bool Color;
		for (y=0;y<Height;y++) {
			Color=GetPixel1Bit(Bordersize,y);
			for (x=0;x<Bordersize;x++) SetPixel1Bit(x,y,Color);
		}
		for (y=0;y<Height;y++) {
			Color=GetPixel1Bit(Width-Bordersize-1,y);
			for (x=Width-Bordersize;x<Width;x++) SetPixel1Bit(x,y,Color);
		}
		for (x=0;x<Width;x++) {
			Color=GetPixel1Bit(x,Height-Bordersize-1);			
			for (y=Height-Bordersize;y<Height;y++) SetPixel1Bit(x,y,Color);
		}
		for (x=0;x<Width;x++) {
			Color=GetPixel1Bit(x,Bordersize+1);
			for (y=0;y<Bordersize;y++) SetPixel1Bit(x,y,Color);
		}	
	} else if (bitperpixel==8) {
		unsigned long x,y;
		unsigned short Color;
		for (y=0;y<Height;y++) {
			Color=GetPixel8Bit(Bordersize,y);
			for (x=0;x<Bordersize;x++) SetPixel8Bit(x,y,Color);
		}
		for (y=0;y<Height;y++) {
			Color=GetPixel8Bit(Width-Bordersize-1,y);
			for (x=Width-Bordersize;x<Width;x++) SetPixel8Bit(x,y,Color);
		}
		for (x=0;x<Width;x++) {
			Color=GetPixel8Bit(x,Height-Bordersize-1);			
			for (y=Height-Bordersize;y<Height;y++) SetPixel8Bit(x,y,Color);
		}
		for (x=0;x<Width;x++) {
			Color=GetPixel8Bit(x,Bordersize+1);
			for (y=0;y<Bordersize;y++) SetPixel8Bit(x,y,Color);
		}
	} else {
		unsigned long x,y;
		unsigned short Color;
		for (y=0;y<Height;y++) {
			Color=GetPixel16Bit(Bordersize,y);
			for (x=0;x<Bordersize;x++) SetPixel16Bit(x,y,Color);
		}
		for (y=0;y<Height;y++) {
			Color=GetPixel16Bit(Width-Bordersize-1,y);
			for (x=Width-Bordersize;x<Width;x++) SetPixel16Bit(x,y,Color);
		}
		for (x=0;x<Width;x++) {
			Color=GetPixel16Bit(x,Height-Bordersize-1);			
			for (y=Height-Bordersize;y<Height;y++) SetPixel16Bit(x,y,Color);
		}
		for (x=0;x<Width;x++) {
			Color=GetPixel16Bit(x,Bordersize+1);
			for (y=0;y<Bordersize;y++) SetPixel16Bit(x,y,Color);
		}
	}
}

void CImage::DrawLineTillBorder(CPoint pos, CPoint dir, CPoint &left, CPoint &middle, CPoint &right)
{
	if (bitperpixel==8) DrawLineTillBorder8Bit(pos,dir,left,middle,right);
	else if (bitperpixel==16) DrawLineTillBorder16Bit(pos,dir,left,middle,right);
}

void CImage::DrawLineTillBorder16Bit(CPoint pos, CPoint dir, CPoint &left, CPoint &middle, CPoint &right)
{ 	
	left=right=middle=CPoint::CPoint(0,0);
	if (bitperpixel!=16) return; 
	 if (GetPixel16Bit(pos.x,pos.y)!=0) return;
	 short x0=pos.x;
	 short y0=pos.y;
	 SetPixel16Bit(pos.x,pos.y,65535);
     if (abs(dir.x) > abs(dir.y)) {          // slope < 1
		double m = (double) dir.y / (double) dir.x;      // compute slope
        double b = pos.y - m*pos.x;
        int dx = (dir.x < 0) ? -1 : 1;
		bool ende=false;
        while ((x0>0) && (x0<Width) && (!ende)) {
            x0 += dx;
			y0=m*x0 + b;
			if ((y0>0) && (y0<Height)) {
				ende=GetPixel16Bit(x0,y0)==65535;
				SetPixel16Bit(x0,y0,65535);
			} else ende=true;
        }
		left=CPoint::CPoint(x0,y0);
		short endx1=x0;
		x0=pos.x;
		dx*=-1;
		ende=false;
		while ((x0>0) && (x0<Width) && (!ende)) {
            x0 += dx;
			y0=m*x0 + b;
			if ((y0>0) && (y0<Height)) {
				ende=GetPixel16Bit(x0,y0)==65535;
				SetPixel16Bit(x0,y0,65535);
			} else ende=true;
        }				
		short middlex=(x0+endx1)/2;
		short middley=m*middlex+b;
		middle=CPoint::CPoint(middlex,middley);
		right=CPoint::CPoint(x0,y0);		
     } else {
        if (dir.y != 0) {                              // slope >= 1            
			double m = (double) dir.x / (double) dir.y;      // compute slope
            double b = pos.x - m*pos.y;
            int dy = (dir.y < 0) ? -1 : 1;
			bool ende=false;
			while ((y0>0) && (y0<Height) && (!ende)) {            
                y0 += dy;
				x0=m*y0 + b;
				if ((x0>0) && (x0<Width)) {
					ende=GetPixel16Bit(x0,y0)==65535;
					SetPixel16Bit(x0,y0,65535);
				} else ende=true;
            }
			left=CPoint::CPoint(x0,y0);
			short endy1=y0;
			y0=pos.y;
			dy*=-1;
			ende=false;
			while ((y0>0) && (y0<Height) && (!ende)) {            
                y0 += dy;
				x0=m*y0 + b;
				if ((x0>0) && (x0<Width)) {
					ende=GetPixel16Bit(x0,y0)==65535;
					SetPixel16Bit(x0,y0,65535);
				} else ende=true;
            }
			short middley=(y0+endy1)/2;
			short middlex=m*middley+b;
			middle=CPoint::CPoint(middlex,middley);
			right=CPoint::CPoint(x0,y0);
		}		
    }	 
}

void CImage::DrawLineTillBorder8Bit(CPoint pos, CPoint dir, CPoint &left, CPoint &middle, CPoint &right)
{ 	
	left=right=middle=CPoint::CPoint(0,0);
	if (bitperpixel!=8) return; 
	 if (GetPixel8Bit(pos.x,pos.y)!=0) return;
	 short x0=pos.x;
	 short y0=pos.y;
	 SetPixel8Bit(pos.x,pos.y,255);
     if (abs(dir.x) > abs(dir.y)) {          // slope < 1
		double m = (double) dir.y / (double) dir.x;      // compute slope
        double b = pos.y - m*pos.x;
        int dx = (dir.x < 0) ? -1 : 1;
		bool ende=false;
        while ((x0>0) && (x0<Width) && (!ende)) {
            x0 += dx;
			y0=m*x0 + b;
			if ((y0>0) && (y0<Height)) {
				ende=GetPixel8Bit(x0,y0)==255;
				SetPixel8Bit(x0,y0,255);
			} else ende=true;
        }
		left=CPoint::CPoint(x0,y0);
		short endx1=x0;
		x0=pos.x;
		dx*=-1;
		ende=false;
		while ((x0>0) && (x0<Width) && (!ende)) {
            x0 += dx;
			y0=m*x0 + b;
			if ((y0>0) && (y0<Height)) {
				ende=GetPixel8Bit(x0,y0)==255;
				SetPixel8Bit(x0,y0,255);
			} else ende=true;
        }				
		short middlex=(x0+endx1)/2;
		short middley=m*middlex+b;
		middle=CPoint::CPoint(middlex,middley);
		right=CPoint::CPoint(x0,y0);		
     } else {
        if (dir.y != 0) {                              // slope >= 1            
			double m = (double) dir.x / (double) dir.y;      // compute slope
            double b = pos.x - m*pos.y;
            int dy = (dir.y < 0) ? -1 : 1;
			bool ende=false;
			while ((y0>0) && (y0<Height) && (!ende)) {            
                y0 += dy;
				x0=m*y0 + b;
				if ((x0>0) && (x0<Width)) {
					ende=GetPixel8Bit(x0,y0)==255;
					SetPixel8Bit(x0,y0,255);
				} else ende=true;
            }
			left=CPoint::CPoint(x0,y0);
			short endy1=y0;
			y0=pos.y;
			dy*=-1;
			ende=false;
			while ((y0>0) && (y0<Height) && (!ende)) {            
                y0 += dy;
				x0=m*y0 + b;
				if ((x0>0) && (x0<Width)) {
					ende=GetPixel8Bit(x0,y0)==255;
					SetPixel8Bit(x0,y0,255);
				} else ende=true;
            }
			short middley=(y0+endy1)/2;
			short middlex=m*middley+b;
			middle=CPoint::CPoint(middlex,middley);
			right=CPoint::CPoint(x0,y0);
		}		
    }	 
}

void CImage::ShiftPixelBits(int nr)
{
	if (bitperpixel==16) {
		if (bitmap) {
			unsigned short *bm=bitmap;
			if (nr>0) {
				for (unsigned long k=0;k<Width*Height;k++) {
					(*bm)=(*bm)<<nr;
					bm++;
				}
			} else {
				int help=-nr;
				for (unsigned long k=0;k<Width*Height;k++) {
					(*bm)=(*bm)>>help;
					bm++;
				}
			}
		}
	}
}


void CImage::Clear()
{
	if (bitperpixel==16) {
		if (bitmap) {
			unsigned short *bm=bitmap;
			for (unsigned long k=0;k<Width*Height;k++) {
				(*bm)=0;
				bm++;
			}
		}
	} else if (bitperpixel==8) {
		if (bitmap8bit) {
			unsigned char *bm=bitmap8bit;
			for (unsigned long k=0;k<Width*Height;k++) {
				(*bm)=0;
				bm++;
			}
		}
	} else if (bitperpixel==1) {
		if (bitmap32bit) {
			unsigned long *bm=bitmap32bit;
			for (unsigned long k=0;k<Width1Bit*Height;k++) {
				(*bm)=0;
				bm++;
			}
		}
	} 
}

bool CImage::GetPixel(unsigned short x, unsigned short y, unsigned short &value)
{
	if ((x>=0) && (y>=0) && (x<Width) && (y<Height)) {
		if (bitperpixel==1) value=GetPixel1Bit(x,y) ? 65535 : 0;
		else if (bitperpixel==8) value=GetPixel8Bit(x,y)*256;
		else if (bitperpixel==16) value=GetPixel16Bit(x,y);
		else return false;
		return true;
	} else return false;
}

bool CImage::SetPixel(unsigned short x, unsigned short y, unsigned short value)
{
	if ((x>=0) && (y>=0) && (x<Width) && (y<Height)) {
		if (bitperpixel==1) SetPixel1Bit(x,y,value>32768);
		else if (bitperpixel==8) SetPixel8Bit(x,y,value/256);
		else if (bitperpixel==16) SetPixel16Bit(x,y,value);
		else return false;
		return true;
	} else return false;
}

void CImage::KeepOutside(unsigned long m_FloodFillOutsideSize)
{
	//Fill all backgroundareas bigger than m_FloodFillOutside pixels in copy
	unsigned long MinCount=m_FloodFillOutsideSize;		
	CImage* help=new CImage(this);	
	CreateFloodFillStack(16);
	if (bitperpixel==8) {
		for (unsigned short x=0;x<Width;x++) {
			for (unsigned short y=0;y<Height;y++) {
				if (help->GetPixel8Bit(x,y)==0) {
					unsigned long count=0;
					help->FloodFill8Bit(x,y,255,count);
					if (count>MinCount) {					
						InvertFloodFill8Bit(x,y,1,0,count);
					} 
				}
			}
		}
	} else {
		for (unsigned short x=0;x<Width;x++) {
			for (unsigned short y=0;y<Height;y++) {
				if (help->GetPixel16Bit(x,y)==0) {
					unsigned long count=0;
					help->FloodFill16Bit(x,y,65535,count);
					if (count>MinCount) {					
						InvertFloodFill16Bit(x,y,1,0,count);
					} 
				}
			}
		}
	}	
	DeleteFloodFillStack(16);
	delete help;				
	help=NULL;
	TestColor(1); 
}

void CImage::OptimizeContrastAndConvertTo8BitPerPixel(unsigned long ppm, unsigned short &OptimizeContrastMin,unsigned short &OptimizeContrastMax) {

	if (bitperpixel==8) return;	
	if (bitperpixel==16) {
		CHistogram Histogram;
		GetHistogram(&Histogram);
		unsigned char min,max;
		double ppmd=ppm;
		ppmd/=1000000;
		Histogram.GetMinMaxAbove(ppmd,min,max);		
		if (min>=max) return;
		OptimizeContrastMin=min;
		OptimizeContrastMax=max;
		unsigned short hmin=min;
		unsigned short hmax=max;		
		hmin*=256;
		hmax*=256;
		unsigned short diff=hmax-hmin;
		if (bitmap8bit) delete bitmap8bit;
		bitmap8bit=new unsigned char[Width*Height];	
		for (unsigned short y=0;y<Height;y++) 
			for (unsigned short x=0;x<Width;x++){
				long help=GetPixel16Bit(x,y);
				help-=hmin;
				if (help<0) help=0;
				help*=255;
				help/=diff;		
				if (help>255) help=255;			
				SetPixel8Bit(x,y,help);
			}	
		delete bitmap;
		bitmap=NULL;
		bitperpixel=8;
	}
}

void CImage::OptimizeContrast(unsigned long ppm, unsigned short &OptimizeContrastMin,unsigned short &OptimizeContrastMax, CRect selection) {
	int x1 = selection.left;
	int y1 = selection.top;
	int x2 = selection.right;
	int y2 = selection.bottom;
	long begin = y1 * Width+x1;
	long end = y2 * Width+x2;
	unsigned short x,y;

	CHistogram Histogram;
	for (int i=0;i<256;i++) 
		Histogram.statistic[i]=0;

	if (bitperpixel==8) 
	{
		for (y=y1;y<y2;y++)
		{
			for (x=x1;x<x2;x++)
			{
				unsigned char help=GetPixel8Bit(x,y);
				Histogram.statistic[help]++;
			}
		}
		Histogram.Total = (x2-x1) * (y2-y1);
		unsigned char min,max;
		double ppmd=ppm;
		ppmd/=100000;
		Histogram.GetMinMaxAbove(ppmd,min,max);		
		if (min>=max) 
		{
			//AfxMessageBox("min greater than max");
			return;
		}
		OptimizeContrastMin=min;
		OptimizeContrastMax=max;
		for (y=0;y<Height;y++) 
			for (x=0;x<Width;x++)
			{
				double help = GetPixel8Bit(x,y);
				help -= min;
				if (help<0) help=0;
				help *= 256;
				help /= max - min;
				if (help>255) help=255;			
				SetPixel8Bit(x,y,help);
			}	

		
	}
	if (bitperpixel==16) 
	{
		//AfxMessageBox("op contrast 16 bit");
		//unsigned short *bm=bitmap;
		for (y=y1;y<y2;y++)
			for (x=x1;x<x2;x++)
			{
				unsigned char help = (unsigned char)(GetPixel16Bit(x,y)/256);
				Histogram.statistic[help]++;
				//bm++;
			}
		Histogram.Total= (x2-x1) * (y2-y1);
		//Histogram.Total=Width*Height;
		unsigned char min,max;
		double ppmd=ppm;
		ppmd/=1000000;
		Histogram.GetMinMaxAbove(ppmd,min,max);		
		if (min>=max) 
		{
			//AfxMessageBox("min greater than max");
			return;
		}
		OptimizeContrastMin=min;
		OptimizeContrastMax=max;
		//if (bitmap8bit) 
		//	delete bitmap8bit;
		//bitmap8bit = new unsigned char[Width*Height];	
		for (unsigned short y=0;y<Height;y++) 
			for (unsigned short x=0;x<Width;x++)
			{
				double help=GetPixel16Bit(x,y);
				help -= min*256;
				if (help<0) help=0;
				//help *= 255;
				help *= 256;
				help /= max - min;		
				if (help>256*256) help=256*256 -1;			
				SetPixel16Bit(x,y,help);
			}	
		//delete bitmap;
		//bitmap=NULL;
		//bitperpixel=8;
	}
}

void CImage::FlipVertical()
{
	if (bitperpixel==16) {
		if (bitmap) {
			unsigned short *helpbitmap=new unsigned short[Width*Height];
			unsigned short *hbm=helpbitmap;			
			for (short y=Height-1;y>=0;y--)
				for (unsigned short x=0;x<Width;x++) {
					*hbm=GetPixel16Bit(x,y);
					hbm++;
				}
			delete bitmap;
			bitmap=helpbitmap;
		}
	}
}

void CImage::ClearWhite()
{
	if (bitperpixel==16) {
		if (bitmap) {
			unsigned short *bm=bitmap;
			for (unsigned long k=0;k<Width*Height;k++) {
				(*bm)=256*256 -1 ;
				bm++;
			}
		}
	} else if (bitperpixel==8) {
		if (bitmap8bit) {
			unsigned char *bm=bitmap8bit;
			for (unsigned long k=0;k<Width*Height;k++) {
				(*bm)=255;
				bm++;
			}
		}
	} else if (bitperpixel==1) {
		if (bitmap32bit) {
			unsigned long *bm=bitmap32bit;
			for (unsigned long k=0;k<Width1Bit*Height;k++) {
				(*bm)=1;
				bm++;
			}
		}
	}
}

void CImage::CopyAt(unsigned short x0, unsigned short y0, CImage *source)
{
	if (bitperpixel==1) { //I did beforehand guarantee bitalignement!
		x0=x0>>5;
		for (unsigned short y=y0;y<y0+source->Height;y++) {
			unsigned short yOffs=y*Width1Bit;
			for (unsigned short x=x0;x<(x0+(source->Width>>5));x++)			
				bitmap32bit[x+yOffs] = source->bitmap32bit[x-x0+yOffs];
		}
	} else if (bitperpixel==8) {
		for (unsigned short y=y0;y<y0+source->Height;y++)
			for (unsigned short x=x0;x<x0+source->Width;x++)			
				SetPixel8Bit(x,y, source->GetPixel8Bit(x-x0,y-y0));
	} else {
		for (unsigned short y=y0;y<y0+source->Height;y++)
			for (unsigned short x=x0;x<x0+source->Width;x++)			
				SetPixel16Bit(x,y, source->GetPixel16Bit(x-x0,y-y0));
	}
}
