#if !defined(AFX_IMAGE_H__6008D52B_DCCF_441F_8098_967AE04B059C__INCLUDED_)
#define AFX_IMAGE_H__6008D52B_DCCF_441F_8098_967AE04B059C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Image.h : header file
//

#include <afxtempl.h>
#include "histogram.h"

void DeleteFloodFillStack(int bitperpixel);
void CreateFloodFillStack(int bitperpixel);

/////////////////////////////////////////////////////////////////////////////
// CImage window

class CImage : public CObject
{
// Construction
public:
	CImage(unsigned long aWidth,unsigned long aHeight,bool init=true,unsigned char abitperpixel=16);
	CImage();
	CImage(CImage* Org);
// Attributes
public:   
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CImage)
	//}}AFX_VIRTUAL

// Implementation
public:
	void CopyAt(unsigned short x0, unsigned short y0, CImage *source);
	void ClearWhite();
	CRect m_selection;
	void FlipVertical();
	void OptimizeContrastAndConvertTo8BitPerPixel(unsigned long ppm, unsigned short &OptimizeContrastMin,unsigned short &OptimizeContrastMax);
	void OptimizeContrast(unsigned long ppm, unsigned short &OptimizeContrastMin,unsigned short &OptimizeContrastMax, CRect selection);
	void KeepOutside(unsigned long PixelNr);
	bool SetPixel(unsigned short x, unsigned short y, unsigned short value);
	bool GetPixel(unsigned short x, unsigned short y, unsigned short &value);
	void Clear();
	void ShiftPixelBits(int nr);
	bool IsFrontierPoint8Bit(unsigned short hx,unsigned short hy);
	bool IsFrontierPoint16Bit(unsigned short hx,unsigned short hy);	
	void GetFrontier(CPoint StartPos,CPoint &Left,CPoint &Right,unsigned short Range,CArray<POINT,POINT> *Frontier,unsigned long &count);
	void GetFrontier16Bit(CPoint StartPos,CPoint &Left,CPoint &Right,unsigned short Range,CArray<POINT,POINT> *Frontier,unsigned long &count);
	void GetFrontier8Bit(CPoint StartPos,CPoint &Left,CPoint &Right,unsigned short Range,CArray<POINT,POINT> *Frontier,unsigned long &count);
	unsigned char EffectiveBitPerPixel;
	unsigned char *bitmap8bit;	
	void DrawLineTillBorder(CPoint pos, CPoint dir, CPoint &left, CPoint &middle, CPoint &right);
	void DrawLineTillBorder8Bit(CPoint pos, CPoint dir, CPoint &left, CPoint &middle, CPoint &right);
	void DrawLineTillBorder16Bit(CPoint pos, CPoint dir, CPoint &left, CPoint &middle, CPoint &right);
	void FillBorder(unsigned short Bordersize);	
	void CopyOrAt(unsigned short x0, unsigned short y0,CImage* source);
	void Copy(CImage* org);
	void CopyRegion(unsigned short x0, unsigned short y0, unsigned short x1, unsigned short y1, CImage* source);
	unsigned short Width1Bit;
	unsigned short GetPixel16Bit(unsigned long x,unsigned long y) {return bitmap[x+Width*y];}		
	void SetPixel16Bit(unsigned long x,unsigned long y, unsigned short color) {bitmap[x+Width*y]=color;}		
	unsigned char GetPixel8Bit(unsigned long x,unsigned long y) {return bitmap8bit[x+Width*y];}		
	void SetPixel8Bit(unsigned long x,unsigned long y, unsigned char color) {bitmap8bit[x+Width*y]=color;}		
	bool GetPixel1Bit(unsigned short x, unsigned short y) {return (bitmap32bit[(x >> 5)+y*Width1Bit] & (1 << (x & 0x1f)))>0 ;};
	void SetPixel1Bit(unsigned short x, unsigned short y,bool color) {if (color) bitmap32bit[(x >> 5)+y*Width1Bit]|=(1 << (x & 0x1f)); else bitmap32bit[(x >> 5)+y*Width1Bit]&=(0xFFFFFFFF) ^ (1 << (x & 0x1f));};
	void SetPixel1BitWhite(unsigned short x, unsigned short y) {bitmap32bit[(x >> 5)+y*Width1Bit]|=(1 << (x & 0x1f));};
	void SetPixel1BitBlack(unsigned short x, unsigned short y) {bitmap32bit[(x >> 5)+y*Width1Bit]&=(0xFFFFFFFF) ^ (1 << (x & 0x1f));};
	unsigned long* bitmap32bit;
	void ConvertTo1BitPerPixel();
	void ConvertTo8BitPerPixel();
	void ConvertTo16BitPerPixel();	
	void FloodFillWithBlack1Bit(unsigned short x, unsigned short y, unsigned long &count);
	unsigned char bitperpixel;	
	void EraseSmallerThan(unsigned long MaxCount);
	void TestColor(unsigned short testcolor);
	void ExchangeColor(unsigned short testcolor, unsigned short truecolor, unsigned short falsecolor);
	void FloodFillOutside();
	void Invert();
	void FillGaps(unsigned short GapSize);
	void CropBorders(unsigned short Bordersize,unsigned short Color);	
	void Fill(unsigned short Color);
	double CalcMedian();
	void CopyMedian(unsigned short NeighborhoodSize, unsigned short Median, CImage *source);
	void AddImage(CImage* Source);
	void Filter(unsigned short FilterSize, long Filter[],unsigned short Norm,CImage* dest);
	void InvertFloodFill8Bit(unsigned long x, unsigned long y, unsigned short fillcolor, unsigned short surfacecolor,unsigned long &count);
	void InvertFloodFill16Bit(unsigned long x, unsigned long y, unsigned short fillcolor, unsigned short surfacecolor,unsigned long &count);
	void InvertFloodFill(unsigned long x, unsigned long y, unsigned short fillcolor, unsigned short surfacecolor,unsigned long &count);
	void FloodFill8Bit(unsigned long x, unsigned long y, unsigned short color, unsigned long &count);
	void FloodFill16Bit(unsigned long x, unsigned long y, unsigned short color, unsigned long &count);
	void FloodFill(unsigned long x, unsigned long y, unsigned short color, unsigned long &count);	
	void CopyFloodFill(unsigned long x, unsigned long y, unsigned short color,unsigned long &count,CImage* dest);
	void CountBlackAndWhitePixel(unsigned long x1, unsigned long y1, unsigned long x2, unsigned long y2,unsigned long &NrBlack, unsigned long &NrWhite);
	void FillRegion(unsigned long x1, unsigned long y1, unsigned long x2, unsigned long y2,unsigned short color);
	void GetHistogram(CHistogram* Histogram);
	bool LoadFromBMP(const char* name,int LoadingMode,bool blackwhite);
	void SaveAsBMP(const char* name, CRect Selection);
	void NewBitmap(unsigned long aWidth, unsigned long aHeight,bool init);
	void SaveAsTGA(const char * name);
	bool LoadFromTGA(const char *name);
	void GetWinBitmap(CBitmap*& aBitmap,unsigned long red,unsigned long green,unsigned long blue);
	unsigned long Height;
	unsigned long Width;
	unsigned short *bitmap;
	virtual ~CImage();	
	// Generated message map functions
protected:
	//{{AFX_MSG(CImage)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

private:	
	CBitmap* WinBitmap;
};

class TGAFile {
  public:
	TGAFile();
	WriteTGAFile(const char* name,unsigned long width,unsigned long height,unsigned short *bitmap);
	bool ReadTGAFile(const char* name,unsigned long &width,unsigned long &height,unsigned short *&bitmap);
	~TGAFile();
};

//*** WriteBMPFile ***//
class WriteBMPFile {
  int modwidth,pos,maxpos;
  unsigned char *zeile;
  FILE *stream;
  int open;
public:
  WriteBMPFile(const char* name,long int width, long int height,long int colors,COLORREF* palette, bool blackwhite=false);
  ~WriteBMPFile();
  void Pixel(unsigned char col);
  void WriteLine();
  void NewLine();
  void ZeileAuffuellen();
  int Open() {return open;};
};

//*** ReadBMPFile ***//
class ReadBMPFile {
  FILE* bild;
  int hoehe,breite,modweite,position;
  long int pixelwidth;
  unsigned char *zeile;
  unsigned char *puffer;
  long int colors;
  int offen,ok;
public:
  ReadBMPFile(const char *filename,COLORREF* palette,bool blackwhite=false);
  ~ReadBMPFile(void);
  int eof(void);
  void HoleZeile(void);
  unsigned char getPixel(int pos) {return zeile[pos];}
  int getBreite() {return pixelwidth;}
  int getHoehe() {return hoehe;}
  long int getColors() {return colors;}
  int Ok() {return ok;};
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_IMAGE_H__6008D52B_DCCF_441F_8098_967AE04B059C__INCLUDED_)
