// Microscope.cpp : implementation file
//

#include "stdafx.h"
#include "Neuron.h"
#include "Microscope.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMicroscope

i16 iMicroscopeDevice = 1;
i16 iMicroscopePort = 0;
i16 iMicroscopeLightLine = 0;
i16 iMicroscopeShutterLine = 1;

CMicroscope::CMicroscope()
{
	HardwareAccess=false;	
   	LightOn=false;
	bShutterOn = true;
}

void CMicroscope::InitialUpdate(bool aHardwareAccess)
{
	HardwareAccess=aHardwareAccess;
	if (HardwareAccess) {
		i16 iStatus = 0;
		i16 iRetVal = 0;  
		i16 iDir = 1;
		i16 iStateON = 1;
		i16 iStateOFF = 0;
		i16 iIgnoreWarning = 0; 
		iStatus = DIG_Line_Config(iMicroscopeDevice, iMicroscopePort, iMicroscopeLightLine, iDir);
		iRetVal = NIDAQErrorHandler(iStatus, "CMicroscope::InitialUpdate DIG_Line_Config", iIgnoreWarning);
		iStatus = DIG_Line_Config(iMicroscopeDevice, iMicroscopePort, iMicroscopeShutterLine, iDir);
		iRetVal = NIDAQErrorHandler(iStatus, "CMicroscope::InitialUpdate DIG_Line_Config", iIgnoreWarning);
	}
	SwitchLight(LightOn);
}

CMicroscope::~CMicroscope()
{
	SwitchLight(false);
}

/////////////////////////////////////////////////////////////////////////////
// CMicroscope message handlers

void CMicroscope::SwitchLight(bool onoff)
{
	i16 iStatus = 0;
    i16 iRetVal = 0;  
    i16 iIgnoreWarning = 0;  

	if (HardwareAccess && onoff != LightOn) {
		if (onoff)
		{
			iStatus = DIG_Out_Line(iMicroscopeDevice, iMicroscopePort, iMicroscopeLightLine, 1);
			iRetVal = NIDAQErrorHandler(iStatus, "CMicroscope::SwitchLight DIG_Out_Line", iIgnoreWarning);
			//wait half second for light to warm up
			Delay(500);
		}
		else
		{
			iStatus = DIG_Out_Line(iMicroscopeDevice, iMicroscopePort, iMicroscopeLightLine, 0);
			iRetVal = NIDAQErrorHandler(iStatus, "CMicroscope::SwitchLight DIG_Out_Line", iIgnoreWarning);
		}
	LightOn=onoff;
	}
}

bool CMicroscope::IsLightOn()
{
  return LightOn;
}



void CMicroscope::ToggleLight()
{
	SwitchLight(!LightOn);
}



void CMicroscope::ShutterOn(bool on)
{
	i16 iStatus = 0;
	i16 iRetVal = 0;
	i16 iIgnoreWarning = 0;
	bShutterOn = on;
	if (HardwareAccess) {
		iStatus = DIG_Out_Line(iMicroscopeDevice, iMicroscopePort, iMicroscopeShutterLine, (on) ? 1 : 0);
		iRetVal = NIDAQErrorHandler(iStatus, "CMicroscope::SwitchLight DIG_Out_Line", iIgnoreWarning);
	}

}