// Preview.cpp : implementation file
//

#include "stdafx.h"
#include "Neuron.h"
#include "Preview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPreview

IMPLEMENT_DYNCREATE(CPreview, CScrollView)

CPreview::CPreview()
{
}

CPreview::~CPreview()
{
}


BEGIN_MESSAGE_MAP(CPreview, CScrollView)
	//{{AFX_MSG_MAP(CPreview)
		ON_WM_ERASEBKGND()
	ON_WM_MOUSEMOVE()
	ON_WM_CANCELMODE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPreview drawing

void CPreview::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

void CPreview::OnDraw(CDC* pDC)
{	
	CDataPointDoc* pDoc = (CDataPointDoc*)GetDocument();
	ASSERT_VALID(pDoc);
	CRect rectClip;	
	pDC->GetClipBox(&rectClip);
	rectClip.InflateRect(2,2);
	if ((pDoc->CellImage) || (pDoc->Preview)) {				
		if (pDoc->Preview==NULL) {
			pDoc->CalcPreview(((CNeuronApp*)AfxGetApp( ))->PreviewBinning);
		}
		if (pDoc->Preview!=NULL) {
			CDC dcMem;
			CBitmap* pbmOld = NULL;
			ASSERT(dcMem.CreateCompatibleDC(&*pDC));
			CBitmap* help=pDoc->CalcPreviewWinBitmap();
			pbmOld = dcMem.SelectObject(&*help);		
			pDC->StretchBlt(rectClip.left, rectClip.top, rectClip.Width(),rectClip.Height(), &dcMem, rectClip.left, rectClip.top, rectClip.Width(),rectClip.Height(),SRCCOPY);			
			dcMem.SelectObject(pbmOld);
			dcMem.DeleteDC();
			delete help;
		}
	} else {
		CBrush br( RGB(255,255,255));
		pDC->FillRect( rectClip, &br );
	}	
}

BOOL CPreview::OnEraseBkgnd( CDC* pDC )
{
    CBrush br( RGB(0,0,0));   //GetSysColor( COLOR_WINDOW ) ); 
    FillOutsideRect( pDC, &br );
    return TRUE;                   // Erased
}

/////////////////////////////////////////////////////////////////////////////
// CPreview diagnostics

#ifdef _DEBUG
void CPreview::AssertValid() const
{
	CScrollView::AssertValid();
}

void CPreview::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPreview message handlers

void CPreview::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	CDataPointDoc* pDoc = (CDataPointDoc*)GetDocument();
	ASSERT_VALID(pDoc);
	if (pDoc->Preview!=NULL) {
		SetScrollSizes( MM_TEXT, CSize(pDoc->Preview->Width,pDoc->Preview->Height) );
		ResizeParentToFit( );  	
	}
	CScrollView::OnUpdate(pSender,lHint,pHint);
}

void CPreview::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CScrollView::OnMouseMove(nFlags, point);
}

void CPreview::OnCancelMode() 
{
	CScrollView::OnCancelMode();
	
	// TODO: Add your message handler code here
	
}
