#if !defined(__fitmath_h)
#define __fitmath_h

void SetFitFunc1D(double (*func)(double, double []));

void GeneralFitFunc1D(double x, double a[], double *y, double dyda[], int na);

bool fit(double x[],	//x and y datapoints from 0 to ndata-1
		 double y[], 
		 int ndata,		//number of datapoints
		 double a[],	//coefficients 0 to ma-1
		 double v[],	//integer coefficients? from 0 to ma-1
  		 int ma,		//number of arguments
		 double *chisq, //chisqu
		 int maxn,		//maximum number of fitting rounds
		 int minn,		//number of fitting rounds after last that changed something in coefficients		 
		 double minchisq,	//stop if chisqu<minchisqu		 
		 int &nend,			//return value: number of fitting rounds
		 double &changeend,	//return value: value of change during last round
		 void (*funcs)(  //fitting function
			double,			//point at which to evaluate
			double [],		//coefficients
			double *,		//return value
			double [],		//return derivatives
			int)			//number of coefficients
	);

#endif