// RunForm.cpp : implementation file
//

#include "stdafx.h"
#include "Neuron.h"
#include "RunForm.h"
#include <windows.h>
#include "CommentDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRunForm

IMPLEMENT_DYNCREATE(CRunForm, CFormView)

CRunForm::CRunForm()
	: CFormView(CRunForm::IDD)
{
	//{{AFX_DATA_INIT(CRunForm)
	m_AutoLoad = FALSE;
	m_slider_value = 0;
	m_TimeStamp = _T("");
	m_datapoint_edit = 0;
	//}}AFX_DATA_INIT
	LastNumber=-1;
	AutoScroll=0;
	AutoScrollTickCount=GetTickCount();
}

CRunForm::~CRunForm()
{
}

void CRunForm::DoDataExchange(CDataExchange* pDX)
{
	//CString	m_TimeStamp;
	CFormView::DoDataExchange(pDX);
	/*
	if ((pDX->m_bSaveAndValidate==0) && (LastNumber!=m_DataPointNumber)) {
		CRunDoc* pDoc = (CRunDoc*)GetDocument();
		ASSERT_VALID(pDoc);
		long help=m_DataPointNumber;
		pDoc->GetNextWithImage(help,LastNumber>m_DataPointNumber);
		m_DataPointNumber=help;
		m_DATAPOINT_SCROLLBAR=m_DataPointNumber;
		CDataPointDoc* Doc=pDoc->GetDataPoint(m_slider_value);		
		if (Doc) {
			m_TimeStamp=Doc->RelativeTime.Format("%H:%M:%S");
			pDoc->SearchPreview(Doc);
		}
		LastNumber=m_DataPointNumber;
	}
	*/
	//{{AFX_DATA_MAP(CRunForm)
	DDX_Control(pDX, IDC_SLIDER_DATAPOINT, m_datapoint_slider);
	DDX_Check(pDX, IDC_AUTO_LOAD, m_AutoLoad);
	DDX_Slider(pDX, IDC_SLIDER_DATAPOINT, m_slider_value);
	DDX_Text(pDX, IDC_TIMESTAMP, m_TimeStamp);
	DDX_Text(pDX, IDC_DATAPOINT_NUMBER, m_datapoint_edit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRunForm, CFormView)
	//{{AFX_MSG_MAP(CRunForm)
	ON_EN_CHANGE(IDC_DATAPOINT_NUMBER, OnDataPointNumberEdit)
	ON_BN_CLICKED(IDC_LOAD_DATAPOINT, OnLoadDatapoint)
	ON_BN_CLICKED(IDC_LOAD_DATAPOINT_IN_NEW_VIEW, OnLoadDatapointInNewView)
	ON_BN_CLICKED(ID_ADD_COMMENT, OnAddComment)
	ON_BN_CLICKED(IDC_DATAPOINT_UP, OnDatapointUp)
	ON_BN_CLICKED(IDC_DATAPOINT_DOWN, OnDatapointDown)
	ON_COMMAND(ID_SAVE_AS_BMP, OnSaveAsBmp)
	ON_UPDATE_COMMAND_UI(ID_SAVE_AS_BMP, OnUpdateSaveAsBmp)
	ON_BN_CLICKED(IDC_DATAPOINT_UP2, OnDatapointUp2)
	ON_BN_CLICKED(IDC_DATAPOINT_DOWN2, OnDatapointDown2)
	ON_BN_DOUBLECLICKED(IDC_DATAPOINT_UP, OnDoubleclickedDatapointUp)
	ON_BN_DOUBLECLICKED(IDC_DATAPOINT_DOWN, OnDoubleclickedDatapointDown)
	ON_BN_CLICKED(IDC_DATAPOINT_DOWN_AUTO, OnDatapointDownAuto)
	ON_BN_CLICKED(IDC_DATAPOINT_UP_AUTO, OnDatapointUpAuto)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER_DATAPOINT, OnReleasedcaptureSliderDatapoint)
	ON_BN_CLICKED(IDC_BUTTON1, OnAutoUpTen)
	ON_BN_CLICKED(IDC_BUTTON2, OnAutoDownTen)
	ON_BN_CLICKED(IDC_AUTO_LOAD, OnAutoLoad)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRunForm diagnostics

#ifdef _DEBUG
//DEL void CRunForm::AssertValid() const
//DEL {
//DEL 	CFormView::AssertValid();
//DEL }

void CRunForm::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRunForm message handlers


void CRunForm::OnDataPointNumberEdit() 
{
	/*
	UpdateData(true);
	if ((m_datapoint_edit>0) && (m_datapoint_edit<=MaxDataPoint())) {
		m_slider_value = m_datapoint_edit;
		UpdateData(false);
		LoadDatapoint(0);
	}
	*/
}

void CRunForm::OnLoadDatapoint() 
{
	
	CRunDoc* pDoc = (CRunDoc*)GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->LoadDatapoint(m_slider_value);
}

void CRunForm::OnLoadDatapointInNewView() 
{
	CRunDoc* pDoc = (CRunDoc*)GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->LoadDatapointInNewView(m_slider_value);
}

void CRunForm::OnAddComment() 
{	
	CRunDoc* pDoc = (CRunDoc*)GetDocument();
	ASSERT_VALID(pDoc);	
	UpdateData(true);
	CDataPointDoc* Doc=pDoc->GetDataPoint(m_slider_value);
	if (Doc) Doc->ChangeComment();
}

WORD CRunForm::MaxDataPoint() {
	CRunDoc* pDoc = (CRunDoc*)GetDocument();
	ASSERT_VALID(pDoc);
	return pDoc->LastPictureNumber;
}

void CRunForm::ChangeMaxDataPoint()
{	
	m_datapoint_slider.SetRange(1,MaxDataPoint());
	m_datapoint_slider.SetPos(m_slider_value);
	UpdateData(false);
}

//DEL void CRunForm::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
//DEL {
//DEL 	/*UpdateData(true);
//DEL 	if ((m_DATAPOINT_SCROLLBAR>0) && (m_DATAPOINT_SCROLLBAR<=MaxDataPoint())) {
//DEL 		m_DataPointNumber=m_DATAPOINT_SCROLLBAR;
//DEL 		UpdateData(false);	
//DEL 	}*/
//DEL /*	CScrollBar* scroll=(CScrollBar*)GetDlgItem(IDC_DATAPOINT_NR_SCROLLBAR);
//DEL 	if (scroll!=NULL) {	
//DEL 		scroll->SetScrollPos( nPos);
//DEL 	}*/
//DEL 	//pScrollBar->SendChildNotifyLastMsg();
//DEL 	CFormView::OnHScroll(nSBCode, nPos, pScrollBar);
//DEL }

//DEL void CRunForm::OnCancelMode() 
//DEL {
//DEL 	CFormView::OnCancelMode();
//DEL 	
//DEL 	// TODO: Add your message handler code here
//DEL 	
//DEL }

void CRunForm::OnDatapointUp() 
{
	LoadDatapoint(1);
	AutoScroll=0;
}

//DEL void CRunForm::DatapointUp() 
//DEL {
//DEL 	AutoScroll=0;
//DEL }	

void CRunForm::OnDatapointDown() 
{
	LoadDatapoint(-1);
	AutoScroll=0;
}

//DEL void CRunForm::DatapointDown() 
//DEL {
//DEL 	CRunDoc* pDoc = (CRunDoc*)GetDocument();
//DEL 	ASSERT_VALID(pDoc);
//DEL 	m_slider_value = pDoc->FindNextImage(m_slider_value, -1);
//DEL 
//DEL 	UpdateData(false);
//DEL 	LoadDatapoint();
//DEL 	AutoScroll=0;
//DEL }


//DEL void CRunForm::OnLoadDatapointUp() 
//DEL {
//DEL 	// TODO: Add your command handler code here
//DEL 	LoadDatapointUp();
//DEL 	AutoScroll=0;
//DEL }

//DEL void CRunForm::LoadDatapointUp()
//DEL {
//DEL 	/*
//DEL 	if (m_DataPointNumber<MaxDataPoint()) {
//DEL 		m_DataPointNumber++;
//DEL 		m_DATAPOINT_SCROLLBAR=m_DataPointNumber;
//DEL 		UpdateData(false);
//DEL 		if (m_AutoLoad) OnLoadDatapoint();
//DEL 	} else AutoScroll=0;
//DEL 
//DEL 	CRunDoc* pDoc = (CRunDoc*)GetDocument();
//DEL 	ASSERT_VALID(pDoc);
//DEL 	UpdateData(true);
//DEL 	pDoc->LoadDatapoint(m_DATAPOINT_SCROLLBAR);	
//DEL 	*/
//DEL }

//DEL void CRunForm::OnLoadDatapointDown() 
//DEL {
//DEL 		// TODO: Add your command handler code here
//DEL 	LoadDatapointDown();
//DEL 	AutoScroll=0;
//DEL }

//DEL void CRunForm::LoadDatapointDown()
//DEL {
//DEL 	/*
//DEL 	if (m_DataPointNumber>MaxDataPoint()) {
//DEL 		m_DataPointNumber--;
//DEL 		m_DATAPOINT_SCROLLBAR=m_DataPointNumber;
//DEL 		UpdateData(false);
//DEL 		if (m_AutoLoad) OnLoadDatapoint();
//DEL 	} else AutoScroll=0;
//DEL 
//DEL 	CRunDoc* pDoc = (CRunDoc*)GetDocument();
//DEL 	ASSERT_VALID(pDoc);
//DEL 	UpdateData(true);
//DEL 	pDoc->LoadDatapoint(m_DATAPOINT_SCROLLBAR);	
//DEL 	*/
//DEL }

void CRunForm::OnDoubleclickedDatapointUp() 
{
	AutoScroll=1;
	AutoScrollTickCount=GetTickCount();
}

void CRunForm::OnDoubleclickedDatapointDown() 
{
	AutoScroll=2;	
	AutoScrollTickCount=GetTickCount();
}

void CRunForm::OnIdle()
{	
	if (AutoScroll==0)
		return;	
	int oldNumber = m_slider_value;
	if (GetTickCount()<(AutoScrollTickCount+((CNeuronApp*)AfxGetApp())->PreviewPlaybackSpeed)) 
		return;	
	if (AutoScroll==1) 
		LoadDatapoint(1);
	else if (AutoScroll==2) 
		LoadDatapoint(-1);
	else if (AutoScroll==3)
		LoadDatapoint(10);
	else if (AutoScroll==4)
		LoadDatapoint(-10);

	if (oldNumber == m_slider_value)
		AutoScroll = 0;
	AutoScrollTickCount=GetTickCount();
}

void CRunForm::OnDatapointDownAuto() 
{
	AutoScroll=2;	
	AutoScrollTickCount=GetTickCount();	
}

void CRunForm::OnDatapointUpAuto() 
{
	AutoScroll=1;
	AutoScrollTickCount=GetTickCount();
}

void CRunForm::OnDatapointUp2() 
{
	LoadDatapoint(10);
}

void CRunForm::OnDatapointDown2() 
{
	LoadDatapoint(-10);
}

void CRunForm::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	//GetParentFrame()->ModifyStyleEx(NULL,WS_EX_TOPMOST, SWP_NOSIZE|SWP_NOMOVE);
	SetScrollSizes( MM_TEXT, CSize(600, 100) );
	ResizeParentToFit( );  
	ChangeMaxDataPoint();
	CRunDoc* pDoc = (CRunDoc*)GetDocument();
	ASSERT_VALID(pDoc);	
	pDoc->SetTitle();	
	m_datapoint_slider.SetRange(1,MaxDataPoint());
	m_slider_value = 0;
	//m_slider_value = pDoc->FindNextImage(m_slider_value, 1);
	LoadDatapoint(1);
	pDoc->LoadDatapoint(m_slider_value);
	//GetParentFrame()->SetWindowPos(&wndTopMost, 0,0,0,0, SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);
}

void CRunForm::CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType) 
{
	CFormView::CalcWindowRect(lpClientRect, nAdjustType);
}

void CRunForm::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	//SetScrollSizes( MM_TEXT, CSize(515, 100) );
	//ResizeParentToFit( );
	//UpdateData(false);
	//GetParentFrame()->SetWindowPos(&wndTopMost, 0,0,0,0, SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);
	/*
	if (lHint == 1)
	{
		CRunDoc* pDoc = (CRunDoc*)GetDocument();
		ASSERT_VALID(pDoc);
		m_slider_value = pDoc->LastLoadedDataPoint;
		LoadDatapoint();
	}
	*/
}

BOOL CRunForm::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	//dwStyle |= WS_EX_TOPMOST;
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}


void CRunForm::OnSaveAsBmp() 
{	
	CRunDoc* pDoc = (CRunDoc*)GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->SaveAsBMP(0);
}

void CRunForm::OnUpdateSaveAsBmp(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(true);	
}

/*void CRunForm::OnUpdateLoadDatapointUp(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(true);	

}

void CRunForm::OnUpdateLoadDatapointDown(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(true);	

}

*/
void CRunForm::OnAutoLoad() 
{	
	UpdateData(true);
}

void CRunForm::OnReleasedcaptureSliderDatapoint(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData(true);
	LoadDatapoint(0);

	*pResult = 0;
}

void CRunForm::LoadDatapoint(int increment)
{
	CRunDoc* pDoc = (CRunDoc*)GetDocument();
	ASSERT_VALID(pDoc);
	if (increment)
		m_slider_value = pDoc->FindNextImage(m_slider_value, increment);
	CDataPointDoc* Doc=pDoc->GetDataPoint(m_slider_value);		
	if (Doc) {
		m_TimeStamp=Doc->RelativeTime.Format("%H:%M:%S");
		if (m_AutoLoad)
			pDoc->LoadDatapoint(m_slider_value);
		else
			pDoc->SearchPreview(Doc);
		m_datapoint_edit = m_slider_value;
	}
	UpdateData(false);
}

void CRunForm::OnAutoUpTen() 
{
	AutoScroll=3;
	AutoScrollTickCount=GetTickCount();	
}


void CRunForm::OnAutoDownTen() 
{
	AutoScroll=4;
	AutoScrollTickCount=GetTickCount();	
}
